unit ShapeTable;

{$mode delphi}

interface

uses
  Classes, SysUtils, db, dbf, FileUtil, Forms, Controls, Graphics, Dialogs,
  DBGrids, ExtCtrls, StdCtrls, Menus, StrUtils;

type

  { TfrmShapeTable }

  TfrmShapeTable = class(TForm)
    btnSelectShapesWhere: TButton;
    btnClose: TButton;
    cbxFields: TComboBox;
    cbxFields1: TComboBox;
    cbxOperators: TComboBox;
    cbxAndOr: TComboBox;
    cbxOperators1: TComboBox;
    DataSource1: TDataSource;
    Dbf1: TDbf;
    DBGridShapes: TDBGrid;
    edValue: TEdit;
    edValue1: TEdit;
    Label1: TLabel;
    Panel1: TPanel;
    Panel2: TPanel;
    procedure btnCloseClick(Sender: TObject);
    procedure btnSelectShapesWhereClick(Sender: TObject);
    procedure DBGridShapesCellClick(Column: TColumn);
    procedure DBGridShapesDblClick(Sender: TObject);
    procedure Panel2Click(Sender: TObject);
  private
    { private declarations }
//    FSelectedShapes: TStringList;
    FClickedShape : integer;

//    procedure SetSelectedShapes(AValue: TStringList);
  public
    { public declarations }
    procedure DisplayTable(TableName : string);

//    property SelectedShapes : TStringList read FSelectedShapes write SetSelectedShapes;
  end;

var
  frmShapeTable: TfrmShapeTable;

implementation

{$R *.lfm}

uses FLBModelmain;

{ TfrmShapeTable }

procedure TfrmShapeTable.btnCloseClick(Sender: TObject);
begin
  Dbf1.Active := false;
  Close;
end;

procedure TfrmShapeTable.btnSelectShapesWhereClick(Sender: TObject);
var
  filter : string;
begin
  filter := cbxFields.Text + ' ' + cbxOperators.Text + ' ' +
    edValue.Text;
  if cbxFields1.Text <> '' then
    filter := filter + ' ' + cbxAndOr.Text + ' ' +
    cbxFields.Text + ' ' + cbxOperators1.Text + ' ' +
    edValue1.Text;
  Dbf1.Filter := filter;

  Dbf1.Filtered := true;
end;

procedure TfrmShapeTable.DBGridShapesCellClick(Column: TColumn);
var
  i, n : integer;
  ds : TDataSet;
begin
  frmFLBModel.frmMap.ClearSelectedShapesList;
//  frmFLBModel.frmMap.SelectedShapes.Clear;

  ds := DBGridShapes.DataSource.DataSet;

  if DBGridShapes.SelectedRows.Count > 0 then
  begin
    with ds do
    begin
      i := 0;
      while i < DBGridShapes.SelectedRows.Count do
      begin
        GotoBookmark(Pointer(DBGridShapes.SelectedRows.Items[i]));
        n := ds.RecNo - 1;
        frmFLBModel.frmMap.AddToSelectedShapesList(n, 0);

        Inc(i);
      end;
    end;
  end;

  frmFLBModel.frmMap.BGRAVirtualScreen1.RedrawBitmap;
end;

procedure TfrmShapeTable.DBGridShapesDblClick(Sender: TObject);
var
  n : integer;
  ds : TDataSet;
begin
  ds := DBGridShapes.DataSource.DataSet;

  if DBGridShapes.SelectedRows.Count > 0 then
  begin
    with ds do
    begin
      GotoBookmark(Pointer(DBGridShapes.SelectedRows.Items[0]));
      n := ds.RecNo - 1;
      frmFLBModel.frmMap.PanToShape(ChangeFileExt(Dbf1.TableName, '.shp'), n);
    end;
  end;
end;

procedure TfrmShapeTable.Panel2Click(Sender: TObject);
begin

end;

{procedure TfrmShapeTable.SetSelectedShapes(AValue: TStringList);
begin
  if FSelectedShapes=AValue then Exit;
  FSelectedShapes:=AValue;
end;}

procedure TfrmShapeTable.DisplayTable(TableName: string);
var
  i : integer;
begin
  Dbf1.TableName := TableName;
  Dbf1.Active := true;

  cbxFields.Clear;
  cbxFields1.Clear;

  i := 0;
  while i < Dbf1.FieldDefs.Count do
  begin
    cbxFields.AddItem(Dbf1.FieldDefs[i].Name, nil);
    cbxFields1.AddItem(Dbf1.FieldDefs[i].Name, nil);

    Inc(i);
  end;

  cbxFields.ItemIndex := 0;
  cbxFields1.Items.Insert(0, '');

  Show;
end;

end.

