unit ShapeObj;

{$MODE Delphi}

{
OBS!!! Cartesiskt koordinatsystem
2021-11-22 Lagt till parametern pointsAlso : boolean vid uppritning
           av shape
2021-11-16 Upptäckt proceduren Intersect som returnerar skärnings-
           punkten mellan 2 räta linjer
           Med returparametern res enligt nedan
           // parallella linesegment:
                res := 0
           // identiska linesegment:
                res := 1
           // identiska linesegment i motsatta riktningar:
                res := -1
           // korsande linesegment med skärningspunkt inuti segment 1:
                res := 2
           // korsande linesegment med skärningspunkt inuti segment 2:
                res := 3
           // korsande linesegment med skärningspunkt inuti båda segmenten:
                res := 4
           // korsande linesegment med skärningspunkt utanför segmenten:
                res := 5
           // division med noll, FEL:
               res := 5-9999;
2021-10-30 Lagt till metoden CopyShapeFileShape som kopierar en shape
           från en shapefil till en annan
2021-10-30 Lagt till metoden CopyShapeFileShapes som kopierar ett antal shapes
           från en shapefil till en annan
2021-10-28 Lagt till function ConvertPolylinePolygon för omvandling från
           polyline till polygon och vice versa
2021-10-26 Lagt till att projektionsfil skapas och raderas i CreateShapefile
           resp. DeleteShapefile
2021-04-15 Ändrat HitTest så att test görs i omvänd ordning för polygoner
           vilket innebär att hänsyn tas till z-ordning, dvs. polygon
           ritad ovanpå annan polygon räknas som träffad
2020-04-14 Har lagt till function GetPolylineShapeClosestToPoint som
           bl.a används HitTest av polylines
2020-04-06 Har lagt till property OffsetX, OffsetY, att användas vid
           uppritning av en shape
2020-03-30 Lagt till metoden SimplifyPolyShape som reducerar antalet
           punkter i en shape av typ polyline eller polygon med
           DouglasPeuckers algoritm
2020-01-08 Lagt till skalning av shapefil
2018-11-13 Har lagt till utskrift av area och omkrets vid export i
           entity-format
2018-11-10 Ändrat metod CopyShapeFile med ytterligare en
           parameter: Prompt : boolean med defaultvärde = true,
           som ger en fråga om ev. gammal kopia ska raderas
2018-10-30 Lagt till parametrarna exporteraAlltData, xmin, ymin, xmax, ymax till
           procedure ExportAsXYZMTextFile för att möjliggöra utskrift av
           en del av shapedatat i textform
2018-10-18 Lagt till function DetermineCentroid som beräknar
           centroiden(tyngpunkten) för en polygon
2018-10-16 Lagt till procedure UpdateMaxMinTot som fixar shapefiler
           som saknar uppgift om maxX och maxY för hela akt. shapefil
2018-02-23 Ändrat metod Compress att utnyttja metod CopyShapeFile
2018-02-23 Ändrat metod CopyShapeFile med ytterligare en
           parameter: DeletedShapesAlso : boolean med defaultvärde = false,
           DeletedShapesAlso  = false ger en komprimering av kopieshapefilen
2018-02-10 Lagt till variant av split som delar en shape med
           en annan shape till skillnad från den 1:sta varianten
           som delar en shape med ett rakt linjesegment
2018-02-07 Rättat funktion GetClosestShapePoint och utvidgat
           den för att hantera shapes med M-värden
2018-02-06 Lagt till ny procedure Split som delar en shape
           med en annan shape i två delar
2018-01-25 Gjort om ReadShape till function och lagt till
           function ChangeShapeDirection
2018-01-24 Ändrat AddField så att ett nytt fält valbart kan
           göras indexerat
2018-01-17 Rättat koordinatangivelser efter test mot QGIS genom
           THeader ändrats till packed record
2015-07-10 Rättat procedure Split
2015-07-07 Implementerat metod Compress
2015-02-10 Lagt till metod CopyShapeFile
2012-04-17 Lagt till procedure ExportAsXYZMTextFile för utskrift av shape som
           som textfil i format:
           X        Y       Z       M
           .
           .
           .
           
2012-04-17 Ändrat recnr-uppräkning i dbf-filen så att första entity
           får nr:0 istället för nr:1
2012-04-14 Lagt till function MultiSelect som returnerar en StringList med namn på
           selekterade shapefiler
2012-04-12 Lagt till functionen Exists : boolean för test av om en shapefil existerar
2011-12-21 Rättat ett fel då en ny polygon/polyline skapas(AddPolygonPolylineShape)
           så att antal shapes ökas(FNumEntities = FNumEntities + 1) 
2011-12-03 Lagt till procedure ExportAsTextFile för utskrift av shape
           med parametrarna:
           Filename - Om filename inte är angivet vid anrop visas en SaveDialog
           shapeNum - Om shapeNum = -1 exporteras alla shape:r
2011-12-02 Lagt till function CalcAreaPerimeter för beräkning av en
           polygon/polylines längd och för polygon även arean
           OBS! Hämtad från gamla ShapeObj som utvecklades på Lantmäteriet
2011-12-01 Försökt göra function Buffer(Mode : string; Width : double) för
           buffring av shape
           Mode = 'in' ger buffring inåt
           Mode = 'out' ger buffring utåt
           Mode = 'both' ger buffring både inåt och utåt
           Width anger hur stor buffring blir i akt. enhet

           Akt. shape får endast innehålla EN ENKEL polygon/polyline
           Resultatet sparas som shape nr 2(index 1) i shapefilen

           ERSATT MED ATT UTNYTTJA CLIPPER.PAS AV ANGUS JOHNSON
2011-11-01 Lagt till overloaded function Select(Mode, Title: string) med valbar titel
           för opendialog    
2011-10-25 Lagt till property Transparent som gör att polygoner visas
           som polylines
           Rättat en bug som gjort att en shape bestående av endast 1 del
           i vissa fall inte ritats ut helt och hållet(rad 1977)
           Lagt till response 'ShapeFileName inte angivet' då en shapefil
           skapas och shapefilnamnet inte är angivet
           Lagt till functionen Add(x, y : integer) för att lägga till en
           punkt till en shapefil, där x, y är koordinater för en punkt
           i en kartbild vilket m.h.a FWorldViewPortRoutines räknas om
           till worldkoordinater
           Försäkrat att 1:sta och sista punkt är lika för en sluten polygon
2011-05-09 Ändrat fältet 'RecNo' i tillhörande dbf-fil från ftInteger till ftLargeint
2011-05-06 Lagt till procedure ReadShapePart för läsning av del av polyline eller polygon
2011-05-06 Lagt till mode = 'ex' för exclusive-mode för att göra det möjligt
           att skapa och ta bort index
2008-06-06 Egenutvecklad komponent
}

{
  Null Shape       0
  Point            1
  PolyLine         3
  Polygon          5
  MultiPoint       8
  PointZ          11
  PolyLineZ       13
  PolygonZ        15
  MultiPointZ     18
  PointM          21
  PolyLineM       23
  PolygonM        25
  MultiPointM     28
  MultiPatch      31
}

interface

uses
  LCLIntf, LCLType, LMessages, SysUtils, Classes, StrUtils,
  DB, dbf, dbf_fields, dbf_idxfile, Graphics, Variants, WGS84,
  WorldViewPortRoutines, Dialogs, Math, Forms, FileUtil,
  ExtCtrls, ComCtrls, FastGEO;

const
  integer0 : integer = 0;
  CRLF : string = Chr(13) + Chr(10);
  TAB : string = Chr(9);

type
  // DouglasPeucker **************************************
  // Generalized float and int types
  TFloat = double;

  // Float point 2D
  TPointFloat2D = packed record
    X: TFloat;
    Y: TFloat;
  end;

  // Float point 3D
  TPointFloat3D = packed record
    X: TFloat;
    Y: TFloat;
    Z: TFloat;
  end;

  TInt2dPointAr = array of TPoint;
  TFloat2DPointAr = array of TPointFloat2D;
  TFloat3DPointAr = array of TPointFloat3D;
  // DouglasPeucker **************************************

  TPoints = array of TPoint;

  BytePos = (EndVal, ByteVal);

  PEndianCnvRec = ^EndianCnvRec;
  
  EndianCnvRec = packed record
    case pos: BytePos of
       //The value we are trying to convert
      EndVal: (EndianVal: double);           
       //Overlapping bytes of the double
      ByteVal: (Bytes: array[0..SizeOf(Double)-1] of byte); 
  end;

{
  ShapeType     Value
  Null Shape       0
  Point            1
  PolyLine         3
  Polygon          5
  MultiPoint       8
  PointZ          11
  PolyLineZ       13
  PolygonZ        15
  MultiPointZ     18
  PointM          21
  PolyLineM       23
  PolygonM        25
  MultiPointM     28
  MultiPatch      31
}

  doubleArray = array of double;
//  pDoubleArray = ^doubleArray;
  double2Array = array[0..1] of double;
  double4Array = array[0..3] of double;
  doubleXY =
  record
    x : double;
    y : double;
  end;
  doubleXYArray = array of doubleXY;

  integerArray = array of integer;
  pIntegerArray = ^integerArray;

  singleArray = array of single;

{  pXYArray = ^doubleXYArray;
  pZArray = ^doubleArray;
  pMArray = ^doubleArray;}

  TIndexRecord =
  record
    Offset : integer;
    ContentLength : integer;
  end;
  TIndexRecordsArray = array of TIndexRecord;
  pIndexRecordsArray = ^TIndexRecordsArray;

  TDoubleRect =
  record
    xmin, ymin, xmax, ymax : double;
  end;

  THeader =
  packed record
    FileCode    : integer;
    Unused1     : integer;
    Unused2     : integer;
    Unused3     : integer;
    Unused4     : integer;
    Unused5     : integer;
    FileLength  : integer;
    Version     : integer;
    ShapeType   : integer;
    xMin        : double;
    yMin        : double;
    xMax        : double;
    yMax        : double;
    zMin        : double;
    zMax        : double;
    mMin        : double;
    mMax        : double;
  end;

  TRecordHeader =
  record
    RecordNumber : integer;
    ContentLength : integer;
  end;

  TNullShapeRecord =
  record
    RecordHeader : TRecordHeader;
    ShapeType   : integer;
  end;

  { TShapeObj }

  TShapeObj = class(TComponent)
  private
    { Private declarations }
    FCategory: integer;
    FCurrentShapePart: integer;
    FDrawNonDeletedShapesOnly: boolean;
    FInitialDir: string;
    FOffsetX: double;
    FOffsetY: double;
    FPointsAlso: boolean;
    FProgressBar: TProgressBar;
    FRecordShapeType: integer;
    FShapeFile : TFileStream;
    FIndexFile : TFileStream;
    FDbf : TDbf;

    FShapeFileName : string;
    FMainFileHeader : THeader;
    FIndexFileHeader : THeader;
    FShapeType : integer;
    FFileCode : integer;
    FFileLength : integer;
    FSplitAdjustDistance: double;
    FStatusBar: TStatusBar;
    FVersion : integer;
    FActive: boolean;
    FNumEntities: integer;

    FSingleInstanceShapeType : integer;
    FRecordNumber : integer;
    FContentLength : integer;

    FX : double;
    FY : double;
    FZ : double;
    FM : double;
    
    FXMin : double;
    FYMin : double;
    FXMax : double;
    FYMax : double;

    FXMinTot : double;
    FYMinTot : double;
    FXMaxTot : double;
    FYMaxTot : double;

    FZMin : double;
    FZMax : double;
    FMMin : double;
    FMMax : double;

    FZMinTot : double;
    FZMaxTot : double;
    FMMinTot : double;
    FMMaxTot : double;

    FCurrentShapeNum: integer;
    FBoundingBox  : double4Array;
    FNumParts     : integer;
    FNumPoints    : integer;
    FParts        : integerArray;

    FPolyGonPolylineAdded : boolean;
    
    FIndexRecordsArray : TIndexRecordsArray;

    FRecordHeader : TRecordHeader;

    FXYArray : doubleXYArray;
    FZArray : doubleArray;
    FMArray : doubleArray;

    FPartXYArray : doubleXYArray;
    FPartZArray : doubleArray;
    FPartMArray : doubleArray;
    FPartNumPoints : integer;
    
    FMode : string;
//    FShapeFileType: integer;
    FCanvas: TCanvas;
    FWorldViewPortRoutines: TWorldViewPortRoutines;
    FPenWidth: integer;
    FPenColor: TColor;
    FBrushColor: TColor;

    FNullValue : double;
    FSelectionColor: TColor;
    FShapeFileDir: string;
    FTransparent: boolean;
    FArea: double;
    FPerimeter: double;

    FUpdateArcPolyShapeZValue : boolean;
    FZArrayStartPos : integer;

    // för konvertering från polyline till polygon och vice versa
    FConvertPolylinePolygon, FToPolygon : boolean;

    procedure CloseCurrentShapePart;
    function CopyShapeFileOld(ShapeFileName, ShapeFileCopyName: string;
      DeletedShapesAlso: boolean=false; Prompt: boolean=true): string;
    function DetermineIntersectionWithLine(const x1, y1, x2, y2: extended;
      var shapeNum : integer; var xs, ys: double): boolean;
    function DouglasPeucker(Tol: TFloat; const Orig: array of TPointFloat3D;
      var Simple: TFloat3DPointAr): integer;
    function EndianLong(L: integer): integer;
    procedure FlushShape;
    function GetClosestShapePart(shapeNum: integer; x, y, z: double): integer;
    function GetPolylineShapeClosestToPoint(x, y: double): integer; overload;
    function GetPolylineShapeClosestToPoint(x, y, z: double): integer; overload;
    function MakeDoubleRect(const x1, y1, x2, y2: double) :
      TDoubleRect;
    procedure ReadMainFileHeader;
    procedure ReadIndexFileHeader;
    procedure ReadIndexFile;
//    function EndianLong(L: integer): integer;
    function EndianDouble(D : double) : double;
    procedure DeAllocateMemory;
    procedure ReadMultiPointShape(shapeNum: integer);
    procedure ReadPointShape(shapeNum: integer);
    procedure ReadPolygonPolylineShape(shapeNum: integer);
    procedure SetCategory(AValue: integer);
    procedure SetCurrentShapePart(AValue: integer);
    procedure SetDrawNonDeletedShapesOnly(AValue: boolean);
    procedure SetInitialDir(AValue: string);
    procedure SetOffsetX(AValue: double);
    procedure SetOffsetY(AValue: double);
    procedure SetPointsAlso(AValue: boolean);
    procedure SetProgressBar(AValue: TProgressBar);
    procedure SetSplitAdjustDistance(AValue: double);
    procedure SetStatusBAr(AValue: TStatusBar);
{    function AddArcPolyShape : integer;
    function AddMultiPointShape : integer;}
    function UpdatePointShape(shapeNum: integer; x, y,z, m : double) : integer;
    function UpdateArcPolyShape(shapeNum: integer; x, y,z, m : double) : integer;
    function UpdateMultiPointShape(shapeNum: integer; x, y,z, m : double) : integer;
    procedure SetMode(const Value: string);
    procedure SetShapeType(const Value: integer);
    procedure SetCanvas(const Value: TCanvas);
    procedure SetWorldViewPortRoutines(
      const Value: TWorldViewPortRoutines);
    procedure SetBrushColor(const Value: TColor);
    procedure SetPenColor(const Value: TColor);
    procedure SetPenWidth(const Value: integer);
    function GetShapeFileDir : string;
    function GetShapeFileName : string;
    procedure SetCurrentShapeNum(const Value: integer);
    function AddPolgonPolylinePoint : integer;
    function AddPointShape: integer;
    function AddMultiPointShape: integer;
    function GetXMinTot : double;
    function GetYMinTot : double;
    function GetXMaxTot : double;
    function GetYMaxTot : double;
    function GetZMinTot : double;
    function GetZMaxTot : double;
    function GetMMinTot : double;
    function GetMMaxTot : double;
    function UpdateTotalAndCurrentMaxMinValues(x, y, z,
      m: double): integer;
    function WithInDoubleRect(x, y: double; dRect: TDoubleRect): boolean;
    function TotallyOutsideDoubleRect(x, y: double; dRect: TDoubleRect): boolean;
    procedure WriteXYZAndMArrays;
//    function PtInPoly(const Points: doubleXYArray; NumPoints : integer;
//      X, Y: double): Boolean;
    procedure SetSelectionColor(const Value: TColor);
    procedure SetTransparent(const Value: boolean);
    procedure SetArea(const Value: double);
    procedure SetPerimeter(const Value: double);
    procedure AddToLogFile(const LogMessage: string);
  protected
    { Protected declarations }
  public
    { Public declarations }
    constructor Create(AOwner: TComponent); overload; override;
    destructor Destroy; override;

    procedure AddField(FieldName : string;DataType: TFieldType; Size: Integer = 0;
      Required: Boolean = False; MakeItAnIndex: Boolean = False);
    function Add(x, y : integer) : integer; overload;
    function Add(x, y, z, m : double) : integer; overload;
    function AddIntermediatePoints(shapeNum: integer; pointDistance: double
      ): integer;
    procedure AddPolyGonPolylinePart;
    function AddPolygonPolylineShape: integer;
    function Buffer(Mode : string; Width : double) : string;
    function CalcAreaPerimeter(XYArr: doubleXYArray;
      NumPoints: integer; var Area, Perimeter : double): boolean;
    function ChangeProjection(DesiredProjection : string) : string;
    function ChangeShapeDirection(shapeNum: integer) : boolean;
    function CalcAreaPerimeterAttributes : string;
    procedure Close;
    procedure ClosePolygonPolylineShape;
    procedure Compress;
    function ConvertPolylinePolygon(ToType : string) : boolean;
    function CopyShapeFileShape(ShapeFileName, ShapeFileCopyName: string;
      ShapeNum : integer;
      DeletedShapesAlso : boolean = false; Prompt : boolean = true): string;
    function CopyShapeFileShapes(ShapeFileName, ShapeFileCopyName: string;
      ShapeNums : array of integer; NumberOfShapes : integer;
      DeletedShapesAlso : boolean = false; Prompt : boolean = true): string;
    function CopyShapeFile(ShapeFileName, ShapeFileCopyName: string;
      DeletedShapesAlso : boolean = false; Prompt : boolean = true): string;
    function CreateShapeFile(const ShapeFileName, ShapeType : string) : string; overload;
    function CreateShapeFile(const ShapeFileName : string; ShapeType : integer) : string; overload;
    procedure DeleteField(FieldName : string);
    function DeleteShapeFile(const ShapeFileName: string): string;
    procedure DeleteShape(shapeNum: integer); overload;
    procedure DeleteShape(x, y, z : double); overload;
    procedure DeleteShapePoint(x, y, z : double);
    function DetermineCentroid(ShapeNum : integer; var x, y : double) : string;
    procedure DrawShape(shapeNum: integer); overload;
    procedure DrawShape(shapeNum: integer; outlineOnly: boolean); overload;
    procedure DrawShape(Canvas : TCanvas; shapeNum: integer;
      outlineOnly : boolean = false); overload;
    procedure DrawShape(Canvas : TCanvas;
      ShapeNum, PenWidth: integer; PenColor, BrushColor : TColor;
      outlineOnly : boolean = false; pointsAlso : boolean = false); overload;
    procedure DrawShapePart(Canvas : TCanvas;
      ShapeNum, PartNum, PenWidth: integer; PenColor, BrushColor : TColor;
      outlineOnly : boolean = false; pointsAlso : boolean = false); overload;
    procedure DrawShapes; overload;
    procedure DrawShapes(Canvas : TCanvas); overload;
    procedure DrawShapes(Canvas : TCanvas;
      PenWidth: integer; PenColor, BrushColor : TColor;
      outlineOnly : boolean = false; pointsAlso : boolean = false); overload;
    procedure ExportAsTextFile(ShapeFileName, Filename : string;
      shapeNum : integer; Progressbar : TProgressbar;
      StatusBar : TStatusBar);
    procedure ExportAsXYZMTextFile(ShapeFileName, Filename: string;
      shapeNum: integer; exporteraAlltData : boolean;
      xnv, ynv, xoh, yoh : double; Progressbar : TProgressbar;
      StatusBar : TStatusBar);
    function Exists(const ShapeFileName: string): boolean;
    procedure GetClosestShapeAndPart(x, y, z: double;
      var shapeNum, partNum : integer);
    function GetClosestShape(x, y: double): integer; overload;
    function GetClosestShape(x, y, z : double) : integer; overload;
    function GetClosestShapePoint(x, y,
      z, m: double): integer; overload;
    procedure GetShapeAttributes; overload;
    function GetShapeAttributes(ShapeNum : integer) : TStringList; overload;
    function HitTest(x, y : double) : integer;
    procedure Intersect(const x1, y1, x2, y2, x3, y3, x4, y4: double; out xout,
      yout: double; var res: SmallInt);
    function MergeShapeFiles : boolean; overload;
    function MergeShapeFiles(shapeFileList : TStringList;
      resultShapeFilename : string) : boolean; overload;
    procedure MoveShape(x, y, z : double);
    function MultiSelect(Title: string; var ShapeFileList : TStringList) : boolean;
    function Open(const NameOfShapeFile, Mode : string) : boolean;
    function PtInPoly(const Points: doubleXYArray; NumPoints : integer;
      X, Y: double): Boolean;
    function ReadShape(shapeNum: integer) : boolean;
    procedure ReadShapePart(partNum : integer);
    procedure ReCalculateHeaderBoundingBoxes;
    function Select(Mode : string) : boolean; overload;
    function Select(Mode, Title : string) : boolean; overload;
    function ScaleShapeFile(xmin, ymin, xyscale, zscale : double;
      const NameOfScaledShapeFile : string) : boolean;
    function ShapeIntersect(const x1, y1, x2, y2 : double;
      var shapeNumArray : integerArray; var xyOut : doubleXYArray;
      var distFromX1Y1 : integerArray) : word;
    function ShapeTypeToDesignation: string;
    function SimplifyPolyShape(shapeNum : integer;
      maxReturnedPoints : integer) : integer;
    function Split(x1, y1, x2, y2 : double; ShapeNum : integer) : string; overload;
    function Split(ShapeNum : integer;
      splitShape : TShapeObj; splitShapeNum : integer) : string; overload;
    procedure TwinkleShape(numTimes: integer); overload;
    procedure TwinkleShape(shapeNum, numTimes: integer); overload;
    procedure TwinkleSelectedShape(ShapeNum, numTimes: integer);
    procedure UpdateHeaderBoundingBoxes;
    procedure UpdateMaxMinTot(const NameOfShapeFile : string);
    procedure UpdateShape(shapeNum: integer; x, y, z, m : double); overload;
//    procedure UpdateShape(x, y, z : double); overload;
    function UpdateArcPolyShapeZValue(shapeNum: integer; z: double): boolean;

    property Active : boolean read FActive;
    property BoundingBox  : double4Array read FBoundingBox;
    property Canvas : TCanvas read FCanvas write SetCanvas;
    property Category : integer read FCategory write SetCategory;
    property CurrentShapeNum : integer read FCurrentShapeNum write SetCurrentShapeNum;
    property CurrentShapePart : integer read FCurrentShapePart write SetCurrentShapePart;
    property Dbf : TDbf read FDbf;
    property DrawNonDeletedShapesOnly : boolean read FDrawNonDeletedShapesOnly write SetDrawNonDeletedShapesOnly;
    property InitialDir : string read FInitialDir write SetInitialDir;
    property PenColor : TColor read FPenColor write SetPenColor;
    property PenWidth : integer read FPenWidth write SetPenWidth;
    property PointsAlso : boolean read FPointsAlso write SetPointsAlso;
    property BrushColor : TColor read FBrushColor write SetBrushColor;
    property Mode : string read FMode write SetMode;
    property NullValue : double read FNullValue;
    property NumEntities : integer read FNumEntities;
    property NumParts : integer read FNumParts;
    property NumPoints : integer read FNumPoints;
    property Parts : integerArray read FParts;
    property PartNumPoints : integer read FPartNumPoints;
    property RecordNumber : integer read FRecordNumber;
    property SelectionColor : TColor read FSelectionColor write SetSelectionColor;
    property ShapeFileDir : string read GetShapeFileDir;
    property ShapeFileName : string read GetShapeFileName;
    property ShapeType : integer read FShapeType write SetShapeType;
    property SingleInstanceShapeType : integer read FSingleInstanceShapeType;
    property SplitAdjustDistance : double read FSplitAdjustDistance write SetSplitAdjustDistance;
    property Transparent : boolean read FTransparent write SetTransparent;

    property Area : double read FArea write SetArea;
    property Perimeter : double read FPerimeter write SetPerimeter;

    property ProgressBar : TProgressBar read FProgressBar write SetProgressBar;
    property StatusBar : TStatusBar read FStatusBar write SetStatusBar;

    property M : double read FM write FM;

    property MArray : doubleArray read FMArray;
    property PartMArray : doubleArray read FPartMArray;
    property MMin: double read FMMin;
    property MMax: double read FMMax;

    property X : double read FX write FX;
    property Y : double read FY write FY;
    property Z : double read FZ write FZ;

    property XYArray : doubleXYArray read FXYArray write FXYArray;
    property PartXYArray : doubleXYArray read FPartXYArray write FPartXYArray;

    property XMin : double read FXMin;
    property YMin : double read FYMin;
    property XMax : double read FXMax;
    property YMax : double read FYMax;

    property XMinTot : double read FXMinTot;
    property YMinTot : double read FYMinTot;
    property XMaxTot : double read FXMaxTot;
    property YMaxTot : double read FYMaxTot;
    property ZMinTot : double read FZMinTot;
    property ZMaxTot : double read FZMaxTot;
    property MMinTot : double read FMMinTot;
    property MMaxTot : double read FMMaxTot;

    property OffsetX : double read FOffsetX write SetOffsetX;
    property OffsetY : double read FOffsetY write SetOffsetY;

    property ZArray : doubleArray read FZArray write FZArray;
    property PartZArray : doubleArray read FPartZArray write FPartZArray;
    property ZMin: double read FZMin;
    property ZMax: double read FZMax;

    property WorldViewPortRoutines : TWorldViewPortRoutines read FWorldViewPortRoutines write SetWorldViewPortRoutines;
  published
    { Published declarations }
  end;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('Festina Lente', [TShapeObj]);
end;

{ TShapeObj }

constructor TShapeObj.Create(AOwner: TComponent);
begin
  inherited;

  FNullValue := 1.0e+38;
//  FNullValue := -1.0e+100;

  FDbf := TDbf.Create(Self);
  FActive := false;
  FSelectionColor := clYellow;
  
  FXYArray := nil;
  FParts := nil;

  FCanvas := nil;
//  FWorldViewPortRoutines := TWorldViewPortRoutines.Create(Self);
//  FWorldViewPortRoutines := nil;
  FPenColor := clBlack;
  FBrushColor := $008b00;
  FPenWidth := 1;

  FOffsetX := 0;
  FOffsetY := 0;

  FSplitAdjustDistance := 1.0;
  FDrawNonDeletedShapesOnly := true;

  FProgressBar := nil;
  FStatusBar := nil;

  FConvertPolylinePolygon := false;
  FToPolygon := false;
end;

destructor TShapeObj.Destroy;
begin
try
  Close;
except
end;

  FreeAndNil(FShapeFile);
  FreeAndNil(FIndexFile);
  FreeAndNil(FDbf);
//  FreeAndNil(FWorldViewPortRoutines);
  
  inherited;
end;

//function SwapEndian(value : variant
function TShapeObj.CreateShapeFile(const ShapeFileName, ShapeType : string): string;
var
  typ : integer;
begin
  if UpperCase(ShapeType) = 'POINT' then
    FShapeType := 1
  else if UpperCase(ShapeType) = 'POLYLINE' then
    FShapeType := 3
  else if UpperCase(ShapeType) = 'POLYGON' then
    FShapeType := 5
  else if UpperCase(ShapeType) = 'MULTIPOINT' then
    FShapeType := 8
  else if UpperCase(ShapeType) = 'POINTZ' then
    FShapeType := 11
  else if UpperCase(ShapeType) = 'POLYLINEZ' then
    FShapeType := 13
  else if UpperCase(ShapeType) = 'POLYGONZ' then
    FShapeType := 15
  else if UpperCase(ShapeType) = 'MULTIPOINTZ' then
    FShapeType := 18
  else if UpperCase(ShapeType) = 'POINTM' then
    FShapeType := 21
  else if UpperCase(ShapeType) = 'POLYLINEM' then
    FShapeType := 23
  else if UpperCase(ShapeType) = 'POLYGONM' then
    FShapeType := 25
  else if UpperCase(ShapeType) = 'MULTIPOINTM' then
    FShapeType := 28
  else if UpperCase(ShapeType) = 'MULTIPATCH' then
    FShapeType := 31;

  Result := CreateShapeFile(ShapeFileName, FShapeType);
end;

function TShapeObj.CreateShapeFile(const ShapeFileName : string; ShapeType : integer): string;
var
  dbfFieldDefs : TDbfFieldDefs;
  f : File;
  year : byte;
  i : Cardinal;
  filekod : integer;
  prjList, cpgList : TStringList;
begin
  if ShapeFileName = '' then
  begin
    Result := 'ShapeFileName inte angivet';
    Exit;
  end;

  FShapeFileName := AnsiReplaceText(ShapeFileName, '.shp', '');
  if FileExists(FShapeFileName + '.shp') { *Converted from FileExists*  } then
//  if FileExistsUTF8(FShapeFileName + '.shp') { *Converted from FileExists*  } then
  begin
    Result := ShapeFileName + ' already exists';
    exit;
  end;

  FShapeFile :=
    TFileStream.Create(FShapeFileName + '.shp', fmCreate or fmShareDenyWrite);
//    TFileStream.Create(UTF8ToSys(FShapeFileName + '.shp'), fmCreate or fmShareDenyWrite);
  FShapeFile.Position := 0;

  FIndexFile :=
    TFileStream.Create(FShapeFileName + '.shx', fmCreate or fmShareDenyWrite);
//    TFileStream.Create(UTF8ToSys(FShapeFileName + '.shx'), fmCreate or fmShareDenyWrite);
  FIndexFile.Position := 0;

  // skapa projektionsfil
  prjList := TStringList.Create;
  try
    prjList.Add('PROJCS["SWEREF99_TM",GEOGCS["GCS_SWEREF99",DATUM["D_SWEREF99",SPHEROID["GRS_1980",6378137.0,298.257222101]],PRIMEM["Greenwich",0.0],UNIT["Degree",0.0174532925199433]],PROJECTION["Transverse_Mercator"],PARAMETER["False_Easting",500000.0],PARAMETER["False_Northing",0.0],PARAMETER["Central_Meridian",15.0],PARAMETER["Scale_Factor",0.9996],PARAMETER["Latitude_Of_Origin",0.0],UNIT["Meter",1.0]]'
);
    prjList.SaveToFile(FShapeFileName + '.prj');
  finally
    FreeAndNil(prjList);
  end;

  // skapa code page fil
  cpgList := TStringList.Create;
  try
    cpgList.Add('UTF-8');
    cpgList.SaveToFile(FShapeFileName + '.cpg');
  finally
    FreeAndNil(cpgList);
  end;

  FXMinTot := FNullValue;
  FYMinTot := FNullValue;
  FXMaxTot := -FNullValue;
  FYMaxTot := -FNullValue;

  FZMinTot := FNullValue;
  FZMaxTot := -FNullValue;
  FMMinTot := FNullValue;
  FMMaxTot := -FNullValue;

// initialize MainFileHeader
  filekod := 9994;
  FMainFileHeader.FileCode := SwapEndian(filekod);
  FMainFileHeader.Unused1 := 0;
  FMainFileHeader.Unused2 := 0;
  FMainFileHeader.Unused3 := 0;
  FMainFileHeader.Unused4 := 0;
  FMainFileHeader.Unused5 := 0;
  FMainFileHeader.FileLength := SwapEndian(100);
  FMainFileHeader.Version := 1000;
  FMainFileHeader.ShapeType := ShapeType;

  FMainFileHeader.xMin := FXMinTot;
  FMainFileHeader.yMin := FYMinTot;
  FMainFileHeader.xMax := FXMaxTot;
  FMainFileHeader.yMax := FYMaxTot;
  FMainFileHeader.zMin := FZMinTot;
  FMainFileHeader.zMax := FZMaxTot;
  FMainFileHeader.mMin := FMMinTot;
  FMainFileHeader.mMax := FMMaxTot;

  i := FShapeFile.Size;
    FShapeFile.Write(FMainFileHeader, 100);//SizeOf(THeader));
  i := FShapeFile.Size;
    FreeAndNil(FShapeFile);
    FShapeFile :=
      TFileStream.Create(FShapeFileName + '.shp', fmOpenReadWrite or fmShareDenyWrite);
//      TFileStream.Create(UTF8ToSys(FShapeFileName + '.shp'), fmOpenReadWrite or fmShareDenyWrite);
    FShapeFile.Position := FShapeFile.Size;

// initialize IndexFileHeader
  filekod := 9994;
  FIndexFileHeader.FileCode := SwapEndian(filekod);
//  FIndexFileHeader.FileCode := SwapEndian(9994);
  FIndexFileHeader.Unused1 := 0;
  FIndexFileHeader.Unused2 := 0;
  FIndexFileHeader.Unused3 := 0;
  FIndexFileHeader.Unused4 := 0;
  FIndexFileHeader.Unused5 := 0;
  FIndexFileHeader.FileLength := SwapEndian(100);
  FIndexFileHeader.Version := 1000;
  FIndexFileHeader.ShapeType := ShapeType;

  FIndexFileHeader.xMin := FXMinTot;
  FIndexFileHeader.yMin := FYMinTot;
  FIndexFileHeader.xMax := FXMaxTot;
  FIndexFileHeader.yMax := FYMaxTot;
  FIndexFileHeader.zMin := FZMinTot;
  FIndexFileHeader.zMax := FZMaxTot;
  FIndexFileHeader.mMin := FMMinTot;
  FIndexFileHeader.mMax := FMMaxTot;

  i := FIndexFile.Size;
    FIndexFile.Write(FIndexFileHeader, 100);//SizeOf(THeader));
  i := FIndexFile.Size;
    FreeAndNil(FIndexFile);
    FIndexFile :=
      TFileStream.Create(FShapeFileName + '.shx', fmOpenReadWrite or fmShareDenyWrite);
//      TFileStream.Create(UTF8ToSys(FShapeFileName + '.shx'), fmOpenReadWrite or fmShareDenyWrite);
  FIndexFile.Position := FIndexFile.Size;

  FreeAndNil(FShapeFile);
  FreeAndNil(FIndexFile);

  dbfFieldDefs := TDbfFieldDefs.Create(nil);
  dbfFieldDefs.Add('RecNo', ftLargeint, 8, true);
  dbfFieldDefs.Add('Category', ftInteger, 4, false);
//  dbfFieldDefs.Add('RecNo', ftInteger, 4, true);
{
    FFieldName: string;
    FFieldType: TFieldType;
    FNativeFieldType: TDbfFieldType;
    FDefaultBuf: PChar;
    FMinBuf: PChar;
    FMaxBuf: PChar;
    FSize: Integer;
    FPrecision: Integer;
    FHasDefault: Boolean;
    FHasMin: Boolean;
    FHasMax: Boolean;
    FAllocSize: Integer;
    FCopyFrom: Integer;
    FOffset: Integer;
    FAutoInc: Cardinal;
    FRequired: Boolean;
    FIsLockField: Boolean;
    FNullPosition: integer;
}

  FDbf.Active := false;
//  FDbf.TableLevel := 3;  // dBase III+
  FDbf.FilePathFull := ExtractFilePath(FShapeFileName + '.shp');
  FDbf.TableName := FShapeFileName + '.dbf';
//  FDbf.TableName := UTF8ToSys(FShapeFileName + '.dbf');
  FDbf.CreateTableEx(dbfFieldDefs);

  FDbf.Active := true;
  FDbf.AddIndex('RecNo', 'RecNo', [ixPrimary]);
  FDbf.AddIndex('Category', 'Category', [ixCaseInsensitive]);

  FreeAndNil(dbfFieldDefs);

//  FActive := true;
  
  Result := 'Done';

  Close;
end;

function TShapeObj.Exists(const ShapeFileName : string) : boolean;
var
  namn : string;
begin
  namn := AnsiReplaceText(ShapeFileName, '.shp', '');
  Result := FileExists(namn + '.shp'); { *Converted from FileExists*  }
//  Result := FileExistsUTF8(namn + '.shp'); { *Converted from FileExists*  }
end;

procedure TShapeObj.Compress;
var
  i, n, partNum, numPartPoints,shapeNum, shapeType : integer;
  shapeNamn, tempShapeNamn, mode : string;
  shapeObj, tempShapeObj : TShapeObj;
  x, y, z, m : double;
begin
  shapeNamn := FShapeFileName;
  tempShapeNamn := ChangeFileExt(FShapeFileName, 'temp');
  if Exists(tempShapeNamn) then
    DeleteShapeFile(tempShapeNamn);

  mode := FMode;
  Close;

  CopyShapeFile(shapeNamn, tempShapeNamn);
  DeleteShapeFile(shapeNamn);

  shapeObj := TShapeObj.Create(nil);
  tempShapeObj := TShapeObj.Create(nil);
  try
    tempShapeObj.Open(tempShapeNamn, 'ro');

    shapeObj.CreateShapeFile(shapeNamn, tempShapeObj.ShapeType);
    shapeObj.Open(shapeNamn, 'rw');

    shapeNum := 0;
    while shapeNum < tempShapeObj.NumEntities do
    begin
      tempShapeObj.ReadShape(shapeNum);
      if tempShapeObj.SingleInstanceShapeType > 0 then
      begin
        if (tempShapeObj.shapeType = 1) or (tempShapeObj.shapeType = 11) or
           (tempShapeObj.shapeType = 18)  or (tempShapeObj.shapeType = 28) then
        begin
          x := FX;
          y := FY;
          z := FZ;
          m := FM;

          shapeObj.Add(x, y, z, m);
        end
        else if tempShapeObj.shapeType <> 31 then
        begin
          shapeObj.AddPolygonPolylineShape;
          partNum := 0;
          while partNum < tempShapeObj.NumParts do
          begin
            tempShapeObj.ReadShapePart(partNum);
            n := 0;
            while n < tempShapeObj.PartNumPoints do
            begin
              x := tempShapeObj.PartXYArray[n].x;
              y := tempShapeObj.PartXYArray[n].y;
              if tempShapeObj.PartZArray <> nil then
                z := tempShapeObj.PartZArray[n];
              if tempShapeObj.PartMArray <> nil then
                m := tempShapeObj.PartMArray[n];

              shapeObj.Add(x, y, z, m);

              Inc(n);
            end;

            Inc(partNum);
            if partNum < tempShapeObj.NumParts then
              shapeObj.AddPolyGonPolylinePart;
          end;
          shapeObj.ClosePolygonPolylineShape;
        end;
      end;

      Inc(shapeNum);
    end;
    tempShapeObj.Close;
    shapeObj.Close;
    DeleteShapeFile(tempShapeNamn);
  finally
    FreeAndNil(shapeObj);
    FreeAndNil(tempShapeObj);
  end;

  FMode := mode;
  Open(shapeNamn, FMode);
end;

function TShapeObj.ConvertPolylinePolygon(ToType: string): boolean;
var
  tempShape : TShapeObj;
  newShapeType, numEnt, n : integer;
  dir, namn : string;
  x, y, z, m : double;
begin
  Result := false;
  if not FActive then Exit;
  if (UpperCase(ToType) <> 'POLYLINE') and (UpperCase(ToType) <> 'POLYGON') then
    Exit;
  if (FShapeType < 3) or (FShapeType > 25) then Exit;
  if (FShapeType = 8) or (FShapeType = 11) or (FShapeType = 18) or
     (FShapeType = 21) then Exit;
  if ((FShapeType = 3) or (FShapeType = 13) or (FShapeType = 23)) and
     (UpperCase(ToType) = 'POLYLINE') then Exit;
  if ((FShapeType = 5) or (FShapeType = 15) or (FShapeType = 25)) and
     (UpperCase(ToType) = 'POLYGON') then Exit;

  FConvertPolylinePolygon := true;
  if UpperCase(ToType) = 'POLYGON' then
    FToPolygon := true
  else
    FToPolygon := false;

  namn := FShapeFileName;
  Close;
  CopyShapeFile(namn, '');
end;

function TShapeObj.CopyShapeFileOld(ShapeFileName, ShapeFileCopyName: string;
  DeletedShapesAlso : boolean = false; Prompt : boolean = true): string;
var
  entity, i, n, newShapeType : integer;
  shapeObjCopy : TShapeObj;
  x, y, z, m : double;
  recbuff : array of integer;
  dbfCopy : TDbf;
  temp : string;

  function currentShapeNotDeleted(n : integer) : boolean;
  var
    i : integer;
  begin
    Result := true;
    i := 0;
    while i < Length(recbuff) do
    begin
      if n = recbuff[i] then

      Inc(i);
    end;
    Result := false;
  end;

begin
  shapeObjCopy := TShapeObj.Create(nil);
  dbfCopy := TDbf.Create(nil);
  try
    Close;

    if FConvertPolylinePolygon then
      ShapeFileCopyName := ExtractFilePath(ShapeFileName) + 'temp'
    else
    begin
      if PosEx(':', ShapeFileCopyName) <= 0 then
        ShapeFileCopyName := ExtractFilePath(ShapeFileName) +
          AnsiReplaceText(ShapeFileCopyName, '.shp', '');

      if (Prompt) and (shapeObjCopy.Exists(ShapeFileCopyName)) then
      begin
        i := MessageDlg('Shapefil: ' + ExtractFileName(ShapeFileCopyName) +
          ' finns redan. OK att skriva över', mtConfirmation,
          [mbNo, mbOK], 0);
        if i <> 1 then Exit;
      end;
    end;
    Result := shapeObjCopy.DeleteShapeFile(ShapeFileCopyName);
    if Result <> 'Done' then Exit;

    Result := 'Failed';

    ShapeFileName := AnsiReplaceText(ShapeFileName, '.shp', '');
    if not Open(ShapeFileName, 'ro') then Exit;
    if (FShapeType = 28) or (FShapeType = 31) then
    begin
      Result := 'Kopiering är inte implementerat för MultiPointM och ' +
        'MultiPatch';
      Exit;
    end;
{    if (FShapeType <> 11) and (FShapeType <> 13) and (FShapeType <> 15) and
       (FShapeType <> 21) and (FShapeType <> 23) and (FShapeType <> 25) then
    begin
      Result := 'Kopiering endast implementerat för polylines och ' +
        'polygoner';
      Exit;
    end;}

    if FConvertPolylinePolygon then
    begin
      if FToPolygon then
        newShapeType := FShapeType + 2
      else
        newShapeType := FShapeType - 2;
    end
    else
      newShapeType := FShapeType;

    shapeObjCopy.CreateShapeFile(ShapeFileCopyName, newShapeType);
    if not shapeObjCopy.Open(ShapeFileCopyName, 'rw') then
    begin
      Result := 'Failed';
      Exit;
    end;

    entity := 0;
    while entity < FNumEntities do
    begin
      ReadShape(entity);
      if (FSingleInstanceShapeType <> 0) or
         (DeletedShapesAlso) then
      begin
        // spara
        SetLength(recbuff, Length(recbuff) + 1);
        recbuff[Length(recbuff) - 1] := entity;

        shapeObjCopy.AddPolygonPolylineShape;
        n := 0;
        while n < FNumPoints do
        begin
          x := FXYArray[n].x;
          y := FXYArray[n].y;
          if (FShapeType = 11) or (FShapeType = 13) or (FShapeType = 15) then
            z := FZArray[n]
          else
            z := 0;
          if (FShapeType = 21) or (FShapeType = 23) or (FShapeType = 25) then
            m := FMArray[n]
          else
            m := 0;

          shapeObjCopy.Add(x, y, z, m);

          Inc(n);
        end;
        shapeObjCopy.ClosePolygonPolylineShape;
      end;

      Inc(entity);
    end;

    shapeObjCopy.Close;

    // radera dbf-data
    if FileExists(ShapeFileCopyName + '.dbf') { *Converted from FileExists*  } then
      DeleteFile(ShapeFileCopyName + '.dbf'); { *Converted from DeleteFile*  }

{    CopyFile(ChangeFileExt(ShapeFileName, '.dbf'),
      ShapeFileCopyName + '.dbf');}

    // skapa ny dbf-fil för kopierade data
    dbfCopy.Active := false;
    dbfCopy.FilePathFull := ExtractFilePath(ShapeFileName + '.shp');
    dbfCopy.TableName := ShapeFileCopyName + '.dbf';
    dbfCopy.Exclusive := True;
    dbfCopy.CreateTableEx(FDbf.DbfFieldDefs);
    dbfCopy.Active := true;

    // kopiera endast dbf-data för akt. records
    n := 0;
    FDbf.First;
    while not FDbf.EOF do
    begin
      if currentShapeNotDeleted(n) then
      begin
        dbfCopy.Insert;
        dbfCopy.Fields[0].Value := dbfCopy.PhysicalRecordCount;
        for i:= 1 to FDbf.FieldCount-1 do
          dbfCopy.Fields[i].Value := FDbf.Fields[i].Value;
        dbfCopy.Post;
      end;
      FDbf.Next;
      Inc(n);
    end;

{    n := 0;
    while n < Length(recbuff) do
    begin}
{      FDbf.Active := false;
      FDbf.Filter := 'RECNO = ' + IntToStr(recbuff[n]);
      FDbf.Filtered := true;
      FDbf.Active := true;}

{      FDbf.First;
      while not FDbf.EOF do
      begin
        dbfCopy.Insert;
        dbfCopy.Fields[0].Value := dbfCopy.PhysicalRecordCount;
        for i:= 1 to FDbf.FieldCount-1 do
          dbfCopy.Fields[i].Value := FDbf.Fields[i].Value;
        dbfCopy.Post;
        FDbf.Next;
      end;

      Inc(n);
    end;}
    dbfCopy.Active := false;

    if FConvertPolylinePolygon then
    begin
      temp := FShapeFileName;
      Close;
      DeleteShapeFile(temp);
      FConvertPolylinePolygon := false;
      FToPolygon := false;
      CopyShapeFile(ShapeFileCopyName, temp);
    end;

    Result := 'Done';
  finally
    recbuff := nil;
    FreeAndNil(shapeObjCopy);
    FreeAndNil(dbfCopy);
  end;
end;

function TShapeObj.CopyShapeFile(ShapeFileName, ShapeFileCopyName: string;
  DeletedShapesAlso : boolean = false; Prompt : boolean = true): string;
var
  ShapeNums: array of integer;
  shapeObj : TShapeObj;
  n, numEntities : integer;

begin
  shapeObj := TShapeObj.Create(nil);
  try
    shapeObj.Open(ShapeFileName, 'ro');
    numEntities := shapeObj.NumEntities;
    SetLength(ShapeNums, numEntities);
    n := 0;
    while n < numEntities do
    begin
      ShapeNums[n] := n;

      Inc(n);
    end;
    shapeObj.Close;

    Result := CopyShapeFileShapes(ShapeFileName, ShapeFileCopyName, ShapeNums,
      numEntities, DeletedShapesAlso, Prompt);
  finally
    ShapeNums := nil;
    FreeAndNil(shapeObj);
  end;
end;

function TShapeObj.CopyShapeFileShape(ShapeFileName, ShapeFileCopyName: string;
  ShapeNum: integer;
  DeletedShapesAlso : boolean = false; Prompt : boolean = true): string;
var
  ShapeNums: array of integer;
begin
  SetLength(ShapeNums, 1);
  try
    ShapeNums[0] := ShapeNum;
    Result := CopyShapeFileShapes(ShapeFileName, ShapeFileCopyName,
      ShapeNums, 1, DeletedShapesAlso, Prompt);
  finally
    ShapeNums := nil;
  end;
end;

function TShapeObj.CopyShapeFileShapes(ShapeFileName, ShapeFileCopyName: string;
  ShapeNums: array of integer; NumberOfShapes : integer;
  DeletedShapesAlso : boolean = false; Prompt : boolean = true): string;
var
  entity, i, n, newShapeType : integer;
  shapeObjCopy : TShapeObj;
  x, y, z, m : double;
  shapesToCopy : array of integer;
  dbfCopy : TDbf;
  temp : string;

  function currentShapeCopied(n : integer) : boolean;
  var
    i : integer;
  begin
    Result := true;
    i := 0;
    while i < Length(shapesToCopy) do
    begin
      if n = shapesToCopy[i] then
        Exit;

      Inc(i);
    end;
    Result := false;
  end;

begin
  shapeObjCopy := TShapeObj.Create(nil);
  dbfCopy := TDbf.Create(nil);
  try
    Close;

    if FConvertPolylinePolygon then
      ShapeFileCopyName := ExtractFilePath(ShapeFileName) + 'temp'
    else
    begin
      if PosEx(':', ShapeFileCopyName) <= 0 then
        ShapeFileCopyName := ExtractFilePath(ShapeFileName) +
          AnsiReplaceText(ShapeFileCopyName, '.shp', '');

      if (Prompt) and (shapeObjCopy.Exists(ShapeFileCopyName)) then
      begin
        i := MessageDlg('Shapefil: ' + ExtractFileName(ShapeFileCopyName) +
          ' finns redan. OK att skriva över', mtConfirmation,
          [mbNo, mbOK], 0);
        if i <> 1 then Exit;
      end;
    end;
    Result := shapeObjCopy.DeleteShapeFile(ShapeFileCopyName);
    if Result <> 'Done' then Exit;

    Result := 'Failed';

    ShapeFileName := AnsiReplaceText(ShapeFileName, '.shp', '');
    if not Open(ShapeFileName, 'ro') then Exit;
    if (FShapeType = 28) or (FShapeType = 31) then
    begin
      Result := 'Kopiering är inte implementerat för MultiPointM och ' +
        'MultiPatch';
      Exit;
    end;
{    if (FShapeType <> 11) and (FShapeType <> 13) and (FShapeType <> 15) and
       (FShapeType <> 21) and (FShapeType <> 23) and (FShapeType <> 25) then
    begin
      Result := 'Kopiering endast implementerat för polylines och ' +
        'polygoner';
      Exit;
    end;}

    if FConvertPolylinePolygon then
    begin
      if FToPolygon then
        newShapeType := FShapeType + 2
      else
        newShapeType := FShapeType - 2;
    end
    else
      newShapeType := FShapeType;

    shapeObjCopy.CreateShapeFile(ShapeFileCopyName, newShapeType);
    if not shapeObjCopy.Open(ShapeFileCopyName, 'rw') then
    begin
      Result := 'Failed';
      Exit;
    end;

    entity := 0;
    while entity < NumberOfShapes do
//    while entity < FNumEntities do
    begin
      ReadShape(ShapeNums[entity]);
//      ReadShape(entity);
      if (FSingleInstanceShapeType <> 0) or
         (DeletedShapesAlso) then
      begin
        // spara
        SetLength(shapesToCopy, Length(shapesToCopy) + 1);
        shapesToCopy[Length(shapesToCopy) - 1] := ShapeNums[entity];

        shapeObjCopy.AddPolygonPolylineShape;
        n := 0;
        while n < FNumPoints do
        begin
          x := FXYArray[n].x;
          y := FXYArray[n].y;
          if (FShapeType = 11) or (FShapeType = 13) or (FShapeType = 15) then
            z := FZArray[n]
          else
            z := 0;
          if (FShapeType = 21) or (FShapeType = 23) or (FShapeType = 25) then
            m := FMArray[n]
          else
            m := 0;

          shapeObjCopy.Add(x, y, z, m);

          Inc(n);
        end;
        shapeObjCopy.ClosePolygonPolylineShape;
      end;

      Inc(entity);
    end;

    shapeObjCopy.Close;

    // radera dbf-data
    if FileExists(ShapeFileCopyName + '.dbf') { *Converted from FileExists*  } then
      DeleteFile(ShapeFileCopyName + '.dbf'); { *Converted from DeleteFile*  }

{    CopyFile(ChangeFileExt(ShapeFileName, '.dbf'),
      ShapeFileCopyName + '.dbf');}

    // skapa ny dbf-fil för kopierade data
    dbfCopy.Active := false;
    dbfCopy.FilePathFull := ExtractFilePath(ShapeFileName + '.shp');
    dbfCopy.TableName := ShapeFileCopyName + '.dbf';
    dbfCopy.Exclusive := True;
    dbfCopy.CreateTableEx(FDbf.DbfFieldDefs);
    dbfCopy.Active := true;

    // kopiera endast dbf-data för akt. records
    entity := 0;
    while entity < NumberOfShapes do
    begin
      FDbf.First;
      n := ShapeNums[entity];
      if currentShapeCopied(n) then
      begin
        FDbf.MoveBy(n);
        dbfCopy.Insert;
        dbfCopy.Fields[0].Value := dbfCopy.PhysicalRecordCount;
        for i:= 1 to FDbf.FieldCount-1 do
          dbfCopy.Fields[i].Value := FDbf.Fields[i].Value;
        dbfCopy.Post;
      end;

      Inc(entity);
    end;
{
    n := 0;
    FDbf.First;
    while not FDbf.EOF do
    begin
      if currentShapeNotDeleted(n) then
      begin
        dbfCopy.Insert;
        dbfCopy.Fields[0].Value := dbfCopy.PhysicalRecordCount;
        for i:= 1 to FDbf.FieldCount-1 do
          dbfCopy.Fields[i].Value := FDbf.Fields[i].Value;
        dbfCopy.Post;
      end;
      FDbf.Next;
      Inc(n);
    end;}

{    n := 0;
    while n < Length(recbuff) do
    begin}
{      FDbf.Active := false;
      FDbf.Filter := 'RECNO = ' + IntToStr(recbuff[n]);
      FDbf.Filtered := true;
      FDbf.Active := true;}

{      FDbf.First;
      while not FDbf.EOF do
      begin
        dbfCopy.Insert;
        dbfCopy.Fields[0].Value := dbfCopy.PhysicalRecordCount;
        for i:= 1 to FDbf.FieldCount-1 do
          dbfCopy.Fields[i].Value := FDbf.Fields[i].Value;
        dbfCopy.Post;
        FDbf.Next;
      end;

      Inc(n);
    end;}
    dbfCopy.Active := false;

    if FConvertPolylinePolygon then
    begin
      temp := FShapeFileName;
      Close;
      DeleteShapeFile(temp);
      FConvertPolylinePolygon := false;
      FToPolygon := false;
      CopyShapeFile(ShapeFileCopyName, temp);
      DeleteShapeFile(ShapeFileCopyName);
    end;

    Result := 'Done';
  finally
    shapesToCopy := nil;
    FreeAndNil(shapeObjCopy);
    FreeAndNil(dbfCopy);
  end;
end;

function TShapeObj.DeleteShapeFile(const ShapeFileName : string): string;
begin
  if ShapeFileName = FShapeFileName then
    Close;

  Result := 'Failed';
  
  FShapeFileName := AnsiReplaceText(ShapeFileName, '.shp', '');
  try
    if FileExists(FShapeFileName + '.shp') { *Converted from FileExists*  } then
      DeleteFile(FShapeFileName + '.shp'); { *Converted from DeleteFile*  }

    if FileExists(FShapeFileName + '.shp') { *Converted from FileExists*  } then Exit;
//    if FileExistsUTF8(FShapeFileName + '.shp') { *Converted from FileExists*  } then
//      DeleteFileUTF8(FShapeFileName + '.shp'); { *Converted from DeleteFile*  }

//    if FileExistsUTF8(FShapeFileName + '.shp') { *Converted from FileExists*  } then Exit;
  except
    on E:Exception do
    begin
      Result:=  E.Message;
      Exit;
    end;
  end;
  
  try
    if FileExists(FShapeFileName + '.shx') { *Converted from FileExists*  } then
      DeleteFile(FShapeFileName + '.shx'); { *Converted from DeleteFile*  }
//    if FileExistsUTF8(FShapeFileName + '.shx') { *Converted from FileExists*  } then
//      DeleteFileUTF8(FShapeFileName + '.shx'); { *Converted from DeleteFile*  }
  except
    on E:Exception do
    begin
      Result:=  E.Message;
      Exit;
    end;
  end;

  try
    if FileExists(FShapeFileName + '.dbf') { *Converted from FileExists*  } then
      DeleteFile(FShapeFileName + '.dbf'); { *Converted from DeleteFile*  }
//    if FileExistsUTF8(FShapeFileName + '.dbf') { *Converted from FileExists*  } then
//      DeleteFileUTF8(FShapeFileName + '.dbf'); { *Converted from DeleteFile*  }
  except
    on E:Exception do
    begin
      Result:=  E.Message;
      Exit;
    end;
  end;

  try
    if FileExists(FShapeFileName + '.mdx') { *Converted from FileExists*  } then
      DeleteFile(FShapeFileName + '.mdx'); { *Converted from DeleteFile*  }
//    if FileExistsUTF8(FShapeFileName + '.mdx') { *Converted from FileExists*  } then
//      DeleteFileUTF8(FShapeFileName + '.mdx'); { *Converted from DeleteFile*  }
  except
    on E:Exception do
    begin
      Result:=  E.Message;
      Exit;
    end;
  end;

  try
    if FileExists(FShapeFileName + '.sbn') { *Converted from FileExists*  } then
      DeleteFile(FShapeFileName + '.sbn'); { *Converted from DeleteFile*  }
//    if FileExistsUTF8(FShapeFileName + '.sbn') { *Converted from FileExists*  } then
//      DeleteFileUTF8(FShapeFileName + '.sbn'); { *Converted from DeleteFile*  }
  except
    on E:Exception do
    begin
      Result:=  E.Message;
      Exit;
    end;
  end;

  try
    if FileExists(FShapeFileName + '.sbx') { *Converted from FileExists*  } then
      DeleteFile(FShapeFileName + '.sbx'); { *Converted from DeleteFile*  }
//    if FileExistsUTF8(FShapeFileName + '.sbx') { *Converted from FileExists*  } then
//      DeleteFileUTF8(FShapeFileName + '.sbx'); { *Converted from DeleteFile*  }
  except
    on E:Exception do
    begin
      Result:=  E.Message;
      Exit;
    end;
  end;

  try
    if FileExists(FShapeFileName + '.prj') { *Converted from FileExists*  } then
      DeleteFile(FShapeFileName + '.prj'); { *Converted from DeleteFile*  }
  except
    on E:Exception do
    begin
      Result:=  E.Message;
      Exit;
    end;
  end;

    try
      if FileExists(FShapeFileName + '.cpg') { *Converted from FileExists*  } then
        DeleteFile(FShapeFileName + '.cpg'); { *Converted from DeleteFile*  }
    except
      on E:Exception do
      begin
        Result:=  E.Message;
        Exit;
      end;
    end;

  Result := 'Done';
end;

function TShapeObj.Select(Mode : string): boolean;
var
  OpenDialog : TOpenDialog;
begin
  Result := false;

  OpenDialog := TOpenDialog.Create(nil);
  try
    OpenDialog.DefaultExt := 'shp';
    OpenDialog.FileName := '*.shp';
    OpenDialog.InitialDir := FInitialDir;
    OpenDialog.Title := 'Markera Shapefil';
    if not OpenDialog.Execute then Exit;

    Result := Open(OpenDialog.FileName, Mode);
  finally
    FreeAndNil(OpenDialog);
  end;
end;

function TShapeObj.Select(Mode, Title: string): boolean;
var
  OpenDialog : TOpenDialog;
begin
  Result := false;

  OpenDialog := TOpenDialog.Create(nil);
  try
    OpenDialog.DefaultExt := 'shp';
    OpenDialog.FileName := '*.shp';
    OpenDialog.InitialDir := FInitialDir;
    OpenDialog.Title := Title;
    if not OpenDialog.Execute then Exit;

    Result := Open(OpenDialog.FileName, Mode);
  finally
    FreeAndNil(OpenDialog);
  end;
end;

function TShapeObj.ScaleShapeFile(xmin, ymin, xyscale, zscale : double;
  const NameOfScaledShapeFile: string): boolean;
var
  shapeObj : TShapeObj;
  namn : string;
  i, k, index, ktot, numPoints, shapeNum, numEntities : integer;
  x, y, z : double;
begin
  Result := false;
  if not FActive then Exit;

  shapeObj := TShapeObj.Create(nil);
  try
    if PosEx(FShapeFileDir, NameOfScaledShapeFile) > 0 then
      namn := NameOfScaledShapeFile
    else
      namn := FShapeFileDir + NameOfScaledShapeFile;
    if shapeObj.Exists(namn) then
      shapeObj.DeleteShapeFile(namn);
    shapeObj.CreateShapeFile(namn, FShapeType);
    shapeObj.Open(namn, 'rw');

    xyscale := xyscale / 1000;

    shapeNum := 0;
    while shapeNum < FNumEntities do
    begin
      ReadShape(shapeNum);
      if FSingleInstanceShapeType > 0 then
      begin
        case FShapeType of
          1 : shapeObj.Add((FX - xmin) / xyscale, (FY - ymin) / xyscale, 0, 0);
          11 : shapeObj.Add((FX - xmin) / xyscale, (FY - ymin) / xyscale,
            FZ * zscale / xyscale, 0);
          21 : shapeObj.Add((FX - xmin) / xyscale, (FY - ymin) / xyscale,
            FZ * zscale / xyscale, FM);
          3, 5, 13, 15, 23, 25 :
          begin
            shapeObj.AddPolygonPolylineShape;

            ktot := 0;
            for i := 0 to FNumParts - 1 do
            begin
              if FNumParts = 1 then
              begin
                numPoints := FNumPoints;
//                  resultShapeObj.Parts[i + 1] := numPoints + 1;
              end
              else if i < FNumParts - 1 then
                numPoints := FParts[i + 1] - FParts[i]
              else
                numPoints := FNumPoints - FParts[i];

              index := FParts[i];
              k := 0;
              while (ktot < FNumPoints) {and
                    (index + k < resultShapeObj.Parts[i + 1])} do
              begin
                x := (FXYArray[index + k].x - xmin) / xyscale;
                y := (FXYArray[index + k].y - ymin) / xyscale;
                z := FZArray[index + k] * zscale / xyscale;
                case FShapeType of
                  3, 5 :
                    shapeObj.Add(x, y, 0, 0);
                  13, 15 :
                    shapeObj.Add(x, y, z, 0);
                  23, 25 :
                    shapeObj.Add(x, y, z, FMArray[index + k]);
                end;

                Inc(k);
                Inc(ktot);
              end;
              shapeObj.CloseCurrentShapePart;

              if i < FNumParts - 1 then
                shapeObj.AddPolyGonPolylinePart;
            end;
            shapeObj.ClosePolygonPolylineShape;
          end;
          8, 18, 28 :
          begin
            for i := 0 to FNumPoints - 1 do
            begin
              x := (FXYArray[i].x - xmin) / xyscale;
              y := (FXYArray[i].y - ymin) / xyscale;
              z := FZArray[i] * zscale / xyscale;
              case FShapeType of
              8 : shapeObj.Add(x, y, 0, 0);
              18 :
                shapeObj.Add(x, y, z, 0);
              28 :
                shapeObj.Add(x, y, z, FMArray[i]);
              end;
            end;
          end;
        end;
      end;

      Inc(shapeNum);
    end;
    shapeObj.Close;
  finally
    FreeAndNil(shapeObj);
  end;
end;

function TShapeObj.MergeShapeFiles: boolean;
var
  shapeFileList : TStringList;
  resultShapeFilename: string;
begin
  Result := false;

  ShapeFileList := TStringList.Create;
  try
    if not MultiSelect('Markera shapefiler som ska slås samman', shapeFileList) then Exit;

    if not InputQuery('', 'Ange namn för sammanslagen shapefil', resultShapeFilename) then Exit;

    Result := MergeShapeFiles(shapeFileList, resultShapeFilename);
  finally
    FreeAndNil(ShapeFileList);
  end;
end;

function TShapeObj.MergeShapeFiles(shapeFileList: TStringList;
  resultShapeFilename: string): boolean;
var
  i, res, shapeType, shapeFileNum, shapeNum : integer;
  ktot, numPoints, index, k : integer;
  shapeObj, resultShapeObj : TShapeObj;

  function CheckEqualShapeTypesOK : integer;
  begin
    shapeObj.Open(ShapeFileList.Strings[0], 'ro');
    shapeType := shapeObj.ShapeType;

    Result := 1;
    while Result < ShapeFileList.Count do
    begin
      shapeObj.Open(ShapeFileList.Strings[Result], 'ro');
      if shapeObj.ShapeType <> shapeType then Exit;

      Inc(Result);
    end;
  end;

begin
  Result := false;

  resultShapeObj := TShapeObj.Create(nil);
  shapeObj := TShapeObj.Create(nil);
  try
    res := CheckEqualShapeTypesOK;
    if res < shapeFileList.Count then
    begin
      ShowMessage(ExtractFileName(shapeFileList.Strings[res]) +
        ' är av annan shapetyp');
      Exit;
    end;

    resultShapeFilename := ExtractFilePath(shapeFileList.Strings[0]) +
      resultShapeFilename;
    resultShapeObj.CreateShapeFile(resultShapeFilename, shapeType);
    resultShapeObj.Open(resultShapeFilename , 'rw');

    shapeFileNum := ShapeFileList.Count - 1;
    while shapeFileNum >= 0 do
    begin
      shapeObj.Open(ShapeFileList.Strings[shapeFileNum], 'ro');

      shapeNum := 0;
      while shapeNum < shapeObj.NumEntities do
      begin
        shapeObj.ReadShape(shapeNum);
        if shapeObj.SingleInstanceShapeType > 0 then
        begin
          case shapeType of
            1 : resultShapeObj.Add(shapeObj.X, shapeObj.Y, 0, 0);
            11 : resultShapeObj.Add(shapeObj.X, shapeObj.Y, shapeObj.Z, 0);
            21 : resultShapeObj.Add(shapeObj.X, shapeObj.Y, shapeObj.Z, shapeObj.M);
            3, 5, 13, 15, 23, 25 :
            begin
              resultShapeObj.AddPolygonPolylineShape;

              ktot := 0;
              for i := 0 to shapeObj.NumParts - 1 do
              begin
                if shapeObj.NumParts = 1 then
                begin
                  numPoints := shapeObj.NumPoints;
//                  resultShapeObj.Parts[i + 1] := numPoints + 1;
                end
                else if i < shapeObj.NumParts - 1 then
                  numPoints := resultShapeObj.Parts[i + 1] -
                    resultShapeObj.Parts[i]
                else
                  numPoints := shapeObj.NumPoints -
                    resultShapeObj.Parts[i];

                index := resultShapeObj.Parts[i];
                k := 0;
                while (ktot < shapeObj.NumPoints) {and
                      (index + k < resultShapeObj.Parts[i + 1])} do
                begin
                  case shapeType of
                    3, 5 :
                      resultShapeObj.Add(shapeObj.XYArray[index + k].x,
                        shapeObj.XYArray[index + k].y, 0, 0);
                    13, 15 :
                      resultShapeObj.Add(shapeObj.XYArray[index + k].x,
                        shapeObj.XYArray[index + k].y,
                        shapeObj.ZArray[index + k], 0);
                    23, 25 :
                      resultShapeObj.Add(shapeObj.XYArray[index + k].x,
                        shapeObj.XYArray[index + k].y,
                        shapeObj.ZArray[index + k],
                        shapeObj.MArray[index + k]);
                  end;

                  Inc(k);
                  Inc(ktot);
                end;
                resultShapeObj.CloseCurrentShapePart;

                if i < shapeObj.NumParts - 1 then
                  resultShapeObj.AddPolyGonPolylinePart;
              end;
              resultShapeObj.ClosePolygonPolylineShape;
            end;
            8, 18, 28 :
            begin
              for i := 0 to shapeObj.NumPoints - 1 do
              begin
                case shapeType of
                8 : resultShapeObj.Add(shapeObj.FXYArray[i].x,
                      shapeObj.XYArray[i].y, 0, 0);
                18 :
                  resultShapeObj.Add(shapeObj.XYArray[i].x,
                    shapeObj.XYArray[i].y,
                    shapeObj.ZArray[i], 0);
                28 :
                  resultShapeObj.Add(shapeObj.XYArray[i].x,
                    shapeObj.XYArray[i].y,
                    shapeObj.ZArray[i],
                    shapeObj.MArray[i]);
                end;
              end;
            end;
          end;
        end;

        Inc(shapeNum);
      end;

      Dec(shapeFileNum);
    end;
    resultShapeObj.Close;

    Result := true;
  finally
    FreeAndNil(shapeObj);
    FreeAndNil(resultShapeObj);
  end;
end;

function TShapeObj.MultiSelect(Title: string; var ShapeFileList : TStringList) : boolean;
var
  OpenDialog : TOpenDialog;
  i : integer;
begin
  Result := false;

  OpenDialog := TOpenDialog.Create(nil);
  try
    OpenDialog.DefaultExt := 'shp';
    OpenDialog.FileName := '*.shp';
    if Title = '' then
      OpenDialog.Title := 'Markera shapefiler'
    else
      OpenDialog.Title := Title;
    OpenDialog.Options := [ofAllowMultiSelect];
    if not OpenDialog.Execute then Exit;

    i := 0;
    while i < OpenDialog.Files.Count do
    begin
      ShapeFileList.Add(OpenDialog.Files[i]);

      i := i + 1;
    end;
    ShapeFileList.Sort;

    Result := true;
  finally
    FreeAndNil(OpenDialog);
  end;
end;

function TShapeObj.Open(const NameOfShapeFile, Mode : string): boolean;
var
  namn, temp : string;
begin
  Result := false;

  try
    if (PosEx('.shp', NameOfShapeFile) > 0) and
       (not FileExists(NameOfShapeFile)) { *Converted from FileExists*  } then Exit
//       (not FileExistsUTF8(ShapeFileName)) { *Converted from FileExists*  } then Exit
    else if (PosEx('.shp', NameOfShapeFile) <= 0) and
            (not FileExists(NameOfShapeFile + '.shp')) { *Converted from FileExists*  } then Exit;
//            (not FileExistsUTF8(ShapeFileName + '.shp')) { *Converted from FileExists*  } then Exit;

    if (Mode <> 'ro') and (Mode <> 'rw') and (Mode <> 'ex') then Exit;

    Close;

    namn := NameOfShapeFile;
    if PosEx('.shp', namn) > 0 then
      namn := AnsiReplaceText(namn, '.shp', '');
    FShapeFileName := namn;
    FShapeFileDir := ExtractFilePath(FShapeFileName);
    FMode := Mode;

    if Mode = 'ro' then
      FShapeFile :=
        TFileStream.Create(FShapeFileName + '.shp', fmOpenRead or fmShareDenyWrite)
//        TFileStream.Create(UTF8ToSys(FShapeFileName + '.shp'), fmOpenRead or fmShareDenyWrite)
    else
      FShapeFile :=
        TFileStream.Create(FShapeFileName + '.shp', fmOpenReadWrite or fmShareDenyWrite);
        //TFileStream.Create(UTF8ToSys(FShapeFileName + '.shp'), fmOpenReadWrite or fmShareDenyWrite);
    FShapeFile.Position := 0;

    if Mode = 'ro' then
      FIndexFile :=
        TFileStream.Create(FShapeFileName + '.shx', fmOpenRead or fmShareDenyWrite)
//        TFileStream.Create(UTF8ToSys(FShapeFileName + '.shx'), fmOpenRead or fmShareDenyWrite)
    else
      FIndexFile :=
        TFileStream.Create(FShapeFileName + '.shx', fmOpenReadWrite or fmShareDenyWrite);
//        TFileStream.Create(UTF8ToSys(FShapeFileName + '.shx'), fmOpenReadWrite or fmShareDenyWrite);
    FIndexFile.Position := 0;

    ReadMainFileHeader;

    ReadIndexFileHeader;
    ReadIndexFile;
{    if FXMaxTot - FXMinTot < 2 then
      // akt. shapefils total maxmin-koordinater är inte OK
      UpdateMaxMinTot;}

    FDbf.Active := false;
    FDbf.FilePathFull := ExtractFilePath(FShapeFileName + '.shp');
    FDbf.TableName := FShapeFileName + '.dbf';
//    FDbf.TableName := UTF8ToSys(FShapeFileName + '.dbf');
    if FMode = 'ex' then
      FDbf.Exclusive := true
    else
      FDbf.Exclusive := false;
    FDbf.Active := true;

    FActive := true;

    if (FShapeType = 3) or (FShapeType = 5) or
       (FShapeType = 13) or (FShapeType = 15) or
       (FShapeType = 23) or (FShapeType = 25) then
      FPolyGonPolylineAdded := false;

    FOffsetX := 0;
    FOffsetY := 0;

    Result := true;
  except
    on E: Exception do
    begin
      temp := E.Message;
      Result := false;
    end;
  end;
end;

procedure TShapeObj.Close;
var
  p, mainFileLength, indexFileLength : integer;
begin
  if FActive then
  begin
{    if (FShapeType =  5) or (FShapeType = 15) or (FShapeType = 25) then
      CloseCurrentShapePart;}
      
    if FPolyGonPolylineAdded then
      ClosePolygonPolylineShape;
//      WriteXYZAndMArrays;
       
    if (FMode = 'rw') or (FMode = 'ex') then
    begin
      if not FUpdateArcPolyShapeZValue then
        ReCalculateHeaderBoundingBoxes;

      mainFileLength := FShapeFile.Size div 2;
      FMainFileHeader.FileLength := SwapEndian(mainFileLength);
{      FFileLength := FShapeFile.Size;
      FMainFileHeader.FileLength := SwapEndian(FFileLength);}
      FShapeFile.Position := 0;
      FShapeFile.Write(FMainFileHeader, 100);//SizeOf(THeader));

      indexFileLength := FIndexFile.Size div 2;
      FIndexFileHeader.FileLength := SwapEndian(indexFileLength);
      FIndexFile.Position := 0;
      FIndexFile.Write(FIndexFileHeader, 100);//SizeOf(THeader));
    end;

    FreeAndNil(FShapeFile);
    FreeAndNil(FIndexFile);

    DeAllocateMemory;

    FXMin := 100000000;
    FYMin := 100000000;
    FZMin := 100000000;
    FMMin := 100000000;
    FXMax := -100000000;
    FYMax := -100000000;
    FZMax := -100000000;
    FMMax := -100000000;

    FXMinTot := 100000000;
    FYMinTot := 100000000;
    FZMinTot := 100000000;
    FMMinTot := 100000000;
    FXMaxTot := -100000000;
    FYMaxTot := -100000000;
    FZMaxTot := -100000000;
    FMMaxTot := -100000000;

    try
      FDbf.Edit;
      FDbf.Post;
    except
    end;
    FDbf.Active := false;

    FShapeFileName := '';
    FActive := false;
  end;
end;

procedure TShapeObj.ClosePolygonPolylineShape;
begin
  if FPolyGonPolylineAdded then
  begin
    CloseCurrentShapePart;
    WriteXYZAndMArrays;
  end
  else
  begin
    DeleteShape(FNumEntities);
    Dec(FNumEntities);
  end;

  FPolyGonPolylineAdded := false;
end;

procedure TShapeObj.DeAllocateMemory;
begin
// deallocate memory for parts
  if FPartNumPoints > 0 then
  begin
// deallocate memory for FPartXYArray
    FPartXYArray := nil;

    if (FShapeType = 13) or (FShapeType = 15) then
// deallocate memory for FPartZArray
      FPartZArray := nil;

    if (FShapeType = 13) or (FShapeType = 15) or
       (FShapeType = 23) or (FShapeType = 25) then
// deallocate memory for FPartMArray
      FPartMArray := nil;
  end;

// deallocate memory for FIndexRecordsArray
  if FNumEntities > 0 then
    FIndexRecordsArray := nil;

// deallocate memory for FParts
  if FNumParts > 0 then
    FParts := nil;

// deallocate memory for FXYArray
  if FNumPoints > 0 then
    FXYArray := nil;

  if (FShapeType = 13) or (FShapeType = 15) or (FShapeType = 18) then
  begin
// deallocate memory for FZArray
    if FNumPoints > 0 then
      FZArray := nil;
  end;

  if (FShapeType = 13) or (FShapeType = 15) or (FShapeType = 18) or
     (FShapeType = 23) or (FShapeType = 25) or
     (FShapeType = 28) then
  begin
// deallocate memory for FMArray
    if FNumPoints > 0 then
      FMArray := nil;
  end;

  FNumEntities := 0;
  FNumParts := 0;
  FNumPoints := 0;
end;

procedure TShapeObj.ReadMainFileHeader;
var
  i : integer;
begin
  FShapeFile.Read(FMainFileHeader, 100);

  i := FMainFileHeader.FileCode;
  FFileCode := SwapEndian(i);
  i := FMainFileHeader.FileLength;
  FFileLength := SwapEndian(i);
  FVersion := FMainFileHeader.Version;
  FShapeType := FMainFileHeader.ShapeType;

  FXMinTot := FMainFileHeader.xMin;
  FYMinTot := FMainFileHeader.yMin;
  FXMaxTot := FMainFileHeader.xMax;
  FYMaxTot := FMainFileHeader.yMax;
  FZMinTot := FMainFileHeader.zMin;
  FZMaxTot := FMainFileHeader.zMax;
  FMMinTot := FMainFileHeader.mMin;
  FMMaxTot := FMainFileHeader.mMax;
end;

function TShapeObj.GetXMinTot : double;
begin
  Result := FMainFileHeader.xMin;
end;

function TShapeObj.GetYMinTot : double;
begin
  Result := FMainFileHeader.yMin;
end;

function TShapeObj.GetXMaxTot : double;
begin
  Result := FMainFileHeader.xMax;
end;

function TShapeObj.GetYMaxTot : double;
begin
  Result := FMainFileHeader.yMax;
end;

function TShapeObj.GetZMinTot : double;
begin
  Result := FMainFileHeader.zMin;
end;

function TShapeObj.GetZMaxTot : double;
begin
  Result := FMainFileHeader.zMax;
end;

function TShapeObj.GetMMinTot : double;
begin
  Result := FMainFileHeader.mMin;
end;

function TShapeObj.GetMMaxTot : double;
begin
  Result := FMainFileHeader.mMax;
end;

procedure TShapeObj.ReadIndexFileHeader;
var
  i : integer;
begin
  FIndexFile.Read(FIndexFileHeader, 100);

  i := FIndexFileHeader.FileCode;
  FFileCode := SwapEndian(i);
  i := FIndexFileHeader.FileLength;
  FFileLength := SwapEndian(i);
  FVersion := FIndexFileHeader.Version;
  FShapeType := FIndexFileHeader.ShapeType;
end;

procedure TShapeObj.ReadIndexFile;
var
  i, offset, contentLength : integer;
begin
  FIndexFile.Position := 100;
  FNumEntities := (FIndexFile.Size - 100) div 8;
//  FNumEntities := (FIndexFile.Size - SizeOf(THeader)) div 8;
  if FNumEntities = 0 then Exit;

  if (FMode = 'rw') or (FMode = 'ex') then
    FRecordNumber := FNumEntities;

// allocate SizeOf(TIndexRecord) * FNumEntities bytes
  SetLength(FIndexRecordsArray, SizeOf(TIndexRecord) * FNumEntities);

  FIndexFile.Read(FIndexRecordsArray[0], SizeOf(TIndexRecord) * FNumEntities);
  for i := 0 to FNumEntities - 1 do
  begin
    offset := FIndexRecordsArray[i].Offset;
    FIndexRecordsArray[i].Offset := 2 * SwapEndian(offset);
    contentLength := FIndexRecordsArray[i].ContentLength;
    FIndexRecordsArray[i].ContentLength := SwapEndian(contentLength);
  end;
end;

procedure TShapeObj.CloseCurrentShapePart;
begin
  if (UpperCase(FMode) = 'RO') or (FXYArray = nil) or
     (not FPolyGonPolylineAdded) then Exit;

  if ((FShapeType = 5) and
      ((FXYArray[FParts[FNumParts - 1]].x <> FXYArray[FNumPoints - 1].x) or
       (FXYArray[FParts[FNumParts - 1]].y <> FXYArray[FNumPoints - 1].y))) or
     ((FShapeType = 15) and
      ((FXYArray[FParts[FNumParts - 1]].x <> FXYArray[FNumPoints - 1].x) or
       (FXYArray[FParts[FNumParts - 1]].y <> FXYArray[FNumPoints - 1].y))) or
     ((FShapeType = 25) and
      ((FXYArray[FParts[FNumParts - 1]].x <> FXYArray[FNumPoints - 1].x) or
       (FXYArray[FParts[FNumParts - 1]].y <> FXYArray[FNumPoints - 1].y))) then
  begin
    FX := FXYArray[FParts[FNumParts - 1]].x;
    FY := FXYArray[FParts[FNumParts - 1]].y;
    AddPolgonPolylinePoint;
    WriteXYZAndMArrays;
  end;
end;

// read shape
function TShapeObj.ReadShape(shapeNum : integer) : boolean;
begin
  Result := false;
  if (shapeNum < 0) or (shapeNum >= FNumEntities) then Exit;
  
  case FShapeType of
    0 :
    begin
    end;
    1, 11, 21 :
      ReadPointShape(shapeNum);
    3, 5, 13, 15, 23, 25 :
      ReadPolygonPolylineShape(shapeNum);
    8, 18, 28 :
      ReadMultiPointShape(shapeNum);
  end;

  FCurrentShapeNum := shapeNum;
  Result := true;
//  CalcAreaPerimeter(FXYArray, FNumPoints, FArea, FPerimeter);

{  Null Shape       0
  Point            1
  PolyLine         3
  Polygon          5
  MultiPoint       8
  PointZ          11
  PolyLineZ       13
  PolygonZ        15
  MultiPointZ     18
  PointM          21
  PolyLineM       23
  PolygonM        25
  MultiPointM     28
  MultiPatch      31}
end;

procedure TShapeObj.ReadShapePart(partNum: integer);
var
  i, index, numPoints : integer;
  x, y, z, m : double;
begin
  if FPartNumPoints > 0 then
  begin
// deallocate memory for FPartXYArray
    FPartXYArray := nil;

    if (FShapeType = 13) or (FShapeType = 15) then
// deallocate memory for FPartZArray
      FPartZArray := nil;

    if (FShapeType = 13) or (FShapeType = 15) or
       (FShapeType = 23) or (FShapeType = 25) then
// deallocate memory for FPartMArray
      FPartMArray := nil;
  end;

  if FNumParts = 1 then
    FPartNumPoints := FNumPoints
  else if partNum < FNumParts - 1 then
    FPartNumPoints := FParts[partNum + 1] -
      FParts[partNum]
  else
    FPartNumPoints := FNumPoints -
      FParts[partNum];

// allocate memory for FPartXYArray
  SetLength(FPartXYArray, SizeOf(doubleXY) * FPartNumPoints);

  if (FShapeType = 13) or (FShapeType = 15) then
// allocate memory for FZArray
    SetLength(FPartZArray, SizeOf(double) * FPartNumPoints);

  if (FShapeType = 13) or (FShapeType = 15) or
     (FShapeType = 23) or (FShapeType = 25) then
// allocate memory for FPartMArray
    SetLength(FPartMArray, SizeOf(double) * FPartNumPoints);

  try
    index := FParts[partNum];
    numPoints := 0;
    while numPoints < FPartNumPoints do
    begin
      FPartXYArray[numPoints].x := FXYArray[index + numPoints].x;
      FPartXYArray[numPoints].y := FXYArray[index + numPoints].y;

      if (FShapeType = 13) or (FShapeType = 15) then
        FPartZArray[numPoints] := FZArray[index + numPoints];

      if (FShapeType = 13) or (FShapeType = 15) or
         (FShapeType = 23) or (FShapeType = 25) then
        FPartMArray[numPoints] := FMArray[index + numPoints];

      numPoints := numPoints + 1;
    end;
  except
  end;
end;

procedure TShapeObj.GetShapeAttributes;
begin
  FDbf.First;
  FDbf.MoveBy(FCurrentShapeNum);
end;

function TShapeObj.GetShapeAttributes(ShapeNum: integer): TStringList;
begin
  FDbf.First;
  FDbf.MoveBy(ShapeNum);
end;

procedure TShapeObj.ReadPointShape(shapeNum : integer);
var
  i, recnum, contentLength : integer;
begin
  if (shapeNum < 0) or (shapeNum >= FNumEntities) then Exit;
  
  i := FShapeFile.Position;
  FShapeFile.Position := FIndexRecordsArray[shapeNum].Offset;

  FShapeFile.Read(FRecordHeader, SizeOf(TRecordHeader));
  recnum := FRecordHeader.RecordNumber;
  FRecordNumber := SwapEndian(recnum);
  contentLength := FRecordHeader.ContentLength;
  FContentLength := SwapEndian(contentLength);

  FShapeFile.Read(FSingleInstanceShapeType, SizeOf(FShapeType));

  FShapeFile.Read(FX, SizeOf(FX));
  FShapeFile.Read(FY, SizeOf(FY));

  FXMin := FX;
  FYMin := FY;
  FXMax := FX;
  FYMax := FY;

  if FShapeType = 11 then
    FShapeFile.Read(FZ, SizeOf(FZ))
  else
    FZ := FNullValue;

  if FShapeType = 21 then
    FShapeFile.Read(FM, SizeOf(FM))
  else
    FM := FNullValue;

  FZMin := FZ;
  FZMax := FZ;

  FMMin := FM;
  FMMax := FM;

  FNumPoints := 1;
end;

procedure TShapeObj.ReadPolygonPolylineShape(shapeNum : integer);
var
  i, recnum, contentLength : integer;
begin
  if (shapeNum < 0) or (shapeNum >= FNumEntities) then Exit;

  if (Length(FIndexRecordsArray) = 0) or
     (FIndexRecordsArray[shapeNum].Offset < 0) then
  begin
// akt. shape ännu inte skriven till disk och finns i minne
   
    Exit;
  end;

  i := FIndexRecordsArray[shapeNum].Offset;
  if i < 0 then Exit;
  FShapeFile.Position := FIndexRecordsArray[shapeNum].Offset;

  i := SizeOf(TRecordHeader);
  FShapeFile.Read(FRecordHeader, SizeOf(TRecordHeader));
  recnum := FRecordHeader.RecordNumber;
  FRecordNumber := SwapEndian(recnum);
  if FRecordNumber <> shapeNum + 1 then Exit;
  contentLength := FRecordHeader.ContentLength;
  FContentLength := SwapEndian(contentLength);

  FShapeFile.Read(FSingleInstanceShapeType, SizeOf(FShapeType));
{  if FSingleInstanceShapeType = 0 then
  begin
    FNumParts := 0;
    FNumPoints := 0;
    Exit;
  end;}

  FShapeFile.Read(FBoundingBox, SizeOf(FBoundingBox));

  FXMin := FBoundingBox[0];
  FYMin := FBoundingBox[1];
  FXMax := FBoundingBox[2];
  FYMax := FBoundingBox[3];

// deallocate memory for FParts
  try
    if (FNumParts > 0) and (FParts <> nil) then
      FParts := nil;
  except
  end;
  
  if FNumPoints > 0 then
  begin
// deallocate memory for FXYArray
    FXYArray := nil;

    if (FShapeType = 13) or (FShapeType = 15) then
// deallocate memory for FZArray
      FZArray := nil;

    if (FShapeType = 13) or (FShapeType = 15) or
       (FShapeType = 23) or (FShapeType = 25) then
// deallocate memory for FMArray
      FMArray := nil;
  end;

  FZMin := FNullValue;
  FZMax := FNullValue;
  FMMin := FNullValue;
  FMMax := FNullValue;

  i := FShapeFile.Position;
  FShapeFile.Read(FNumParts, SizeOf(FNumParts));
  FShapeFile.Read(FNumPoints, SizeOf(FNumPoints));

// allocate memory for FParts
  SetLength(FParts, FNumParts);
  FShapeFile.Read(FParts[0], (SizeOf(integer)) * FNumParts);

// allocate memory for FXYArray
  SetLength(FXYArray, SizeOf(doubleXY) * FNumPoints);
  FShapeFile.Read(FXYArray[0], (SizeOf(doubleXY)) * FNumPoints);

  if (FShapeType = 13) or (FShapeType = 15) then
  begin
    FShapeFile.Read(FZMin, SizeOf(FZMin));
    FShapeFile.Read(FZMax, SizeOf(FZMax));

// allocate memory for FZArray
    SetLength(FZArray, SizeOf(double) * FNumPoints);
    if shapeNum = 0 then
      FZArrayStartPos := FShapeFile.Position;
    FShapeFile.Read(FZArray[0], (SizeOf(double)) * FNumPoints);
  end;

  if (FShapeType = 13) or (FShapeType = 15) or
     (FShapeType = 23) or (FShapeType = 25) then
  begin
    FShapeFile.Read(FMMin, SizeOf(FMMin));
    FShapeFile.Read(FMMax, SizeOf(FMMax));

// allocate memory for FMArray
    SetLength(FMArray, SizeOf(double) * FNumPoints);
    FShapeFile.Read(FMArray[0], (SizeOf(double)) * FNumPoints);
  end;
end;

procedure TShapeObj.SetCategory(AValue: integer);
begin
  if FCategory=AValue then Exit;
  FCategory:=AValue;
end;

procedure TShapeObj.SetCurrentShapePart(AValue: integer);
begin
  if FCurrentShapePart=AValue then Exit;
  FCurrentShapePart:=AValue;
end;

procedure TShapeObj.SetDrawNonDeletedShapesOnly(AValue: boolean);
begin
  if FDrawNonDeletedShapesOnly=AValue then Exit;
  FDrawNonDeletedShapesOnly:=AValue;
end;

procedure TShapeObj.SetInitialDir(AValue: string);
begin
  if FInitialDir=AValue then Exit;
  FInitialDir:=AValue;
end;

procedure TShapeObj.SetOffsetX(AValue: double);
begin
  if FOffsetX=AValue then Exit;
  FOffsetX:=AValue;
end;

procedure TShapeObj.SetOffsetY(AValue: double);
begin
  if FOffsetY=AValue then Exit;
  FOffsetY:=AValue;
end;

procedure TShapeObj.SetPointsAlso(AValue: boolean);
begin
  if FPointsAlso=AValue then Exit;
  FPointsAlso:=AValue;
end;

procedure TShapeObj.SetProgressBar(AValue: TProgressBar);
begin
  if FProgressBar=AValue then Exit;
  FProgressBar:=AValue;
end;

procedure TShapeObj.SetSplitAdjustDistance(AValue: double);
begin
  if FSplitAdjustDistance=AValue then Exit;
  FSplitAdjustDistance:=AValue;
end;

procedure TShapeObj.SetStatusBAr(AValue: TStatusBar);
begin
  if FStatusBar=AValue then Exit;
  FStatusBar:=AValue;
end;

procedure TShapeObj.ReadMultiPointShape(shapeNum : integer);
var
  i, recnum, contentLength : integer;
begin
  if (shapeNum < 0) or (shapeNum >= FNumEntities) then Exit;
  
  FShapeFile.Position := FIndexRecordsArray[shapeNum].Offset;

  FShapeFile.Read(FRecordHeader, SizeOf(TRecordHeader));
  recnum := FRecordHeader.RecordNumber;
  FRecordNumber := SwapEndian(recnum);
  contentLength := FRecordHeader.ContentLength;
  FContentLength := SwapEndian(contentLength);

  FShapeFile.Read(FSingleInstanceShapeType, SizeOf(FShapeType));

  FShapeFile.Read(FBoundingBox, SizeOf(FBoundingBox));

  FXMin := FBoundingBox[0];
  FYMin := FBoundingBox[1];
  FXMax := FBoundingBox[2];
  FYMax := FBoundingBox[3];

  if FNumPoints > 0 then
  begin
// deallocate memory for FXYArray
    FXYArray := nil;

    if FShapeType = 18 then
// deallocate memory for FZArray
      FZArray := nil;

    if (FShapeType = 18) or (FShapeType = 28) then
// deallocate memory for FMArray
      FMArray := nil;
  end;

  FZMin := FNullValue;
  FZMax := FNullValue;
  FMMin := FNullValue;
  FMMax := FNullValue;

  FShapeFile.Read(FNumPoints, SizeOf(FNumPoints));

// allocate memory for FXYArray
  SetLength(FXYArray, SizeOf(doubleXY) * FNumPoints);
  FShapeFile.Read(FXYArray[0], (SizeOf(doubleXY)) * FNumPoints);

  if FShapeType = 18 then
  begin
    FShapeFile.Read(FZMin, SizeOf(FZMin));
    FShapeFile.Read(FZMax, SizeOf(FZMax));

// allocate memory for FZArray
    SetLength(FZArray, SizeOf(double) * FNumPoints);
    FShapeFile.Read(FZArray[0], (SizeOf(double)) * FNumPoints);
  end;

  if (FShapeType = 18) or (FShapeType = 28) then
  begin
    FShapeFile.Read(FMMin, SizeOf(FMMin));
    FShapeFile.Read(FMMax, SizeOf(FMMax));

// allocate memory for FMArray
    SetLength(FMArray, SizeOf(double) * FNumPoints);
    FShapeFile.Read(FMArray[0], (SizeOf(double)) * FNumPoints);
  end;
end;

procedure TShapeObj.UpdateMaxMinTot(const NameOfShapeFile : string);
var
  n : integer;
  xmin, ymin, xmax, ymax : double;
  mode, shapeFileName : string;
begin
  Open(NameOfShapeFile, 'rw');

  if FNumEntities = 0 then Exit;

  shapeFileName := FShapeFileName;
  mode := FMode;

  xmin := 100000000;
  ymin := 100000000;
  xmax := -100000000;
  ymax := -100000000;

  // läs alla shapes och beräkna totmaxmin
  n := 0;
  while n < FNumEntities do
  begin
    ReadShape(n);

    if xmin > FXMin then
      xmin := FXMin;
    if ymin > FYMin then
      ymin := FYMin;
    if xmax < FXMax then
      xmax := FXMax;
    if ymax < FYMax then
      ymax := FYMax;

    Inc(n);
  end;

{  FXMinTot := xmin;
  FYMinTot := ymin;
  FXMaxTot := xmax;
  FYMaxTot := ymax;}

  // stäng shapefil och dess indexfil
{  FreeAndNil(FShapeFile);
  FreeAndNil(FIndexFile);

  // öppna shapefil och dess indexfil för skrivning
  FShapeFile :=
      TFileStream.Create(FShapeFileName + '.shp', fmOpenReadWrite or fmShareDenyWrite);
      //TFileStream.Create(UTF8ToSys(FShapeFileName + '.shp'), fmOpenReadWrite or fmShareDenyWrite);
}
  FShapeFile.Position := 0;

{  FIndexFile :=
      TFileStream.Create(FShapeFileName + '.shx', fmOpenReadWrite or fmShareDenyWrite);
//        TFileStream.Create(UTF8ToSys(FShapeFileName + '.shx'), fmOpenReadWrite or fmShareDenyWrite);
}
  FIndexFile.Position := 0;

  FMainFileHeader.xMin := xmin;
  FMainFileHeader.yMin := ymin;
  FMainFileHeader.xMax := xmax;
  FMainFileHeader.yMax := ymax;

  FIndexFileHeader.xMin := xmin;
  FIndexFileHeader.yMin := ymin;
  FIndexFileHeader.xMax := xmax;
  FIndexFileHeader.yMax := ymax;

  // skriv uppdaterade totmaxmin
  FShapeFile.Write(FMainFileHeader, 100);//SizeOf(THeader));
  FIndexFile.Write(FIndexFileHeader, 100);//SizeOf(THeader));

  // stäng shapefil och dess indexfil
  FreeAndNil(FShapeFile);
  FreeAndNil(FIndexFile);

  // återöppna shapefil
//  Open(shapeFileName, mode);
end;

function TShapeObj.UpdateTotalAndCurrentMaxMinValues(x, y, z, m : double) : integer;
var
  size : integer;
begin
  if (x >= 0) and (x <= 360) and
     (y >= -90) and (y <= 90) then
  begin
    FX := x;
    FY := y;
  end
  else
  begin
    FX := Round(x);
    FY := Round(y);
  end;
  FZ := z;
  FM := m;

  if FXMaxTot < FX then
    FXMaxTot := FX;
  if FYMaxTot < FY then
    FYMaxTot := FY;
  if (FZMaxTot < FZ) and (FZ <> FNullValue) then
    FZMaxTot := FZ;
  if FMMaxTot < FM then
    FMMaxTot := FM;
  if FXMinTot > FX then
    FXMinTot := FX;
  if FYMinTot > FY then
    FYMinTot := FY;
  if (FZMinTot > FZ) and (FZ <> -32768) and (FZ <> FNullValue) then
    FZMinTot := FZ;
  if FMMinTot > FM then
    FMMinTot := FM;

  if FXMax < FX then
    FXMax := FX;
  if FYMax < FY then
    FYMax := FY;
  if (FZMax < FZ)  and (FZ <> FNullValue) then
    FZMax := FZ;
  if FMMax < FM then
    FMMax := FM;
  if FXMin > FX then
    FXMin := FX;
  if FYMin > FY then
    FYMin := FY;
  if (FZMin > FZ) and (FZ <> -32768) and (FZ <> FNullValue) then
    FZMin := FZ;
  if FMMin > FM then
    FMMin := FM;

// update MainFileHeader
  size := FShapeFile.Size div 2;
  FMainFileHeader.FileLength := SwapEndian(size);

  if (FMainFileHeader.xMin = FNullValue) or
     (FMainFileHeader.xMin > FXMinTot) then
    FMainFileHeader.xMin := FXMinTot;
  if (FMainFileHeader.yMin = FNullValue) or
     (FMainFileHeader.yMin > FYMinTot) then
    FMainFileHeader.yMin := FYMinTot;
  if (FShapeType = 11) or (FShapeType = 13) or
     (FShapeType = 15) or (FShapeType = 18) then
  begin
    if (FMainFileHeader.zMin = FNullValue) or
       (FMainFileHeader.zMin > FZMinTot) then
      FMainFileHeader.zMin := FZMinTot;
  end;
  if (FShapeType = 21) or (FShapeType = 23) or
     (FShapeType = 25) or (FShapeType = 28) then
  begin
    if (FMainFileHeader.mMin = FNullValue) or
        (FMainFileHeader.mMin > FMMinTot) then
      FMainFileHeader.mMin := FMMinTot;
  end;

  if (FMainFileHeader.xMax = FNullValue) or
     (FMainFileHeader.xMax < FXMaxTot) then
    FMainFileHeader.xMax := FXMaxTot;
  if (FMainFileHeader.yMax = FNullValue) or
     (FMainFileHeader.yMax < FYMaxTot) then
    FMainFileHeader.yMax := FYMaxTot;
  if (FShapeType = 11) or (FShapeType = 13) or
     (FShapeType = 15) or (FShapeType = 18) then
  begin
    if (FMainFileHeader.zMax = FNullValue) or
       (FMainFileHeader.zMax < FZMaxTot) then
      FMainFileHeader.zMax := FZMaxTot;
  end;
  if (FShapeType = 21) or (FShapeType = 23) or
     (FShapeType = 25) or (FShapeType = 28) then
  begin
    if (FMainFileHeader.mMax = FNullValue) or
        (FMainFileHeader.mMax < FMMaxTot) then
      FMainFileHeader.mMax := FMMaxTot;
  end;

  // update IndexFileHeader
  size := FIndexFile.Size div 2;
  FIndexFileHeader.FileLength := SwapEndian(size);

  if (FIndexFileHeader.xMin = FNullValue) or
     (FIndexFileHeader.xMin > x) then
    FIndexFileHeader.xMin := x;
  if (FIndexFileHeader.yMin = FNullValue) or
     (FIndexFileHeader.yMin > y) then
    FIndexFileHeader.yMin := y;
  if (FShapeType = 11) or (FShapeType = 13) or
     (FShapeType = 15) or (FShapeType = 18) then
  begin
    if (FIndexFileHeader.zMin = FNullValue) or
       (FIndexFileHeader.zMin > z) then
      FIndexFileHeader.zMin := z;
  end;
  if (FShapeType = 21) or (FShapeType = 23) or
     (FShapeType = 25) or (FShapeType = 28) then
  begin
    if (FIndexFileHeader.mMin = FNullValue) or
       (FIndexFileHeader.mMin > m) then
      FIndexFileHeader.mMin := m;
  end;

  if (FIndexFileHeader.xMax = FNullValue) or
     (FIndexFileHeader.xMax < x) then
    FIndexFileHeader.xMax := x;
  if (FIndexFileHeader.yMax = FNullValue) or
     (FIndexFileHeader.yMax < y) then
    FIndexFileHeader.yMax := y;
  if (FShapeType = 11) or (FShapeType = 13) or
     (FShapeType = 15) or (FShapeType = 18) then
  begin
    if (FIndexFileHeader.zMax = FNullValue) or
       (FIndexFileHeader.zMax < z) then
      FIndexFileHeader.zMax := z;
  end;
  if (FShapeType = 21) or (FShapeType = 23) or
     (FShapeType = 25) or (FShapeType = 28) then
  begin
    if (FIndexFileHeader.mMax = FNullValue) or
       (FIndexFileHeader.mMax < m) then
      FIndexFileHeader.mMax := m;
  end;
end;

function TShapeObj.Add(x, y : integer) : integer;
begin
  Add(FWorldViewPortRoutines.wx(x),
      FWorldViewPortRoutines.wy(y), 0, 0);
end;

function TShapeObj.Add(x, y, z, m : double) : integer;
var
  IndexRecord : TIndexRecord;
  fileSizeBeforeAdd, ContentLength, i : integer;
begin
  if (FIndexFile = nil) or ((FMode <> 'rw') and (FMode <> 'ex')) then Exit;

  i := FIndexFile.Size;
  fileSizeBeforeAdd := FShapeFile.Size;

  UpdateTotalAndCurrentMaxMinValues(x, y, z, m);

  case FShapeType of
    0 :
    begin
    end;
    1, 11, 21 :
      ContentLength := AddPointShape;
    3, 5, 13, 15, 23, 25 :
    begin
      ContentLength := AddPolgonPolylinePoint;
      FPolyGonPolylineAdded := true;
    end;
    8, 18, 28 :
      ContentLength := AddMultiPointShape;
  end;
end;

function TShapeObj.AddPointShape : integer;
var
  IndexRecord : TIndexRecord;
  fileSizeBeforeAdd, ContentLength, i, offset : integer;
begin
  FXMin := FNullValue;
  FYMin := FNullValue;
  FXMax := -FNullValue;
  FYMax := -FNullValue;

  FZMin := FNullValue;
  FZMax := -FNullValue;
  FMMin := FNullValue;
  FMMax := -FNullValue;

  i := FIndexFile.Size;
  fileSizeBeforeAdd := FShapeFile.Size;

  FShapeFile.Position := FShapeFile.Size;
i := FShapeFile.Position;

  if FShapeType = 11 then
    Result := 28
  else if FShapeType = 21 then
    Result := 28
  else
    Result := 20;

  Result := Result div 2;

  FRecordNumber := FNumEntities + 1;
  FRecordHeader.RecordNumber := SwapEndian(FRecordNumber);
  FRecordHeader.ContentLength := SwapEndian(Result);
  FShapeFile.Write(FRecordHeader, SizeOf(TRecordHeader));
i := FShapeFile.Position;

  FShapeFile.Write(FShapeType, SizeOf(FShapeType));
//i := FShapeFile.Position;

  FShapeFile.Write(FX, SizeOf(FX));
  FShapeFile.Write(FY, SizeOf(FY));
//i := FShapeFile.Position;

  if FShapeType = 11 then
    FShapeFile.Write(FZ, SizeOf(FZ));

  if FShapeType = 21 then
    FShapeFile.Write(FM, SizeOf(FM));

// expand index array
  FNumEntities := FNumEntities + 1;
  if FNumEntities = 1 then
    SetLength(FIndexRecordsArray, SizeOf(TIndexRecord) * FNumEntities)
  else
    SetLength(FIndexRecordsArray, SizeOf(TIndexRecord) * FNumEntities);

  FIndexRecordsArray[FNumEntities - 1].Offset := fileSizeBeforeAdd div 2;
//  FIndexRecordsArray[FNumEntities - 1].Offset := fileSizeBeforeAdd div 2;
//  ContentLength := 10;
  FIndexRecordsArray[FNumEntities - 1].ContentLength := Result;

  offset := fileSizeBeforeAdd div 2;
  IndexRecord.Offset := SwapEndian(offset);
  IndexRecord.ContentLength := SwapEndian(Result);

  FIndexFile.Position := FIndexFile.Size;
  FIndexFile.Write(IndexRecord, SizeOf(TIndexRecord));

  FDbf.AppendRecord([FNumEntities - 1]);
  FDbf.Edit;
  FDbf.UpdateRecord;
  FDbf.FieldByName('Category').AsInteger := FCategory;
  FDbf.Post;
end;

function TShapeObj.AddPolygonPolylineShape : integer;
begin
  if FPolyGonPolylineAdded then
  begin
    CloseCurrentShapePart;
    WriteXYZAndMArrays;
  end;

  FNumEntities := FNumEntities + 1;
  FNumParts := 0;
  FNumPoints := 0;

  FXMin := FNullValue;
  FYMin := FNullValue;
  FXMax := -FNullValue;
  FYMax := -FNullValue;

  FZMin := FNullValue;
  FZMax := -FNullValue;
  FMMin := FNullValue;
  FMMax := -FNullValue;

  FPolyGonPolylineAdded := false;
  AddPolyGonPolylinePart;
end;

procedure TShapeObj.WriteXYZAndMArrays;
var
  IndexRecord : TIndexRecord;
  fileSizeBeforeAdd, ContentLength, i : integer;

  procedure DetermineBoundingBox;
  var
    i : integer;
  begin
    FXMinTot := 100000000.0;
    FYMinTot := 100000000.0;
    FXMaxTot := -100000000.0;
    FYMaxTot := -100000000.0;

    i := 0;
    while i < FNumPoints do
    begin
      if FXMinTot > FXYArray[i].x then
        FXMinTot := FXYArray[i].x;
      if FYMinTot > FXYArray[i].y then
        FYMinTot := FXYArray[i].y;
      if FXMaxTot < FXYArray[i].x then
        FXMaxTot := FXYArray[i].x;
      if FYMaxTot < FXYArray[i].y then
        FYMaxTot := FXYArray[i].y;

      i := i + 1;
    end;

    if (FMainFileHeader.xMin = FNullValue) or
       (FMainFileHeader.xMin > FXMinTot) then
      FMainFileHeader.xMin := FXMinTot;
    if (FMainFileHeader.yMin = FNullValue) or
       (FMainFileHeader.yMin > FYMinTot) then
      FMainFileHeader.yMin := FYMinTot;
    if (FMainFileHeader.xMax = FNullValue) or
       (FMainFileHeader.xMax < FXMaxTot) then
      FMainFileHeader.xMax := FXMaxTot;
    if (FMainFileHeader.yMax = FNullValue) or
       (FMainFileHeader.yMax < FYMaxTot) then
      FMainFileHeader.yMax := FYMaxTot;

    FIndexFileHeader.xMin := FMainFileHeader.xMin;
    FIndexFileHeader.yMin := FMainFileHeader.yMin;
    FIndexFileHeader.xMax := FMainFileHeader.xMax;
    FIndexFileHeader.yMax := FMainFileHeader.yMax;
  end;

begin
  if FNumParts > 0 then
  begin
// write previous polygon/polyline to disk
    fileSizeBeforeAdd := FShapeFile.Size;
    FShapeFile.Position := FShapeFile.Size;

    ContentLength :=
      SizeOf(FShapeType) +
      4 * (SizeOf(double)) +
      2 * (SizeOf(integer)) +
      (SizeOf(integer)) * FNumParts +
      (SizeOf(doubleXY)) * FNumPoints;
    if (FShapeType = 13) or (FShapeType = 15) then
      ContentLength := ContentLength +
        2 * (SizeOf(double)) +
        (SizeOf(double)) * FNumPoints;
    if (FShapeType = 23) or (FShapeType = 25) then
      ContentLength := ContentLength +
        2 * (SizeOf(double)) +
        (SizeOf(double)) * FNumPoints;

    ContentLength := ContentLength div 2;

    FRecordNumber := FNumEntities;
    FRecordHeader.RecordNumber := SwapEndian(FRecordNumber);
    FRecordHeader.ContentLength := SwapEndian(ContentLength);
    FShapeFile.Write(FRecordHeader, SizeOf(TRecordHeader));

    i := FShapeFile.Position;
    FShapeFile.Write(FShapeType, SizeOf(FShapeType));

    DetermineBoundingBox;

    FShapeFile.Write(FXMin, SizeOf(double));
    FShapeFile.Write(FYMin, SizeOf(double));
    FShapeFile.Write(FXMax, SizeOf(double));
    FShapeFile.Write(FYMax, SizeOf(double));

    FShapeFile.Write(FNumParts, SizeOf(integer));
    FShapeFile.Write(FNumPoints, SizeOf(integer));
    FShapeFile.Write(FParts[0], (SizeOf(integer)) * FNumParts);
    FShapeFile.Write(FXYArray[0], (SizeOf(doubleXY)) * FNumPoints);
    SetLength(FParts, 0);
    SetLength(FXYArray, 0);

    if (FShapeType = 13) or (FShapeType = 15) then
    begin
      FShapeFile.Write(FZMin, SizeOf(double));
      FShapeFile.Write(FZMax, SizeOf(double));
      SetLength(FZArray, SizeOf(double) * FNumPoints);
      FZArrayStartPos := FShapeFile.Position;
      FShapeFile.Write(FZArray[0], (SizeOf(double)) * FNumPoints);
    end;

    if (FShapeType = 23) or (FShapeType = 25) then
    begin
      FShapeFile.Write(FMMin, SizeOf(double));
      FShapeFile.Write(FMMax, SizeOf(double));
      SetLength(FMArray, SizeOf(double) * FNumPoints);
      FShapeFile.Write(FMArray[0], (SizeOf(double)) * FNumPoints);
    end;

    if FRecordNumber = 1 then
      SetLength(FIndexRecordsArray, SizeOf(TIndexRecord) * FRecordNumber)
    else
      SetLength(FIndexRecordsArray, SizeOf(TIndexRecord) * FRecordNumber);

// ****** Fix 2015-02-19 Konstigt att detta inte hittats tidigare ******
    FIndexRecordsArray[FNumEntities - 1].Offset := fileSizeBeforeAdd;
  //    FIndexRecordsArray[FRecordNumber - 1].Offset := fileSizeBeforeAdd div 2;
// ****** Fix 2015-02-19 Konstigt att detta inte hittats tidigare ******
  //  ContentLength := 10;

//    ContentLength := ContentLength div 2;

    FIndexRecordsArray[FRecordNumber - 1].ContentLength := ContentLength;

    IndexRecord.ContentLength := SwapEndian(ContentLength);
    i := fileSizeBeforeAdd div 2;
    IndexRecord.Offset := SwapEndian(i);
//    IndexRecord.Offset := SwapEndian(fileSizeBeforeAdd div 2);

    i := FIndexFile.Position;
    i := FIndexFile.Size;
    FIndexFile.Position := FIndexFile.Size;
    FIndexFile.Write(IndexRecord, SizeOf(TIndexRecord));

    FDbf.Active := false;
    FDbf.FilePathFull := ExtractFilePath(FShapeFileName + '.shp');
    FDbf.TableName := FShapeFileName + '.dbf';
    FDbf.Active := true;

    FDbf.AppendRecord([FRecordNumber - 1]);
    FDbf.Edit;
    FDbf.UpdateRecord;
    FDbf.FieldByName('Category').AsInteger := FCategory;
    FDbf.Post;
  end
  else
    FRecordNumber := 0;

  FNumParts := 0;
  FNumPoints := 0;
end;

procedure TShapeObj.AddPolyGonPolylinePart;
begin
  if (FNumParts > 0) {and
     ((FShapeType =  5) or (FShapeType = 15) or (FShapeType = 25))} then
    CloseCurrentShapePart;

  FNumParts := FNumParts + 1;
  SetLength(FParts, FNumParts);
  FParts[FNumParts - 1] := FNumPoints;
//  SetLength(FParts, SizeOf(integer) * FNumParts);
//  SetLength(FParts, SizeOf(TIndexRecord) * FNumParts);
//  FParts[FNumParts - 1] := FNumPoints;
end;

function TShapeObj.AddPolgonPolylinePoint: integer;
begin
  if not FPolyGonPolylineAdded then
    FPolyGonPolylineAdded := true;

  FNumPoints := FNumPoints + 1;
  SetLength(FXYArray, SizeOf(doubleXY) * FNumPoints);
  FXYArray[FNumPoints - 1].x := FX;
  FXYArray[FNumPoints - 1].y := FY;

  if (FShapeType = 13) or (FShapeType = 15) then
  begin
    SetLength(FZArray, SizeOf(double) * FNumPoints);
    FZArray[FNumPoints - 1] := FZ;
  end;

  if (FShapeType = 23) or (FShapeType = 25) then
  begin
    SetLength(FMArray, SizeOf(double) * FNumPoints);
    FMArray[FNumPoints - 1] := FM;
  end;
end;

function TShapeObj.AddMultiPointShape : integer;
begin
end;

procedure TShapeObj.AddField(FieldName: string; DataType: TFieldType;
  Size: Integer; Required: Boolean = False; MakeItAnIndex: Boolean = False);
var
  i, SizeOld : integer;
  Dbf : TDbf;
  fieldList : TStringList;
  FieldNameOld, temp : string;
  DataTypeOld : TFieldType;
  fieldDef : TDbfFieldDef;
  fieldDefs : TDbfFieldDefs;
  indexDef : TDbfIndexDef;
  RequiredOld, oldActiveStatus : boolean;
begin
  fieldDefs := TDbfFieldDefs.Create(nil);
  try
    i := 0;
    while i < FDbf.DbfFieldDefs.Count do
    begin
      fieldDef := FDbf.DbfFieldDefs.Items[i];
      if fieldDef.FieldName = UpperCase(FieldName) then
        Exit; // fältet finns redan

      fieldDefs.Add(fieldDef.FieldName, fieldDef.FieldType, fieldDef.Size, fieldDef.Required);

      i := i + 1;
    end;

    try
      oldActiveStatus := FDbf.Active;

      if FileExists(FDbf.FilePathFull + 'temp.dbf') then
        DeleteFile(FDbf.FilePathFull + 'temp.dbf');
      if FileExists(FDbf.FilePathFull + 'temp.mdx') then
        DeleteFile(FDbf.FilePathFull + 'temp.mdx');

      Dbf := TDbf.Create(nil);
      Dbf.FilePathFull := FDbf.FilePathFull;
      Dbf.TableName := 'temp.dbf';

      fieldDefs.Add(FieldName, DataType, Size, Required);

      Dbf.CreateTableEx(fieldDefs);
      Dbf.Active:=true;
      FDbf.First;
      while not FDbf.Eof do
      begin
        Dbf.Insert;
        for i:=0 to FDbf.FieldCount-1 do
        begin
          Dbf.Fields[i].Value:=FDbf.Fields[i].Value;
        end;
        Dbf.Post;
        FDbf.Next;
      end;

      fieldList := TStringList.Create;
      try
        FDbf.GetFieldNames(fieldList);
        if PosEx('RecNo', fieldList.Text) > 0 then
          Dbf.AddIndex('RecNo', 'RecNo', [ixPrimary]);
        if PosEx('Category', fieldList.Text) > 0 then
          Dbf.AddIndex('Category', 'Category', [ixCaseInsensitive]);
      finally
        FreeAndNil(fieldList);
      end;
//      if MakeItAnIndex then
//        Dbf.AddIndex(FieldName, FieldName, [ixCaseInsensitive]);
    finally
      Dbf.Active:=false;
      FreeAndNil(Dbf);

      FDbf.Active := false;
      temp := FDbf.FilePathFull + FDbf.TableName;
      DeleteFile(FDbf.FilePathFull + FDbf.TableName); { *Converted from DeleteFile*  }
      RenameFile(FDbf.FilePathFull + 'temp.dbf',
        FDbf.FilePathFull + FDbf.TableName); { *Converted from RenameFile*  }
      FDbf.Active := oldActiveStatus;
      if MakeItAnIndex then
      begin
        FDbf.AddIndex(FieldName, FieldName, [ixCaseInsensitive]);
        FDbf.IndexName := FieldName;
      end;
    end;
  finally
    FreeAndNil(fieldDefs);
    DeleteFile(FDbf.FilePathFull + 'temp.mdx');
  end;
end;

procedure TShapeObj.DeleteField(FieldName: string);
var
  i, n, deletedFieldNr, SizeOld : integer;
  Dbf : TDbf;
  FieldNameOld, error : string;
  DataTypeOld : TFieldType;
  fieldDef : TDbfFieldDef;
  fieldDefs : TDbfFieldDefs;
  RequiredOld, oldActiveStatus : boolean;
begin
//  if UpperCase(FieldName) = 'RECNO' then Exit;

  try
    oldActiveStatus := FDbf.Active;

    fieldDefs := TDbfFieldDefs.Create(nil);
    Dbf := TDbf.Create(nil);
    Dbf.FilePathFull := FDbf.FilePathFull;

    if FileExists(ExtractFilePath(FShapeFileName) + 'temp.dbf') { *Converted from FileExists*  } then
      DeleteFile(ExtractFilePath(FShapeFileName) + 'temp.dbf'); { *Converted from DeleteFile*  }
//    if FileExistsUTF8(ExtractFilePath(FShapeFileName) + 'temp.dbf') { *Converted from FileExists*  } then
//      DeleteFileUTF8(ExtractFilePath(FShapeFileName) + 'temp.dbf'); { *Converted from DeleteFile*  }

    Dbf.TableName := 'temp.dbf';

    deletedFieldNr := -1;
    
    i := 0;
    while i < FDbf.DbfFieldDefs.Count do
    begin
      fieldDef := FDbf.DbfFieldDefs.Items[i];
      if fieldDef.FieldName <> UpperCase(FieldName) then
        fieldDefs.Add(fieldDef.FieldName, fieldDef.FieldType, fieldDef.Size, fieldDef.Required)
      else
        deletedFieldNr := i;

      i := i + 1;
    end;

    Dbf.CreateTableEx(fieldDefs);
    Dbf.Active:=true;
    FDbf.First;
    while not FDbf.Eof do begin
      Dbf.Insert;
      n := 0;
      for i:=0 to FDbf.FieldCount-1 do
      begin
        if i <> deletedFieldNr then
        begin
          Dbf.Fields[n].Value:=FDbf.Fields[i].Value;
          n := n + 1;
        end;
      end;
      Dbf.Post;
      FDbf.Next;
    end;
  finally
    Dbf.Active:=false;
    FreeAndNil(Dbf);
    FreeAndNil(fieldDefs);

    FDbf.Active := false;
    DeleteFile(FDbf.FilePathFull + FDbf.TableName); { *Converted from DeleteFile*  }
    RenameFile(FDbf.FilePathFull + 'temp.dbf',FDbf.FilePathFull + FDbf.TableName); { *Converted from RenameFile*  }
//    DeleteFileUTF8(FDbf.FilePathFull + FDbf.TableName); { *Converted from DeleteFile*  }
//    RenameFileUTF8(FDbf.FilePathFull + 'temp.dbf',FDbf.FilePathFull + FDbf.TableName); { *Converted from RenameFile*  }
    FDbf.Active := true;
  end;
end;

procedure TShapeObj.DeleteShape(shapeNum: integer);
var
  ShapeType : integer;
begin
  if (shapeNum < 0) or (shapeNum >= FNumEntities) then Exit;
  
  FShapeFile.Position := FIndexRecordsArray[shapeNum].Offset;

  FShapeFile.Read(FRecordHeader, SizeOf(TRecordHeader));

  ShapeType := 0;  // set to null-shape
  FShapeFile.Write(ShapeType, SizeOf(FShapeType));
  FlushShape;
end;

procedure TShapeObj.FlushShape;
var
  shapeFileName : string;
begin
  shapeFileName := FShapeFileName;
  Close;
  Open(shapeFileName, FMode);
end;

procedure TShapeObj.DeleteShape(x, y, z: double);
begin
  DeleteShape(GetClosestShape(x, y, z));
end;

procedure TShapeObj.DeleteShapePoint(x, y, z: double);
begin

end;

function TShapeObj.DetermineCentroid(ShapeNum : integer; var x, y : double) :
  string;
var
  n : integer;
  A : double;
begin
  Result := 'Akt. shape är inte en polygon';

  if (FShapeType = 5) or (FShapeType = 15) or (FShapeType <> 25) then
  begin
  {  The centroid of a non-self-intersecting closed polygon defined by n vertices
    (x0,y0), (x1,y1), ..., (xn−1,yn−1) is point (Cx, Cy),[16] where

    Cx = 1/6A * sum 0 till n-1 av (x[i] + x[i+1])*(x[i]*y[i+1]-x[i+1]*y[i])
    Cy = 1/6A * sum 0 till n-1 av (y[i] + y[i+1])*(x[i]*y[i+1]-x[i+1]*y[i])
    där
    A = 0.5 * sum 0 till n-1 av (x[i]*y[i+1]-x[i+1]*y[i])
  }
    ReadShape(ShapeNum);
    A := 0;
    n := 0;
    while n < FNumPoints do
    begin
      A := A +
        (FXYArray[n].x * FXYArray[n + 1].y - FXYArray[n + 1].x * FXYArray[n].y);

      Inc(n);
    end;
    A := 0.5 * A;

    //  Cx = 1/6A * sum 0 till n-1 av (x[i] + x[i+1])*(x[i]*y[i+1]-x[i+1]*y[i])
    //  Cy = 1/6A * sum 0 till n-1 av (y[i] + y[i+1])*(x[i]*y[i+1]-x[i+1]*y[i])
    x := 0;
    y := 0;
    n := 0;
    while n < FNumPoints do
    begin
      x := x + (FXYArray[n].x + FXYArray[n + 1].x) *
        (FXYArray[n].x * FXYArray[n + 1].y - FXYArray[n + 1].x * FXYArray[n].y);
      y := y + (FXYArray[n].y + FXYArray[n + 1].y) *
        (FXYArray[n].x * FXYArray[n + 1].y - FXYArray[n + 1].x * FXYArray[n].y);

      Inc(n);
    end;

    x := (1 / (6 * A)) * x;
    y := (1 / (6 * A)) * y;
  end;

  Result := 'OK';
end;

procedure TShapeObj.GetClosestShapeAndPart(x, y, z: double; var shapeNum,
  partNum: integer);
begin
  shapeNum := GetClosestShape(x, y, z);
  partNum := GetClosestShapePart(shapeNum, x, y, z);
end;

function TShapeObj.GetClosestShapePart(shapeNum : integer; x, y, z : double): integer;
var
  x1, y1, x2, y2, area, minArea, perimeter : double;
  i, part : integer;

  function CalculatePartsArea : double;
  var
    i : integer;
    area, perimeter : double;
  begin
    CalcAreaPerimeter(FPartXYArray, FPartNumPoints,
       area, perimeter);
    Result := area;
  end;

begin
  Result := -1;

  minArea := 100000000000000.0;

  ReadShape(shapeNum);
  if FSingleInstanceShapeType > 0 then
  begin
    i := 0;
    while i < FNumParts do
    begin
      ReadShapePart(i);
      x1 := FPartXYArray[0].x; y1 := FPartXYArray[0].y;
      x2 := FPartXYArray[FPartNumPoints - 1].x;
      y2 := FPartXYArray[FPartNumPoints - 1].y;
      if PtInPoly(FPartXYArray, FPartNumPoints, x, y) then
      begin
        area := CalculatePartsArea;
        if minArea > area then
        begin
          minArea := area;
          Result := i;
        end;
      end;
      Inc(i);
    end;
  end;
end;

function TShapeObj.GetClosestShape(x, y : double): integer;
var
  dist, minDist, xc, yc, zc : double;
  i : integer;
begin
  Result := -1;

  minDist := 100000000.0;

  i := 0;
  while i < FNumEntities do
  begin
    ReadShape(i);

    if FSingleInstanceShapeType > 0 then
    begin
      case FShapeType of
        1,{ 8, 18,} 21{, 28} :
        begin
          dist := sqrt((Fx - x) * (Fx - x) + (Fy - y) * (Fy - y));
          if dist < minDist then
          begin
            minDist := dist;
            Result := i;
          end;
        end;
        11 :
        begin
          if (x >= FXMin) and  (x <= FXMax) and
             (y >= FYMin) and  (y <= FYMax) then
          begin
            dist :=
              sqrt((Fx - x) * (Fx - x) + (Fy - y) * (Fy - y));
            if dist < minDist then
            begin
              minDist := dist;
              Result := i;
            end;
          end;
        end;
        3, 5, 13, 15, 23, 25 :
//        3, 23 :
        begin
          if (x >= FXMin) and  (x <= FXMax) and
             (y >= FYMin) and  (y <= FYMax) then
          begin
            Result := GetPolylineShapeClosestToPoint(x, y);
            Exit;
{            xc := (FBoundingBox[0] + FBoundingBox[2]) / 2.0;
            yc := (FBoundingBox[1] + FBoundingBox[3]) / 2.0;

            dist := sqrt((xc - x) * (xc - x) + (yc - y) * (yc - y));
            if dist < minDist then
            begin
              minDist := dist;
              Result := i;
            end;}
          end;
        end;
{        13 :
        begin
          if (x >= FXMin) and  (x <= FXMax) and
             (y >= FYMin) and  (y <= FYMax) then
          begin}
{            Result := GetPolylineShapeClosestToPoint(x, y, z);
            Exit;}
{            xc := (FBoundingBox[0] + FBoundingBox[2]) / 2.0;
            yc := (FBoundingBox[1] + FBoundingBox[3]) / 2.0;

            dist :=
              sqrt((xc - x) * (xc - x) + (yc - y) * (yc - y) +
                   (Fz - z) * (Fz - z));
            if dist < minDist then
            begin
              minDist := dist;
              Result := i;
            end;}
//        end;
      end;
    end;

{
  ShapeType     Value
  Null Shape       0
  Point            1
  PolyLine         3
  Polygon          5
  MultiPoint       8
  PointZ          11
  PolyLineZ       13
  PolygonZ        15
  MultiPointZ     18
  PointM          21
  PolyLineM       23
  PolygonM        25
  MultiPointM     28
  MultiPatch      31
}
    i := i + 1;
  end;

  FCurrentShapeNum := Result;
end;

function TShapeObj.GetClosestShape(x, y, z : double): integer;
var
  dist, minDist, xc, yc, zc : double;
  i : integer;
begin
  Result := -1;
  
  minDist := 100000000.0;

  i := 0;
  while i < FNumEntities do
  begin
    ReadShape(i);

    if FSingleInstanceShapeType > 0 then
    begin
      case FShapeType of
        1,{ 8, 18,} 21{, 28} :
        begin
          dist := sqrt((Fx - x) * (Fx - x) + (Fy - y) * (Fy - y));
          if dist < minDist then
          begin
            minDist := dist;
            Result := i;
          end;
        end;
        11 :
        begin
          if (x >= FXMin) and  (x <= FXMax) and
             (y >= FYMin) and  (y <= FYMax) and
             (z >= FZMin) and  (z <= FZMax) then
          begin
            dist :=
              sqrt((Fx - x) * (Fx - x) + (Fy - y) * (Fy - y) +
                   (Fz - z) * (Fz - z));
            if dist < minDist then
            begin
              minDist := dist;
              Result := i;
            end;
          end;
        end;
        3, 5, 13, 15, 23, 25 :
//        3, 23 :
        begin
          if (x >= FXMin) and  (x <= FXMax) and
             (y >= FYMin) and  (y <= FYMax) then
          begin
            Result := GetPolylineShapeClosestToPoint(x, y);
            Exit;
{            xc := (FBoundingBox[0] + FBoundingBox[2]) / 2.0;
            yc := (FBoundingBox[1] + FBoundingBox[3]) / 2.0;

            dist := sqrt((xc - x) * (xc - x) + (yc - y) * (yc - y));
            if dist < minDist then
            begin
              minDist := dist;
              Result := i;
            end;}
          end;
        end;
{        13 :
        begin
          if (x >= FXMin) and  (x <= FXMax) and
             (y >= FYMin) and  (y <= FYMax) then
          begin}
{            Result := GetPolylineShapeClosestToPoint(x, y, z);
            Exit;}
{            xc := (FBoundingBox[0] + FBoundingBox[2]) / 2.0;
            yc := (FBoundingBox[1] + FBoundingBox[3]) / 2.0;

            dist :=
              sqrt((xc - x) * (xc - x) + (yc - y) * (yc - y) +
                   (Fz - z) * (Fz - z));
            if dist < minDist then
            begin
              minDist := dist;
              Result := i;
            end;}
//        end;
      end;
    end;

{
  ShapeType     Value
  Null Shape       0
  Point            1
  PolyLine         3
  Polygon          5
  MultiPoint       8
  PointZ          11
  PolyLineZ       13
  PolygonZ        15
  MultiPointZ     18
  PointM          21
  PolyLineM       23
  PolygonM        25
  MultiPointM     28
  MultiPatch      31
}
    i := i + 1;
  end;

  FCurrentShapeNum := Result;
end;

function TShapeObj.GetPolylineShapeClosestToPoint(x, y : double): integer;
var
  dist, minDist, xp, yp : double;
  n, shapeNum, nMin : integer;
begin
  Result := -1;

  minDist := 100000000.0;

  shapeNum := 0;
  while shapeNum < FNumEntities do
  begin
    ReadShape(shapeNum);
    if (FSingleInstanceShapeType > 0) and
       (x - FOffsetX >= FXMin) and (x - FOffsetX <= FXMax) and
       (y - FOffsetY >= FYMin) and (y - FOffsetY <= FYMax) then
    begin
      n := 0;
      while n < FNumPoints do
      begin
        xp := FXYArray[n].x;
        yp := FXYArray[n].y;

        dist := (xp - x) * (xp - x) + (yp - y) * (yp - y);
        if dist < minDist then
        begin
          nMin := n;
          minDist := dist;
          Result := shapeNum;
        end;

        Inc(n);
      end;
    end;

    Inc(shapeNum);
  end;
end;

function TShapeObj.GetPolylineShapeClosestToPoint(x, y, z : double): integer;
var
  dist, minDist, xp, yp, zp : double;
  n, shapeNum : integer;
begin
  Result := -1;

  minDist := 100000000.0;

  shapeNum := 0;
  while shapeNum < FNumEntities do
  begin
    ReadShape(shapeNum);
    if (FSingleInstanceShapeType > 0) and
       (x - FOffsetX >= FXMin) and (x - FOffsetX <= FXMax) and
       (y - FOffsetY >= FYMin) and (y - FOffsetY <= FYMax) and
       (z >= FZMin) and (z <= FZMax)then
    begin
      n := 0;
      while n < FNumPoints do
      begin
        xp := FXYArray[n].x;
        yp := FXYArray[n].y;
        zp := FZArray[n];

        dist := (xp - x) * (xp - x) + (yp - y) * (yp - y) +
                (zp - z) * (zp - z);
        if dist < minDist then
        begin
          minDist := dist;
          Result := shapeNum;
        end;

        Inc(n);
      end;
    end;

    Inc(shapeNum);
  end;
end;

function TShapeObj.GetClosestShapePoint(x, y, z, m : double): integer;
var
  dist, xc, yc, zc, mc : double;
  i, shapeNum : integer;
begin
  Result := GetClosestShape(x, y, z);
  if Result < 0 then Exit;

  shapeNum := Result;
  
  dist := 100000000.0;

  ReadShape(shapeNum);

  if FSingleInstanceShapeType > 0 then
  begin
    i := 0;
    case FShapeType of
      1 :
      begin
        Exit;
      end;
      11 :
      begin
        Exit;
      end;
      21 :
      begin
        Exit;
      end;
      else
      begin
        while i < FNumPoints do
        begin
          xc := FXYArray[i].x;
          yc := FXYArray[i].y;

          case FShapeType of
            3, 5, 8 :
            begin
              if (xc - x) * (xc - x) + (yc - y) * (yc - y) < dist then
              begin
                dist := (xc - x) * (xc - x) + (yc - y) * (yc - y);
                Result := i;
              end;
            end;
            13, 15, 18 :
            begin
              zc := FZArray[i];

              if (xc - x) * (xc - x) + (yc - y) * (yc - y) + (zc - z) * (zc - z) < dist then
              begin
                dist := (xc - x) * (xc - x) + (yc - y) * (yc - y) + (zc - z) * (zc - z);
                Result := i;
              end;
            end;
            23, 25, 28 :
            begin
              mc := FMArray[i];

              if (xc - x) * (xc - x) + (yc - y) * (yc - y) + (mc - m) * (mc - m) < dist then
              begin
                dist := (xc - x) * (xc - x) + (yc - y) * (yc - y) + (mc - m) * (mc - m);
                Result := i;
              end;
            end;
          end;

          Inc(i);
        end;
      end;
    end;
  end;
{
ShapeType     Value
Null Shape       0
Point            1
PolyLine         3
Polygon          5
MultiPoint       8
PointZ          11
PolyLineZ       13
PolygonZ        15
MultiPointZ     18
PointM          21
PolyLineM       23
PolygonM        25
MultiPointM     28
MultiPatch      31
}
end;
// write shape

// misc
function TShapeObj.EndianLong(L : integer) : integer;
begin
  result := swap(L shr 16) or
           (integer(swap(L and $ffff)) shl 16);
end;

function TShapeObj.EndianDouble(D : double) : double;
var
  i : integer;
  a, c: EndianCnvRec;

  procedure SwapBytes(A, C: PEndianCnvRec);
  var
    i : integer;
    b : byte;
  begin
    for i := high(A.Bytes) downto low(A.Bytes) do
    begin
      b := A.Bytes[i];
      C.Bytes[7 - i] := b;
    end;
  end;

begin
  a.EndianVal := D;
  SwapBytes(@c,@a);
  D := c.EndianVal;
end;

procedure TShapeObj.SetMode(const Value: string);
begin
  FMode := Value;
end;

procedure TShapeObj.SetShapeType(const Value: integer);
begin
  FShapeType := Value;
end;

procedure TShapeObj.TwinkleSelectedShape(ShapeNum, numTimes : integer);
var
 pc, bc : TColor;
 pw : integer;
begin
  pw := FPenWidth;
  pc := FPenColor;
  bc := FBrushColor;

{  FPenWidth := PenWidth;
  FPenColor := FSelectionColor;
  FBrushColor := FSelectionColor;}

  TwinkleShape(ShapeNum, numTimes);

  FPenWidth := pw;
  FPenColor := pc;
  FBrushColor := bc;

  DrawShape(ShapeNum);
end;

procedure TShapeObj.DrawShape(Canvas: TCanvas; ShapeNum,
  PenWidth: integer; PenColor, BrushColor: TColor; outlineOnly : boolean;
  pointsAlso : boolean = false);
var
 pc, bc : TColor;
 pw : integer;
begin
  pw := FPenWidth;
  pc := FPenColor;
  bc := FBrushColor;

  FCanvas := Canvas;
  FPenWidth := PenWidth;
  FPenColor := PenColor;
  FBrushColor := BrushColor;
  FPointsAlso := pointsAlso;

  DrawShape(ShapeNum, outlineOnly);

  FPenWidth := pw;
  FPenColor := pc;
  FBrushColor := bc;
end;

procedure TShapeObj.DrawShapePart(Canvas: TCanvas; ShapeNum, PartNum,
  PenWidth: integer; PenColor, BrushColor: TColor; outlineOnly: boolean;
  pointsAlso : boolean = false);
var
  i : integer;
  pPoints : TPoints;
begin
  FCanvas.Pen.Width := PenWidth;
  FCanvas.Pen.Color := PenColor;
  FCanvas.Brush.Color := BrushColor;
  FPointsAlso := pointsAlso;

  ReadShape(ShapeNum);
  if (PartNum >= 0) and (PartNum < FNumParts) and
     (FSingleInstanceShapeType > 0) and
     ((FShapeType = 3) or (FShapeType = 5) or
      (FShapeType = 13) or (FShapeType = 15) or
      (FShapeType = 23) or (FShapeType = 55)) then
  begin
    ReadShapePart(PartNum);

    SetLength(pPoints, SizeOf(TPoint) * numPoints);
    try
      i := 0;
      while i < FPartNumPoints do
      begin
        x := FPartXYArray[i].x;
        y := FPartXYArray[i].y;

        if FWorldViewPortRoutines = nil then
        begin
          pPoints[i].X := FWorldViewPortRoutines.vx(x);
          pPoints[i].Y := FWorldViewPortRoutines.vy(y);
        end
        else
        begin
          pPoints[i].X := FWorldViewPortRoutines.vx(x);
          pPoints[i].Y := FWorldViewPortRoutines.vy(y);
        end;

        Inc(i);
      end;

      if not Transparent then
      begin
        case FShapeType of
          3, 13, 23 :
            FCanvas.Polyline(Slice(pPoints, FPartNumPoints));
          5, 15, 25 :
          begin
            if outlineOnly then
              FCanvas.Polyline(Slice(pPoints, FPartNumPoints))
            else
              FCanvas.Polygon(Slice(pPoints, FPartNumPoints));
          end;
        end;
      end
      else
        FCanvas.Polyline(Slice(pPoints, FPartNumPoints));

      if FPointsAlso then
      begin
        FCanvas.Pen.Color := clRed;
        FCanvas.Brush.Color := clRed;
        i := 0;
        while i < FPartNumPoints do
        begin
          FCanvas.Ellipse(
            pPoints[i].X - 3, pPoints[i].Y - 3,
            pPoints[i].X + 3, pPoints[i].Y + 3);

          Inc(i);
        end;
      end;
      FCanvas.Pen.Color := FPenColor;
      FCanvas.Brush.Color := BrushColor;
    finally
      pPoints := nil;
    end;
  end;
end;

procedure TShapeObj.DrawShape(Canvas: TCanvas; shapeNum: integer; outlineOnly : boolean);
begin
  FCanvas := Canvas;
  DrawShape(ShapeNum, outlineOnly);
end;

procedure TShapeObj.DrawShape(shapeNum: integer);
begin
  DrawShape(shapeNum, false);
end;

procedure TShapeObj.DrawShape(shapeNum: integer; outlineOnly : boolean);
var
  i, k, ktot, l, p, index, numPoints, isl : integer;
  pPoints : TPoints;
  x, y, z, m : double;
begin
  if (shapeNum < 0) or (shapeNum >= FNumEntities) then Exit;
  
  if FCanvas = nil then Exit;

  FCanvas.Pen.Width := FPenWidth;
  FCanvas.Pen.Color := FPenColor;
  FCanvas.Brush.Color := FBrushColor;

  try
    ReadShape(shapeNum);
    if (FSingleInstanceShapeType > 0) or (not FDrawNonDeletedShapesOnly) then
    begin
      case FShapeType of
        1, 11, 21 :
          begin
            if outlineOnly then
            begin
              if FWorldViewPortRoutines = nil then
                FCanvas.Arc(Round(FWorldViewPortRoutines.vx(FOffsetX + Fx)) - 5,
                            Round(FWorldViewPortRoutines.vy(FOffsetY + Fy)) - 5,
                            Round(FWorldViewPortRoutines.vx(FOffsetX + Fx)) + 5,
                            Round(FWorldViewPortRoutines.vy(FOffsetY + Fy)) + 5,
//                FCanvas.Arc(Round(Fx) - 5, Round(Fy) - 5, Round(Fx) + 5, Round(Fy) + 5,
                  0, 5760)
              else
                FCanvas.Arc(
                  FWorldViewPortRoutines.vx(FOffsetX + Fx) - 5,
                  FWorldViewPortRoutines.vy(FOffsetY + Fy) - 5,
                  FWorldViewPortRoutines.vx(FOffsetX + Fx) + 5,
                  FWorldViewPortRoutines.vy(FOffsetY + Fy) + 5,
{                  FWorldViewPortRoutines.vx(Fy) - 5, FWorldViewPortRoutines.vy(Fx) - 5,
                  FWorldViewPortRoutines.vx(Fy) + 5, FWorldViewPortRoutines.vy(Fx) + 5,}
                  0, 5760);
            end
            else
            begin
              if FWorldViewPortRoutines = nil then
                FCanvas.Ellipse(Round(FWorldViewPortRoutines.vx(FOffsetX + Fx)) - 5,
                                Round(FWorldViewPortRoutines.vy(FOffsetY + Fy)) - 5,
                                Round(FWorldViewPortRoutines.vx(FOffsetX + Fx)) + 5,
                                Round(FWorldViewPortRoutines.vy(FOffsetY + Fy)) + 5)
//                FCanvas.Ellipse(Round(Fx) - 5, Round(Fy) - 5, Round(Fx) + 5, Round(Fy) + 5)
              else
                FCanvas.Ellipse(
                  FWorldViewPortRoutines.vx(FOffsetX + Fx) - 5,
                  FWorldViewPortRoutines.vy(FOffsetY + Fy) - 5,
                  FWorldViewPortRoutines.vx(FOffsetX + Fx) + 5,
                  FWorldViewPortRoutines.vy(FOffsetY + Fy) + 5);
{                  FWorldViewPortRoutines.vx(Fy) - 5, FWorldViewPortRoutines.vy(Fx) - 5,
                  FWorldViewPortRoutines.vx(Fy) + 5, FWorldViewPortRoutines.vy(Fx) + 5);}
            end;
          end;
        3, 5, 13, 15, 23, 25 :
          begin
            l := 0;
            p := 0;

            ktot := 0;
            for i := 0 to FNumParts - 1 do
            begin
              if l > 7 then
                l := 0;

              if p > 4 then
                p := 0;

              if FNumParts = 1 then
              begin
                numPoints := FNumPoints;
//                FParts[i + 1] := numPoints + 1;
              end
//                numPoints := FNumPoints
              else if i < FNumParts - 1 then
                numPoints := FParts[i + 1] -
                  FParts[i]
              else
                numPoints := FNumPoints -
                  FParts[i];

              try
                SetLength(pPoints, SizeOf(TPoint) * numPoints);

                try
                  index := FParts[i];
                  k := 0;
                  while (k < numPoints) do
                  begin
                    x := FOffsetX + FXYArray[index + k].x;
                    y := FOffsetY + FXYArray[index + k].y;

                    if FWorldViewPortRoutines = nil then
                    begin
                      pPoints[k].X := FWorldViewPortRoutines.vx(x);
                      pPoints[k].Y := FWorldViewPortRoutines.vy(y);
{                      pPoints[k].X := FWorldViewPortRoutines.vx(y);
                      pPoints[k].Y := FWorldViewPortRoutines.vy(x);}
                    end
                    else
                    begin
                      pPoints[k].X := FWorldViewPortRoutines.vx(x);
                      pPoints[k].Y := FWorldViewPortRoutines.vy(y);
{                      pPoints[k].X := FWorldViewPortRoutines.vx(y);
                      pPoints[k].Y := FWorldViewPortRoutines.vy(x);}
                    end;

                    k := k + 1;
                    ktot := ktot + 1;
                  end;

                  if not Transparent then
                  begin
                    case FShapeType of
                      3, 13, 23 :
                        FCanvas.Polyline(Slice(pPoints, k));
                      5, 15, 25 :
                      begin
                        if outlineOnly then
                          FCanvas.Polyline(Slice(pPoints, k))
                        else
                          FCanvas.Polygon(Slice(pPoints, k));
                      end;
                    end;
                  end
                  else
                    FCanvas.Polyline(Slice(pPoints, k));
                except
                end;

                if FPointsAlso then
                begin
                  FCanvas.Pen.Color := clRed;
                  FCanvas.Brush.Color := clRed;
                  k := 0;
                  while k < numPoints do
                  begin
                    FCanvas.Ellipse(
                      pPoints[k].X - 3, pPoints[k].Y - 3,
                      pPoints[k].X + 3, pPoints[k].Y + 3);

                    Inc(k);
                  end;
                end;
                FCanvas.Pen.Color := FPenColor;
                FCanvas.Brush.Color := BrushColor;
              finally
                pPoints := nil;
              end;

              l := l + 1;
              p := p + 1;
            end;
          end;
        8, 18, 28 :
          begin
            p := 0;

            for i := 0 to FNumPoints - 1 do
            begin
              if p > 4 then
                p := 0;

//              x := FOffsetX + FXYArray[i].x;
//              y := FOffsetY + FXYArray[i].y;

              if outlineOnly then
              begin
                if FWorldViewPortRoutines = nil then
                  FCanvas.Arc(Round(FWorldViewPortRoutines.vx(FOffsetX + Fx)) - 5,
                              Round(FWorldViewPortRoutines.vy(FOffsetY + Fy)) - 5,
                              Round(FWorldViewPortRoutines.vx(FOffsetX + Fx)) + 5,
                              Round(FWorldViewPortRoutines.vy(FOffsetY + Fy)) + 5,
//                  FCanvas.Arc(Round(Fx) - 5, Round(Fy) - 5, Round(Fx) + 5, Round(Fy) + 5,
                    0, 5760)
                else
                  FCanvas.Arc(
                    FWorldViewPortRoutines.vx(FOffsetX + Fx) - 5,
                    FWorldViewPortRoutines.vy(FOffsetY + Fy) - 5,
                    FWorldViewPortRoutines.vx(FOffsetX + Fx) + 5,
                    FWorldViewPortRoutines.vy(FOffsetY + Fy) + 5,
{                    FWorldViewPortRoutines.vx(Fy) - 5, FWorldViewPortRoutines.vy(Fx) - 5,
                    FWorldViewPortRoutines.vx(Fy) + 5, FWorldViewPortRoutines.vy(Fx) + 5,}
                    0, 5760);
              end
              else
              begin
                if FWorldViewPortRoutines = nil then
                  FCanvas.Ellipse(Round(FWorldViewPortRoutines.vx(FOffsetX + x)) - 5,
                                  Round(FWorldViewPortRoutines.vy(FOffsetY + y)) - 5,
                                  Round(FWorldViewPortRoutines.vx(FOffsetX + x)) + 5,
                                  Round(FWorldViewPortRoutines.vy(FOffsetY + y)) + 5)
//                  FCanvas.Ellipse(Round(x) - 5, Round(y) - 5, Round(x) + 5, Round(y) + 5)
                else
                  FCanvas.Ellipse(
                    FWorldViewPortRoutines.vx(FOffsetX + x) - 5,
                    FWorldViewPortRoutines.vy(FOffsetY + y) - 5,
                    FWorldViewPortRoutines.vx(FOffsetX + x) + 5,
                    FWorldViewPortRoutines.vy(FOffsetY + y) + 5);
{                    FWorldViewPortRoutines.vx(y) - 5, FWorldViewPortRoutines.vy(x) - 5,
                    FWorldViewPortRoutines.vx(y) + 5, FWorldViewPortRoutines.vy(x) + 5);}
              end;

              p := p + 1;
            end;
          end;
      end;
    end;
  except
  end;
end;

procedure TShapeObj.DrawShapes(Canvas: TCanvas; PenWidth: integer;
  PenColor, BrushColor: TColor; outlineOnly : boolean = false;
  pointsAlso : boolean = false);
var
  n : integer;
begin
  FCanvas := Canvas;

  for n := 0 to FNumEntities - 1 do
    DrawShape(Canvas, n, PenWidth, PenColor, BrushColor, outlineOnly,
      pointsAlso);
end;

procedure TShapeObj.DrawShapes(Canvas: TCanvas);
var
  n : integer;
begin
  FCanvas := Canvas;

  for n := 0 to FNumEntities - 1 do
    DrawShape(Canvas, n);
end;

procedure TShapeObj.DrawShapes;
var
  n : integer;
begin
  if FCanvas = nil then Exit;

  for n := 0 to FNumEntities - 1 do
    DrawShape(n);
end;

procedure TShapeObj.SetCanvas(const Value: TCanvas);
begin
  FCanvas := Value;
end;

procedure TShapeObj.SetWorldViewPortRoutines(
  const Value: TWorldViewPortRoutines);
begin
  FWorldViewPortRoutines := Value;
end;

procedure TShapeObj.SetBrushColor(const Value: TColor);
begin
  FBrushColor := Value;
end;

procedure TShapeObj.SetPenColor(const Value: TColor);
begin
  FPenColor := Value;
end;

procedure TShapeObj.SetPenWidth(const Value: integer);
begin
  FPenWidth := Value;
end;

function TShapeObj.GetShapeFileDir: string;
begin
  Result := ExtractFilePath(FShapeFileName);
  FShapeFileDir := Result;
end;

function TShapeObj.GetShapeFileName : string;
begin
  Result := ExtractFileName(FShapeFileName);
end;

procedure TShapeObj.TwinkleShape(numTimes: integer);
var
  i, n : integer;
  PenColor, BrushColor : TColor;
begin
  if FCanvas = nil then Exit;

  try
    PenColor := FPenColor;
    BrushColor := FBrushColor;

    for i := 0 to numTimes - 1 do
    begin
      FPenColor := clBtnFace;
      FBrushColor := clBtnFace;
      for n := 0 to FNumEntities - 1 do
        DrawShape(n);

      Sleep(150);

      FPenColor := PenColor;
      FBrushColor := BrushColor;
      for n := 0 to FNumEntities - 1 do
        DrawShape(n);

      Sleep(150);
    end;
  finally
    FPenColor := PenColor;
    FBrushColor := BrushColor;
  end;
end;

procedure TShapeObj.TwinkleShape(shapeNum, numTimes: integer);
var
  i, n : integer;
  PenColor, BrushColor : TColor;
begin
  if FCanvas = nil then Exit;

  try
    PenColor := FPenColor;
    BrushColor := FBrushColor;

    for i := 0 to numTimes - 1 do
    begin
      FPenColor := FSelectionColor;
      FBrushColor := FSelectionColor;
{      FPenColor := clBtnFace;
      FBrushColor := clBtnFace;}
      DrawShape(shapeNum);

      Sleep(150);

      FPenColor := PenColor;
      FBrushColor := BrushColor;
      DrawShape(shapeNum);

      Sleep(150);
    end;
  finally
    FPenColor := PenColor;
    FBrushColor := BrushColor;
  end;
end;

function TShapeObj.UpdateArcPolyShape(shapeNum: integer; x, y, z, m: double): integer;
begin
  if (shapeNum < 0) or (shapeNum >= FNumEntities) then Exit;


end;

function TShapeObj.UpdateArcPolyShapeZValue(shapeNum: integer; z: double): boolean;
var
  i, k, ktot, l, p, index, numPoints, isl : integer;
  pPoints : TPoints;
  namn, mode : string;
  x, y : double;
begin
  Result := false;

  if (shapeNum < 0) or (shapeNum >= FNumEntities) then Exit;
  
  FUpdateArcPolyShapeZValue := true;

  ReadShape(shapeNum);

  ktot := 0;
  for i := 0 to FNumParts - 1 do
  begin
    if l > 7 then
    l := 0;

    if p > 4 then
    p := 0;

    if FNumParts = 1 then
    begin
    numPoints := FNumPoints;
    FParts[i + 1] := numPoints + 1;
    end
  //                numPoints := FNumPoints
    else if i < FNumParts - 1 then
    numPoints := FParts[i + 1] -
      FParts[i]
    else
    numPoints := FNumPoints -
      FParts[i];

    try
      SetLength(pPoints, SizeOf(TPoint) * numPoints);

      try
        index := FParts[i];
        k := 0;
        while (ktot < FNumPoints) and
  //                    (index + k < FParts[i]) and
      		      (index + k < FParts[i + 1]) do
        begin
      	  FZArray[index + k] := z;

      	  k := k + 1;
      	  ktot := ktot + 1;
        end;
      except
      end;
    finally
      pPoints := nil;

      namn := FShapeFileName;
      mode := FMode;
      FZ := z;
      FZMin := FZ;
      FZMax := FZ;
      FZMinTot := FZ;
      FZMaxTot := FZ;
      FShapeFile.Position := FZArrayStartPos;
      FShapeFile.Write(FZArray[0], (SizeOf(double)) * FNumPoints);
      FMainFileHeader.zMax := FZ;
      FMainFileHeader.zMin := FZ;
      FIndexFileHeader.zMax := FZ;
      FIndexFileHeader.zMin := FZ;
      Close;
      FUpdateArcPolyShapeZValue := false;
//      Open(namn, mode);
      Result := true;
    end;
  end;
end;

function TShapeObj.UpdateMultiPointShape(shapeNum: integer; x, y, z, m: double): integer;
begin
  if (shapeNum < 0) or (shapeNum >= FNumEntities) then Exit;
  

end;

function TShapeObj.UpdatePointShape(shapeNum: integer; x, y, z, m: double): integer;
var
  xold, yold : double;
  recnum, contentLength : integer;
begin
  if (shapeNum < 0) or (shapeNum >= FNumEntities) then Exit;
  
  FShapeFile.Position := FIndexRecordsArray[shapeNum].Offset;

  FShapeFile.Read(FRecordHeader, SizeOf(TRecordHeader));
  recnum := FRecordHeader.RecordNumber;
  FRecordNumber := SwapEndian(recnum);
  contentLength := FRecordHeader.ContentLength;
  FContentLength := SwapEndian(contentLength);

  FShapeFile.Read(FSingleInstanceShapeType, SizeOf(FShapeType));

  FX := x;
  FY := y;
  FZ := z;
  FM := m;

  FShapeFile.Write(FX, SizeOf(FX));
  FShapeFile.Write(FY, SizeOf(FY));

  if FShapeType = 11 then
    FShapeFile.Write(FZ, SizeOf(FZ));

  if FShapeType = 21 then
    FShapeFile.Write(FM, SizeOf(FM));
end;

procedure TShapeObj.UpdateShape(shapeNum: integer; x, y, z, m: double);
begin
  if (shapeNum < 0) or (shapeNum >= FNumEntities) then Exit;

  case FShapeType of
    0 :
    begin
    end;
    1, 11, 21 :
      UpdatePointShape(shapeNum, x, y, z, m);
    3, 5, 13, 15, 23, 25 :
      UpdateArcPolyShape(shapeNum, x, y, z, m);
    8, 18, 28 :
      UpdateMultiPointShape(shapeNum, x, y, z, m);
  end;
end;

{procedure TShapeObj.UpdateShape(x, y, z : double);
var
  n : integer;
 xd, yd, zd, md : double;
begin
  xd := (FMainFileHeader.xMax + FMainFileHeader.xMin) / 2 - x;
  yd := (FMainFileHeader.yMax + FMainFileHeader.yMin) / 2 - y;
  if z = FNullValue then
    zd := 0
  else
    zd := (FMainFileHeader.zMax + FMainFileHeader.zMin) / 2 - z;
  if m = FNullValue then
    md := 0
  else
    md := (FMainFileHeader.mMax + FMainFileHeader.mMin) / 2 - m;
  for n := 0 to FNumEntities - 1 do
  begin
    ReadShape(n);
    UpdateShape(n, FX - xd, FY - yd, FZ - zd, FM - md);
  end;

  UpdateTotalAndCurrentMaxMinValues(x, y, z, m);
end;}

procedure TShapeObj.MoveShape(x, y, z: double);
var
  n : integer;
 xd, yd, zd, md : double;
begin
  xd := x - (FMainFileHeader.xMax + FMainFileHeader.xMin) / 2;
  yd := y - (FMainFileHeader.yMax + FMainFileHeader.yMin) / 2;
  if z = FNullValue then
    zd := 0
  else
    zd := z - (FMainFileHeader.zMax + FMainFileHeader.zMin) / 2;
  if m = FNullValue then
    md := 0
  else
    md := m - (FMainFileHeader.mMax + FMainFileHeader.mMin) / 2;
  for n := 0 to FNumEntities - 1 do
  begin
    ReadShape(n);
    UpdateShape(n, FX + xd, FY + yd, FZ + zd, FM + md);
  end;

  UpdateTotalAndCurrentMaxMinValues(x, y, z, m);
end;

procedure TShapeObj.SetCurrentShapeNum(const Value: integer);
begin
  FCurrentShapeNum := Value;
end;

procedure TShapeObj.ReCalculateHeaderBoundingBoxes;
var
  i : integer;
  x, y, z, m : double;
begin
  FXMin := 100000000;
  FYMin := 100000000;
  FZMin := 100000000;
  FMMin := 100000000;
  FXMax := -100000000;
  FYMax := -100000000;
  FZMax := -100000000;
  FMMax := -100000000;

  UpdateHeaderBoundingBoxes;
end;

procedure TShapeObj.UpdateHeaderBoundingBoxes;
var
  i : integer;
  x, y, z, m : double;
begin
  for i := 0 to FNumEntities - 1 do
  begin
    ReadShape(i);

    if FSingleInstanceShapeType > 0 then
    begin
      UpdateTotalAndCurrentMaxMinValues(FXMin, FYMin, FZMin, FMMin);
      UpdateTotalAndCurrentMaxMinValues(FXMax, FYMax, FZMax, FMMax);
    end;
  end;
end;

function TShapeObj.HitTest(x, y: double): integer;
var
  i : integer;
begin
  Result := -1;

  if (FShapeType = 1) or (FShapeType = 8) or
     (FShapeType = 11) or (FShapeType = 18) or
     (FShapeType = 21) or (FShapeType = 28) then
  begin
    Result := GetClosestShape(x, y, 0);
    Exit;
  end
  else if (FShapeType = 3) or (FShapeType = 13) or (FShapeType = 23) then
  begin
    Result := GetPolylineShapeClosestToPoint(x, y);
    Exit;
  end;

  i := FNumEntities - 1;
  while i >= 0 do
{  i := 0;
  while i < FNumEntities do}
  begin
    ReadShape(i);

    if (FSingleInstanceShapeType <> 0) and (FSingleInstanceShapeType <> 1) and
       (FSingleInstanceShapeType <> 8) and (FSingleInstanceShapeType <> 11) and
       (FSingleInstanceShapeType <> 18) and (FSingleInstanceShapeType <> 21) and
       (FSingleInstanceShapeType <> 28) and (FSingleInstanceShapeType <> 31) and
       (x >= FXMin) and  (x <= FXMax) and
       (y >= FYMin) and  (y <= FYMax) then
    begin
      if PtInPoly(FXYArray, FNumPoints, x, y) then
      begin
        Result := i;
        Exit;
      end;
    end;

    Dec(i);
//    Inc(i);
  end;
end;

function TShapeObj.PtInPoly(const Points: doubleXYArray; NumPoints : integer;
  X, Y: double): Boolean;
var
  K, J : Integer;
begin
  Result := false;

  if (x - FOffsetX < FXMin) or (x - FOffsetX > FXMax) or
     (y - FOffsetY < FYMin) or (y - FOffsetY > FYMax) then Exit;

  J := NumPoints - 1;
  for K := 0 to NumPoints - 1 do
  begin
    if ((Points[K].Y <= Y - FOffsetY) and (Y - FOffsetY < Points[J].Y)) or
       ((Points[J].Y <= Y - FOffsetY) and (Y - FOffsetY < Points[K].Y)) then
    begin
      if (x - FOffsetX < (Points[J].X - Points[K].X) * (y - FOffsetY - Points[K].Y) /
                (Points[J].Y - Points[K].Y) + Points[K].X) then
        Result := not Result;
    end;

    J := K;
  end;
end;

procedure TShapeObj.SetSelectionColor(const Value: TColor);
begin
  FSelectionColor := Value;
end;

procedure TShapeObj.SetTransparent(const Value: boolean);
begin
  FTransparent := Value;
end;

{$R-}
function TShapeObj.Buffer(Mode: string; Width: double) : string;
var
  ShapeObj : TShapeObj;
  direction, temp : string;
  t : double;
  x1, y1, x2, y2, x3, y3 : double;
  x1Offset, y1Offset, x2Offset, y2Offset : double;
  x3Offset, y3Offset, x4Offset, y4Offset : double;
  bufferList : TList;
  bufferPoint : ^doubleXY;
  bufferCoords : doubleXYArray;
  numBufferPoints : integer;
  xyPoint : ^doubleXY;
  i, originalPointNum : integer;
  angle, cosa, sina, bufferDistance : double;
  xBuffer, yBuffer : double;
  x1Orig, y1Orig, x2Orig, y2Orig, x3Orig, y3Orig : double;
  x1Buffer, y1Buffer, x2Buffer, y2Buffer, x3Buffer, y3Buffer : double;
  origAngle, angleBetweenBufferSegments, angleDiff : double;

  function GetAngleForLineSegment(x1, y1, x2, y2 : double) : double;
  begin
    if x1 = x2 then
      Result := Pi / 2.0
    else
      Result := arctan2(y2 - y1, x2 - x1);
  end;

  function AngleBetweenLineSegments(x11, y11, x12, y12, x21, y21, x22, y22 : double) : double;
  var
    Angle1, Angle2 : double;
  begin
    Angle1 := GetAngleForLineSegment(x11, y11, x12, y12);
    Angle2 := GetAngleForLineSegment(x21, y21, x22, y22);
    Result := Angle2 - Angle1;
  end;

  procedure GetOffsetSegment(x1, y1, x2, y2 : double;
    var x1Offset, y1Offset, x2Offset, y2Offset : double);
  var
    n, xd, yd, v, k, kn : double;
    riktn : integer;

    function OffsetSegmentIsWithinPolygon : boolean;
    var
      xliten1, yliten1, xliten2, yliten2, x, y, delta : double;
    begin
// beräkna en punkt längs antagen normalriktning mycket nära akt. segment
// för att bestämma om denna ligger inom eller utanför akt. polygon
// punkten måste ligga mycket nära akt. segment för att vid stor offset,
// i förhållande till polygonstorleken, undvika att beräknad punkt kommer att
// ligga utanför fastän normalen är riktad inåt polygonen

// beräkna alltså ett offsetsegment mycket nära akt. polygonsegment och
// bestäm om dess mittpunkt ligger inom eller utanför akt. polygon
      delta := 0.1;
      xliten1 := x1 + riktn * delta;
      yliten1 := y1 + riktn * delta;
      xliten2 := x2 + riktn * delta;
      yliten2 := y2 + riktn * delta;
      x := (xliten1 + xliten2) / 2.0;
      y := (yliten1 + yliten2) / 2.0;
      if PtInPoly(FXYArray, FNumPoints, x, y) then
        Result := true
      else
        Result := false;
    end;
    
  begin
    if x1 = x2 then
    begin
      xd := Width;
      yd := 0;
    end
    else if y1 = y2 then
    begin
      xd := 0;
      yd := Width;
    end
    else
    begin
// beräkna akt. offsetsegments k-värde
      k := (y2 - y1) / (x2 - x1);
// beräkna k-värde för normalen
      kn := -1 / k;
      v := arctan(kn);
      xd := Width * cos(v);
      yd := Width * sin(v);
    end;

    if direction = 'IN' then
      riktn := 1
    else
      riktn := -1;

    x1Offset := x1 + riktn * xd;
    y1Offset := y1 + riktn * yd;
    x2Offset := x2 + riktn * xd;
    y2Offset := y2 + riktn * yd;

    if (direction = 'IN') and
       (not OffsetSegmentIsWithinPolygon){ or
       (direction = 'OUT') and
       (OffsetSegmentIsWithinPolygon)} then
    begin
      riktn := -riktn;
      x1Offset := x1 + riktn * xd;
      y1Offset := y1 + riktn * yd;
      x2Offset := x2 + riktn * xd;
      y2Offset := y2 + riktn * yd;
    end;

    if {(direction = 'IN') and
       (not OffsetSegmentIsWithinPolygon) or}
       (direction = 'OUT') and
       (OffsetSegmentIsWithinPolygon) then
    begin
      riktn := -riktn;
      x1Offset := x1 + riktn * xd;
      y1Offset := y1 + riktn * yd;
      x2Offset := x2 + riktn * xd;
      y2Offset := y2 + riktn * yd;
    end;
  end;

  function DetermineIntersection(const x1, y1, x2, y2 : extended;
    const x3, y3, x4, y4 : extended; var xs, ys: double): boolean;
  var
    a1, a2, b1, b2, c1, c2 : extended; { Coefficients of line eqns.}
    denom : extended;
  begin
    a1 := y2 - y1;
    b1 := x1 - x2;
    c1 := x2 * y1 - x1 * y2;  { a1*x + b1*y + c1 = 0 is line 1 }

    a2 := y4 - y3;
    b2 := x3 - x4;
    c2 := x4 * y3 - x3 * y4;  { a2*x + b2*y + c2 = 0 is line 2 }

    denom := a1 * b2 - a2 * b1;
    if denom = 0 then
    begin
      Result := false;
      exit;
    end;

    xs := (b1 * c2 - b2 * c1) / denom;
    ys := (a2 * c1 - a1 * c2) / denom;
    Result := true;
  end;

  {function BufferPointIsOnSegment(x1, x2, xBuffer : double) : boolean;
  begin
    if (abs(xBuffer - x1Offset) <= abs(x2Offset - x1Offset)) and
       (abs(yBuffer - y1Offset) <= abs(y2Offset - y1Offset)) then
      Result := true
    else
      Result := false;
  end;

  procedure CalculateAndSaveArcBetweenOffsetSegments;
  var
    vstart, vd, v, xd, yd, xBuffer, yBuffer : double;
    i, riktn : integer;
  begin
    if direction = 'IN' then
      riktn := 1
    else
      riktn := -1;

// beräkna startvinkel som är normalriktningen för 1:sta offsetsegmentet
// av de 2 aktuella offsetsegmenten
    vstart := GetAngleForLineSegment(x2, y2, x2Offset, y2Offset);

    v := vstart;
    vd := angle / 10;
    i := 0;
    while i < 9 do
    begin
      xd := Width * cos(v);
      yd := Width * sin(v);
      xBuffer := x2 + xd;
      yBuffer := y2 + yd;
      if (PtInPoly(FXYArray, FNumPoints, xBuffer, yBuffer) and
         (riktn = -1)) or
         (not PtInPoly(FXYArray, FNumPoints, xBuffer, yBuffer) and
         (riktn = 1))  then
      begin
        xBuffer := x2 - xd;
        yBuffer := y2 - yd;
      end;
      
      New(xyPoint);
      xyPoint^.x := xBuffer;
      xyPoint^.y := yBuffer;
      bufferList.Add(xyPoint);

      v := v + vd;
      i := i + 1;
    end;

// lägg till offsetpunkt 3 som bufferpunkt
    New(xyPoint);
    xyPoint^.x := x3Offset;
    xyPoint^.y := y3Offset;
    bufferList.Add(xyPoint);
  end;}

  function originalAngle(angleNumber : integer) : double;
  var
    x1, y1, x2, y2, x3, y3 : double;
  begin
    if angleNumber - 1 >= 0 then
    begin
      x1 := FXYArray[angleNumber - 1].x;
      y1 := FXYArray[angleNumber - 1].y;
    end
    else
    begin
      x1 := FXYArray[FNumPoints - 2].x;
      y1 := FXYArray[FNumPoints - 2].y;
    end;
    x2 := FXYArray[angleNumber].x;
    y2 := FXYArray[angleNumber].y;
    x3 := FXYArray[angleNumber + 1].x;
    y3 := FXYArray[angleNumber + 1].y;

    Result :=
      AngleBetweenLineSegments(x1, y1, x2, y2,
        x2, y2, x3, y3);

{    AddToLogFile('Vinkelberäkning originalpolygon' + CRLF +
      'originalpolygon-angleNumber:' + IntToStr(angleNumber) + CRLF +
      'x1:' + FloatToStrF(x1, ffFixed, 15, 2) + ' ' +
      'y1:' + FloatToStrF(y1, ffFixed, 15, 2) + CRLF +
      'x2:' + FloatToStrF(x2, ffFixed, 15, 2) + ' ' +
      'y2:' + FloatToStrF(y2, ffFixed, 15, 2) + CRLF +
      'x3:' + FloatToStrF(x3, ffFixed, 15, 2) + ' ' +
      'y3:' + FloatToStrF(y3, ffFixed, 15, 2));}
  end;

  function bufferAngle(angleNumber : integer) : double;
  begin
    if angleNumber - 1 >= 0 then
    begin
      x1Buffer := bufferCoords[angleNumber - 1].x;
      y1Buffer := bufferCoords[angleNumber - 1].y;
    end
    else
    begin
      x1Buffer := bufferCoords[FNumPoints - 2].x;
      y1Buffer := bufferCoords[FNumPoints - 2].y;
    end;
    x2Buffer := bufferCoords[angleNumber].x;
    y2Buffer := bufferCoords[angleNumber].y;
    x3Buffer := bufferCoords[angleNumber + 1].x;
    y3Buffer := bufferCoords[angleNumber + 1].y;

    Result :=
      AngleBetweenLineSegments(x1Buffer, y1Buffer, x2Buffer, y2Buffer,
        x2Buffer, y2Buffer, x3Buffer, y3Buffer);

{    AddToLogFile('Vinkelberäkning bufferpolygon' + CRLF +
      'bufferpolygon-angleNumber:' + IntToStr(angleNumber) + CRLF +
      'x1Buffer:' + FloatToStrF(x1Buffer, ffFixed, 15, 2) + ' ' +
      'y1Buffer:' + FloatToStrF(y1Buffer, ffFixed, 15, 2) + CRLF +
      'x2Buffer:' + FloatToStrF(x2Buffer, ffFixed, 15, 2) + ' ' +
      'y2Buffer:' + FloatToStrF(y2Buffer, ffFixed, 15, 2) + CRLF +
      'x3Buffer:' + FloatToStrF(x3Buffer, ffFixed, 15, 2) + ' ' +
      'y3Buffer:' + FloatToStrF(y3Buffer, ffFixed, 15, 2)); }
  end;

  function CalculateBufferPoint : boolean;
  var
    i : integer;
  begin
    angle := AngleBetweenLineSegments(x1, y1, x2, y2, x2, y2, x3, y3);

{    AddToLogFile('originalPointNum:' + IntToStr(originalPointNum) + CRLF +
      'x1:' + FloatToStrF(x1, ffFixed, 15, 2) + ' ' +
      'y1:' + FloatToStrF(y1, ffFixed, 15, 2) + CRLF +
      'x2:' + FloatToStrF(x2, ffFixed, 15, 2) + ' ' +
      'y2:' + FloatToStrF(y2, ffFixed, 15, 2) + CRLF +
      'x3:' + FloatToStrF(x3, ffFixed, 15, 2) + ' ' +
      'y3:' + FloatToStrF(y3, ffFixed, 15, 2));}

    GetOffsetSegment(x2, y2, x3, y3, x3Offset, y3Offset, x4Offset, y4Offset);

{    AddToLogFile('OffsetSegments' + CRLF +
      'x1Offset:' + FloatToStrF(x1Offset, ffFixed, 15, 2) + ' ' +
      'y1Offset:' + FloatToStrF(y1Offset, ffFixed, 15, 2) + CRLF +
      'x2Offset:' + FloatToStrF(x2Offset, ffFixed, 15, 2) + ' ' +
      'y2Offset:' + FloatToStrF(y2Offset, ffFixed, 15, 2) + CRLF +
      'x3Offset:' + FloatToStrF(x3Offset, ffFixed, 15, 2) + ' ' +
      'y3Offset:' + FloatToStrF(y3Offset, ffFixed, 15, 2) + CRLF +
      'x4Offset:' + FloatToStrF(x4Offset, ffFixed, 15, 2) + ' ' +
      'y4Offset:' + FloatToStrF(y4Offset, ffFixed, 15, 2));}

    DetermineIntersection(x1Offset, y1Offset, x2Offset, y2Offset,
      x3Offset, y3Offset, x4Offset, y4Offset, xBuffer, yBuffer);

//      if BufferPointIsOnSegment(x1, x2, xBuffer) then
//      begin
//  Akt. bufferpunkt ligger på något av offsetsegment1
//  Spara i bufferpolygon
      bufferCoords[numBufferPoints].x := xBuffer;
      bufferCoords[numBufferPoints].y := yBuffer;
      numBufferPoints := numBufferPoints + 1;
{    AddToLogFile('numBufferPoints:' + IntToStr(numBufferPoints) + CRLF +
      'xBuffer:' + FloatToStrF(xBuffer, ffFixed, 15, 2) + ' ' +
      'yBuffer:' + FloatToStrF(yBuffer, ffFixed, 15, 2));}

{      end
    else
// Beräkna och spara 10 punkter längs ett cirkelsegment med centrum
// i p2 och radie = akt. bufferavstånd i bufferpolygon
      CalculateAndSaveArcBetweenOffsetSegments;}

    if (numBufferPoints >= 3) {and
       (originalPointNum < FNumPoints - 2)} then
    begin
// kolla om den buffrade polygon ev. skär sig själv genom att
// jämföra vinkeln mellan akt. linesegment i den ursprungliga polygonen och
// motsv. vinkel i den buffrade polygonen
// OBS! För att hämta rätt segment måste man
// gå 1 punkter bakåt i den ursprungliga polygonen
      origAngle := originalAngle(originalPointNum);
      angleBetweenBufferSegments := bufferAngle(numBufferPoints - 2);
AddToLogFile('******** ' + CRLF +
  'originalVinkel:' + FloatToStrF(origAngle, ffFixed, 15, 2) + CRLF +
  'bufferVinkel:' + FloatToStrF(angleBetweenBufferSegments, ffFixed, 15, 2) + CRLF +
  '********');
      angleDiff := abs(origAngle - angleBetweenBufferSegments);
      if angleDiff > 0.00000001 then
begin
        Result := false;
AddToLogFile(' ********************* VINKLARNA OLIKA *********************');
end
      else
        Result := true;
    end
    else
      Result := true;
//Result := true;
  end;

  function MakeBuffer : boolean;
  begin
    Result := false;

    SetLength(bufferCoords, (FNumPoints + 5) * SizeOf(doubleXY));
//    bufferList := TList.Create;
    try
      originalPointNum := 0;
      x1 := FXYArray[originalPointNum].x;
      y1 := FXYArray[originalPointNum].y;
      x2 := FXYArray[originalPointNum + 1].x;
      y2 := FXYArray[originalPointNum + 1].y;
      GetOffsetSegment(x1, y1, x2, y2, x1Offset, y1Offset, x2Offset, y2Offset);

      while originalPointNum < FNumPoints - 2 do
      begin
        x3 := FXYArray[originalPointNum + 2].x;
        y3 := FXYArray[originalPointNum + 2].y;

        if not CalculateBufferPoint then Exit;

        x1 := x2;
        y1 := y2;
        x2 := x3;
        y2 := y3;

        GetOffsetSegment(x1, y1, x2, y2, x1Offset, y1Offset, x2Offset, y2Offset);
{        x1Offset := x3Offset;
        y1Offset := y3Offset;
        x2Offset := x4Offset;
        y2Offset := y4Offset;}

        originalPointNum := originalPointNum + 1;
      end;

      if (FShapeType = 5) or (FShapeType = 15) or (FShapeType= 25) then
      begin
// sluten polygon, beräkna även bufferpunkt för originalpolygonens
// sista och 1:sta segment
        i := FNumPoints - 2;
        x1 := FXYArray[i].x;
        y1 := FXYArray[i].y;
        i := i + 1;
        x2 := FXYArray[i].x;
        y2 := FXYArray[i].y;
        i := 1;
        x3 := FXYArray[i].x;
        y3 := FXYArray[i].y;

        GetOffsetSegment(x1, y1, x2, y2, x1Offset, y1Offset, x2Offset, y2Offset);
{  temp :=
      'beräkna även bufferpunkt för originalpolygonens sista och 1:sta segment';
  AddToLogFile(temp);}
        if not CalculateBufferPoint then Exit;

// slut även bufferpolygonen genom att sätta 1:sta och sista punkt lika
      bufferCoords[numBufferPoints].x := bufferCoords[0].x;
      bufferCoords[numBufferPoints].y := bufferCoords[0].y;
      numBufferPoints := numBufferPoints + 1;

{  temp :=
      'Alla bufferpunkter ********************************';
  AddToLogFile(temp);
i := 0;
while i < numBufferPoints do
begin
  temp :=
      'bufferCoord' + IntToStr(i) +
        'x:' + FloatToStrF(bufferCoords[i].x , ffFixed, 15, 2) + ' ' +
        'y:' + FloatToStrF(bufferCoords[i].y , ffFixed, 15, 2);
  AddToLogFile(temp);
  
  i := i + 1;
end;}

// då bufferpunkter för alla originalpolygonens punkter beräknats har inte
// vinkelberäkning och jämförelse kunnat ske för vinklarna mellan
//   näst sista och sista segmentet i bufferpolygonen
      origAngle := originalAngle(0);
      angleBetweenBufferSegments := bufferAngle(numBufferPoints - 2);
AddToLogFile('******** näst sista och sista segmentet' + CRLF +
  'originalVinkel:' + FloatToStrF(origAngle, ffFixed, 15, 2) + CRLF +
  'bufferVinkel:' + FloatToStrF(angleBetweenBufferSegments, ffFixed, 15, 2) + CRLF +
  '********');
        angleDiff := abs(origAngle - angleBetweenBufferSegments);
        if angleDiff > 0.00000001 then
        begin
          Result := false;
          Exit;
        end;
//   sista och första segmentet i bufferpolygonen
      origAngle := originalAngle(1);
      angleBetweenBufferSegments := bufferAngle(0);
AddToLogFile('******** sista och första segmentet' + CRLF +
  'originalVinkel:' + FloatToStrF(origAngle, ffFixed, 15, 2) + CRLF +
  'bufferVinkel:' + FloatToStrF(angleBetweenBufferSegments, ffFixed, 15, 2) + CRLF +
  '********');
        angleDiff := abs(origAngle - angleBetweenBufferSegments);
        if angleDiff > 0.00000001 then
        begin
          Result := false;
          Exit;
        end;
      end;

// spara buffrad shape som ny shape
      ShapeObj.AddPolygonPolylineShape;

// spara bufferpunkter
      i := 0;
      while i < numBufferPoints do
      begin
        ShapeObj.Add(bufferCoords[i].x, bufferCoords[i].y, 0, 0);

        i := i + 1;
      end;
{      while i < bufferList.Count do
      begin
        xyPoint := bufferList.Items[i];
        ShapeObj.Add(xyPoint^.x, xyPoint^.y, 0, 0);

        i := i + 1;
      end;}

      Result := true;
    finally
// rensa bort temporära punkter
{      i := FNumPoints - 4;
      while i >= 0 do
      begin
        bufferPoint := bufferCoords[i];
        Dispose(bufferPoint^);

        i := i - 1;
      end;}
      bufferCoords := nil;
{      i := bufferList.Count - 1;
      while i >= 0 do
      begin
        xyPoint := bufferList.Items[i];
        Dispose(xyPoint);
        bufferList.Delete(i);

        i := i - 1;
      end;
      FreeAndNil(bufferList);}
    end;
  end;

begin
{
  Akt. shape får endast innehålla EN polygon/polyline
  Resultatet sparas som shape nr 2(index 1) i shapefilen

  Ta 3 punkter(p1, p2 och p3) i akt. polygon/polyline i taget
  Gör 2 offsetsegement mellan p1-p2 och p2-p3
  Beräkna skärningspunkten psk mellan offsetsegmenten
  Om psk ligger på något av offsetsegmenten
    Spara psk som en punkt i bufferpolygon
  Annars
    Beräkna och spara 10 punkter längs ett cirkelsegment med centrum
    i p2 och radie = akt. bufferavstånd i bufferpolygon
  Upprepa för alla punkter i akt. polygon/polyline
}

  Result := 'Utnyttja iställer clipper.pas av Angus Johnson';
  Exit;
  
  if FNumEntities > 1 then
  begin
    Result := 'Buffring sker endast av shape med EN polygon/polyline';
    Exit;
  end;

  FActive := true;
  ReadShape(0);

  if FNumPoints < 3 then
  begin
    Result := 'Minst 3 punkter måste finnas för buffring';
    Exit;
  end;

  if (UpperCase(Mode) <> 'IN') and
     (UpperCase(Mode) <> 'OUT') and
     (UpperCase(Mode) <> 'BOTH') then
  begin
    Result := 'Tillåtna värden på parametern Mode är "in", "out" och "both"';
    Exit;
  end;

  try
    t := Width;
  except
    on E: Exception do
    begin
      Result := 'Fel i parametern Width:' + E.Message;
      Exit;
    end;
  end;

  numBufferPoints := 0;
  
  ShapeObj := TShapeObj.Create(nil);
  try
// radera ev. "gammal" buffrad shapefil
    Result := ShapeObj.DeleteShapeFile(FShapeFileName + '_Buffer_' + UpperCase(Mode));
    if Result <> 'Done' then
    begin
      Result := 'kunde inte radera "gammal" buffrad shapefil(används ev.)';
      Exit;
    end;

    Result := 'OK';

    ShapeObj.CreateShapeFile(FShapeFileName + '_Buffer_' + UpperCase(Mode), FShapeType);
    ShapeObj.Open(FShapeFileName + '_Buffer_' + UpperCase(Mode), 'rw');
    
    if UpperCase(Mode) = 'BOTH' then
    begin
      direction := 'OUT';
      if not MakeBuffer then
      begin
        Result := 'för stor bufferbredd';
        Exit;
      end;

      direction := 'IN';
      if not MakeBuffer then
        Result := 'för stor bufferbredd';
    end
    else
    begin
      direction := UpperCase(Mode);
      if not MakeBuffer then
        Result := 'för stor bufferbredd';
    end;

    ShapeObj.Close;
  finally
    if Result <> 'OK' then
// radera misslyckad buffrad shapefil
    ShapeObj.DeleteShapeFile(FShapeFileName + '_Buffer_' + UpperCase(Mode));

    FreeAndNil(ShapeObj);
  end;
end;
{$R+}

function TShapeObj.DetermineIntersectionWithLine(const x1, y1, x2, y2 : extended;
  var shapeNum : integer; var xs, ys: double): boolean;
var
  n : integer;
  x3, y3, x4, y4 : extended;

  function DetermineIntersection(const x1, y1, x2, y2 : extended;
    const x3, y3, x4, y4 : extended; var xs, ys: double): boolean;
  var
    a1, a2, b1, b2, c1, c2 : extended; { Coefficients of line eqns.}
    denom : extended;
  begin
    a1 := y2 - y1;
    b1 := x1 - x2;
    c1 := x2 * y1 - x1 * y2;  { a1*x + b1*y + c1 = 0 is line 1 }

    a2 := y4 - y3;
    b2 := x3 - x4;
    c2 := x4 * y3 - x3 * y4;  { a2*x + b2*y + c2 = 0 is line 2 }

    denom := a1 * b2 - a2 * b1;
    if denom = 0 then
    begin
      Result := false;
      exit;
    end;

    xs := (b1 * c2 - b2 * c1) / denom;
    ys := (a2 * c1 - a1 * c2) / denom;
    Result := true;
  end;

begin
  n := 0;
  Result := true;
end;

{$R-}
function TShapeObj.CalcAreaPerimeter(XYArr: doubleXYArray;
  NumPoints : integer; var Area, Perimeter : double) : boolean;
var
  i : integer;
  slutenPolygon : boolean;
  xd, yd, x, y, x1, y1, x2, y2 : double;
begin
  if (abs(XYArr[NumPoints - 1].x - XYArr[0].x) < 0.001) and
     (abs(XYArr[NumPoints - 1].y - XYArr[0].y) < 0.001) then
    slutenPolygon := true
  else
    slutenPolygon := false;

{
function calcPolygonArea(vertices)
    var total = 0;

    for (var i = 0, l = vertices.length; i < l; i++) {
      var addX = vertices[i].x;
      var addY = vertices[i == vertices.length - 1 ? 0 : i + 1].y;
      var subX = vertices[i == vertices.length - 1 ? 0 : i + 1].x;
      var subY = vertices[i].y;

      total += (addX * addY * 0.5);
      total -= (subX * subY * 0.5);
    }

//    return Math.abs(total);

  Area := FastGeo.Area(TPolygon2D(XYARR));
  Perimeter := FastGeo.Perimeter(TPolygon2D(XYARR));

{  Area :=0.0;
  Perimeter := 0.0;
  for i := 0 to NumPoints - 1 do
  begin
    x1 := XYArr[i].x;
  end;

  for i := 0 to NumPoints - 2 do
  begin
    x1 := XYArr[i].x - FXMin; y1 := XYArr[i].y - FYMin;
    x2 := XYArr[i + 1].x - FXMin; y2 := XYArr[i + 1].y - FYMin;
    xd := abs(x2 - x1); yd := abs(y2 - y1);

    Perimeter := Perimeter + sqrt(xd * xd + yd * yd);

    if (slutenPolygon)} {and (ShapeType = 'Area')} {then
    begin
      if abs(XYArr[i + 1].x - XYArr[i].x) > 0.001 then
      begin
        x := XYArr[i].x - FXMin; y := XYArr[i].y - FYMin;
        Area := Area + y * xd + xd * yd / 2;
      end;
    end;
  end;

  if NumPoints < 3 then
    Area := 0.0
  else
    Area := abs(Area);}

  Result:=true;
end;

function TShapeObj.ChangeProjection(DesiredProjection: string): string;
var
  WGS84 : TWGS84;
  d2In, d2UT : double2Array;
  n, n1, n2, shapeNum, partNum, numPoints : integer;
  xIn, yIn, z, m, xUt, yUt, h : double;
  shapeProjectionObj : TShapeObj;
  currentProjection, shapeName, temp : string;
begin
  Result := '';

  if (DesiredProjection <> 'RT90') and
     (DesiredProjection <> 'SWEREF 99 TM') and
     (DesiredProjection <> 'WGS84') then
  begin
    Result := 'Möjliga projektioner är: RT90, SWEREF 99 TM och WGS84';
    Exit;
  end;

  // bestäm akt. projektion
  ReadShape(0);
  ReadShapePart(0);
  xIn := FPartXYArray[0].x;
  yIn := FPartXYArray[0].y;
  if (xIn >= 0) and (xIn <= 360) and
     (yIn >= -90) and (yIn <= 90) then
    currentProjection := 'WGS84'
  else if (Length(IntToStr(Round(xIn))) = 6) and
          (Length(IntToStr(Round(yIn))) = 7) then
    currentProjection := 'SWEREF 99 TM'
  else
    currentProjection := 'RT90';

  if DesiredProjection = currentProjection then
  begin
    Result := 'Akt. projektion är redan: ' + DesiredProjection;
    Exit;
  end;

  shapeName := ExtractFileName(FShapeFileName) + '_' + DesiredProjection;
  if not InputQuery('', 'Ange namn för shapefil med ändrad projektion',
    shapeName) then Exit;
  shapeName := ExtractFilePath(FShapeFileName) + shapeName;
  if Exists(shapeName) then
  begin
    temp := 'OK';
    if not InputQuery('', ExtractFileName(shapeName) + ' finns redan' +
      lineEnding + 'OK annat skriva över', temp) or (temp <> 'OK') then
    begin
      Result := '';
      Exit;
    end
    else
    begin
      temp := FShapeFileName;
      DeleteShapeFile(shapeName);
      Open(temp, 'rw');
    end;
  end;

  shapeProjectionObj := TShapeObj.Create(nil);
  WGS84 := TWGS84.Create;
  try
    // skapa och öppna shapefil i önskad projektion
    shapeProjectionObj.CreateShapeFile(shapeName, FShapeType);
    shapeProjectionObj.Open(shapeName, 'rw');

    if FProgressBar <> nil  then
    begin
      FProgressBar.Max := FNumEntities;
      FProgressBar.Min := 0;
      FProgressBar.Position := 0;
    end;

    if FStatusBar <> nil then
      FStatusBar.SimpleText := 'Ändrar projektion till: ' + DesiredProjection;

    shapeNum := 0;
    while shapeNum < FNumEntities do
    begin
      if (FShapeType = 3) or (FShapeType = 5) or
         (FShapeType = 13) or (FShapeType = 15) or
         (FShapeType = 23) or (FShapeType = 25) then
        shapeProjectionObj.AddPolygonPolylineShape;

      if FProgressBar <> nil  then
        FProgressBar.Position := FProgressBar.Position + 1;

      ReadShape(shapeNum);
      partNum := 0;
      while partNum < FNumParts do
      begin
        if (partNum > 0) and
           ((FShapeType = 3) or (FShapeType = 5) or
           (FShapeType = 13) or (FShapeType = 15) or
           (FShapeType = 23) or (FShapeType = 25)) then
          shapeProjectionObj.AddPolyGonPolylinePart;

        ReadShapePart(partNum);

        if FNumParts = 1 then
        begin
          n1 := 0;
          n2 := FNumPoints;
        end
        else
        begin
          n1 := FParts[partNum];
          n2 := FParts[partNum + 1] - n1;
        end;

        n := n1;
        while n < n2 do
        begin
          xIn := FPartXYArray[n].x;
          yIn := FPartXYArray[n].y;
          if (FShapeType = 13) or (FShapeType = 15) then
            z := FZArray[n]
          else
            z := 0;
          if (FShapeType = 23) or (FShapeType = 25) then
            m := FMArray[n]
          else
            m := 0;

          if DesiredProjection = 'RT90' then
          begin
            if currentProjection = 'WGS84' then
              WGS84.WGS84ToSWEREF99(yIn, xIn, 0, yIn, xIn);
            WGS84.SWEREF99ToRT90(yIn, xIn, yUt, xUt)
          end
          else if DesiredProjection = 'SWEREF 99 TM' then
          begin
            if currentProjection = 'RT90' then
              WGS84.RT90ToSWEREF99(yIn, xIn, yUt, xUt)
            else
              WGS84.WGS84ToSWEREF99(yIn, xIn, 0, yUt, xUt);
          end
          else
          begin
            if currentProjection = 'RT90' then
              WGS84.RT90ToSWEREF99(yIn, xIn, yIn, xIn);
            WGS84.SWEREF99ToWGS84(yIn, xIn, yUt, xUt, h);
          end;

          shapeProjectionObj.Add(xUt, yUt, z, m);

          Inc(n);
        end;
        shapeProjectionObj.CloseCurrentShapePart;

        Inc(partNum);
      end;
      shapeProjectionObj.ClosePolygonPolylineShape;

      Inc(shapeNum);
    end;
    shapeProjectionObj.Close;

    Result := 'OK';
  finally
    if FProgressBar <> nil  then
      FProgressBar.Position := 0;

    if FStatusBar <> nil then
      FStatusBar.SimpleText := '';

    FreeAndNil(WGS84);
    FreeAndNil(shapeProjectionObj);
  end;
end;

function TShapeObj.ChangeShapeDirection(shapeNum: integer): boolean;
var
  n, p : integer;
  XYArray : doubleXYArray;
  ZArray : doubleArray;
  MArray : doubleArray;
  parts : integerArray;
  shapefileName, mode : string;
begin
  Result := false;

  if (FShapeType = 0) or (FShapeType = 1) or
     (FShapeType = 8) or (FShapeType = 11) or
     (FShapeType = 18) or (FShapeType = 21) or
     (FShapeType = 28) or (FShapeType = 31)  then Exit;
  if not ReadShape(shapeNum) then Exit;

  try
    SetLength(parts, Length(FParts));
    parts[0] := 0;
    for n := 1 to NumParts - 1 do
      parts[n] := FNumPoints - FParts[NumParts - n];
    SetLength(XYArray, Length(FXYArray));
    if (FShapeType = 13) or (FShapeType = 15) then
      SetLength(ZArray, Length(FZArray));
    if (FShapeType = 23) or (FShapeType = 25) then
      SetLength(ZArray, Length(FZArray));

    for n := 0 to FNumPoints - 1 do
    begin
      XYArray[FNumPoints - 1 - n].x := FXYArray[n].x;
      XYArray[FNumPoints - 1 - n].y := FXYArray[n].y;
      if (FShapeType = 13) or (FShapeType = 15) then
        ZArray[FNumPoints - 1 - n] := FZArray[n];
      if (FShapeType = 23) or (FShapeType = 25) then
        MArray[FNumPoints - 1 - n] := MArray[n];
    end;

    FShapeFile.Position := FIndexRecordsArray[shapeNum].Offset + 52;
    n := FShapeFile.Position;
    FShapeFile.Write(parts[0], (SizeOf(integer)) * FNumParts);
    FShapeFile.Write(XYArray[0], (SizeOf(doubleXY)) * FNumPoints);
    if (FShapeType = 13) or (FShapeType = 15) then
    begin
      FShapeFile.Position := FShapeFile.Position + 16;
      FShapeFile.Write(ZArray[0], (SizeOf(double)) * FNumPoints);
    end;
    if (FShapeType = 23) or (FShapeType = 25) then
    begin
      FShapeFile.Position := FShapeFile.Position + 16;
      FShapeFile.Write(MArray[0], (SizeOf(double)) * FNumPoints);
    end;

    shapefileName := FShapeFileName;
    mode := FMode;
    FreeAndNil(FShapeFile);
    FreeAndNil(FIndexFile);
    FActive := false;
    Open(shapefileName, mode);
finally
    XYArray := nil;
    ZArray := nil;
    MArray := nil;
    parts := nil;
  end;
end;

{$R+}

function TShapeObj.CalcAreaPerimeterAttributes : string;
var
  i : integer;
  Area, Perimeter : double;
begin
  Result := 'Failed';
  if (not FActive) or
     ((FShapeType <> 5) and (FShapeType <> 15) and
      (FShapeType <> 25))then Exit;

  AddField('Area', ftFloat, 10, false);
  AddField('Perimeter', ftFloat, 10, false);

  i := 0;
  while i < FNumEntities do
  begin
    ReadShape(i);

    CalcAreaPerimeter(FXYArray, FNumPoints, Area, Perimeter);
    FDbf.First;
    FDbf.MoveBy(i);
    FDbf.Edit;
    FDbf.UpdateRecord;
    FDbf.FieldByName('Area').AsFloat := Area;
    FDbf.FieldByName('Perimeter').AsFloat := Perimeter;
    FDbf.Post;

    Inc(i);
  end;
end;

procedure TShapeObj.SetArea(const Value: double);
begin
  FArea := Value;
end;

procedure TShapeObj.SetPerimeter(const Value: double);
begin
  FPerimeter := Value;
end;

{$R-}
procedure TShapeObj.ExportAsTextFile(ShapeFileName, Filename: string;
  shapeNum: integer; Progressbar : TProgressbar;
  StatusBar : TStatusBar);
var
  SaveDialog : TSaveDialog;
  i : integer;
  FileStream : TFileStream;
  zFinns, mFinns : boolean;
  temp, typ : string;

  procedure ExportShape(n : integer);
  var
    part : integer;
    x, y, z, m, area, perimeter : double;
//    temp, typ : string;

    procedure WritePoints;
    var
      i : integer;
    begin
      temp := '      Numpoints:' +  IntToStr(FNumPoints) + CRLF;
      FileStream.Write(temp[1], Length(temp));

      i := 0;
      while i < FNumPoints do
      begin
        temp := '      ' + 
          FloatToStrF(FXYArray[i].x, ffFixed, 15, 4) + ', ' +
          FloatToStrF(FXYArray[i].y, ffFixed, 15, 4);
          if zFinns then
            temp := temp + ', ' + FloatToStrF(FZArray[i], ffFixed, 15, 4);
          if mFinns then
            temp := temp + ', ' + FloatToStrF(FMArray[i], ffFixed, 15, 4);
          temp := temp + lineEnding;
          FileStream.Write(temp[1], Length(temp));

        i := i + 1;
      end;
    end;

  begin
    ReadShape(n);

    if FSingleInstanceShapeType > 0 then
      temp := 'Shape: ' + IntToStr(n) + lineEnding
    else
      temp := 'Shape: ' + IntToStr(n) + ' (marked as deleted)' + lineEnding;
    FileStream.Write(temp[1], Length(temp));
    temp := 'Extent: ' + lineEnding;
    FileStream.Write(temp[1], Length(temp));
    temp := ' XMax: ' + FloatToStrF(FXMax, ffFixed, 15, 4) +
      ' YMax: ' + FloatToStrF(FYMax, ffFixed, 15, 4) + lineEnding;
    FileStream.Write(temp[1], Length(temp));
    temp := ' XMin: ' + FloatToStrF(FXMin, ffFixed, 15, 4) +
      ' YMin: ' + FloatToStrF(FYMin, ffFixed, 15, 4) + lineEnding;
    FileStream.Write(temp[1], Length(temp));
    if zFinns then
    begin
      temp := ' ZMin: ' + FloatToStrF(FZMin, ffFixed, 15, 4) +
        '    ZMax: ' + FloatToStrF(FZMax, ffFixed, 15, 4) + lineEnding;
      FileStream.Write(temp[1], Length(temp));
    end;
    if mFinns then
    begin
      temp := ' MMax: ' + FloatToStrF(FMMax, ffFixed, 15, 4) +
        ' MMin: ' + FloatToStrF(FMMin, ffFixed, 15, 4) + lineEnding;
      FileStream.Write(temp[1], Length(temp));
    end;

    CalcAreaPerimeter(FXYArray, FNumPoints, area, perimeter);
    temp := ' Area: ' + FloatToStrF(area, ffFixed, 15, 2) + lineEnding +
      ' Perimeter: ' + FloatToStrF(perimeter, ffFixed, 15, 2) + lineEnding;
    FileStream.Write(temp[1], Length(temp));

    temp := '   x           y';
    if zFinns then
      temp := temp + '           z';
    if mFinns then
      temp := temp + '           m';

    if (UpperCase(typ) = 'POLYLINE') or
       (UpperCase(typ) = 'POLYGON') or
       (UpperCase(typ) = 'POLYLINEZ') or
       (UpperCase(typ) = 'POLYGONZ') or
       (UpperCase(typ) = 'POLYLINEM') or
       (UpperCase(typ) = 'POLYGONM') then
    begin
      temp := 'Entity-Begin' + CRLF;
      FileStream.Write(temp[1], Length(temp));

      temp := '  Numparts:' +  IntToStr(FNumParts) + CRLF;
      FileStream.Write(temp[1], Length(temp));

      temp := '  Parts-Begin' + CRLF;
      FileStream.Write(temp[1], Length(temp));

      part := 0;
      while part < FNumParts do
      begin
        temp := '    Part-Begin' + CRLF;
        FileStream.Write(temp[1], Length(temp));

        WritePoints;

        temp := '    Part-End' + CRLF;
        FileStream.Write(temp[1], Length(temp));

        part := part + 1;
      end;

      temp := '  Parts-End' + CRLF;
      FileStream.Write(temp[1], Length(temp));

      temp := 'Entity-End' + CRLF;
      FileStream.Write(temp[1], Length(temp));
    end
    else
// Point-Shape
      WritePoints;
  end;

begin
  if not Exists(ShapeFileName) then
  begin
    MessageDlg('Hittar inte ' + ShapeFileName, mtError, [mbOK], 0);
    Exit;
  end;

  if not Active then
    Open(ShapeFileName, 'ro');

  if (shapeNum < -1) or (shapeNum > FNumEntities - 1) then
  begin
    MessageDlg('Angivet ShapeNr(' + IntToStr(shapeNum) + ') finns inte', mtError, [mbOK], 0);
    Exit;
  end;
  
  SaveDialog := TSaveDialog.Create(nil);
  try
    if Filename = '' then
    begin
      SaveDialog.Title := 'Ange namn på exportfil';
      SaveDialog.FileName :=
        ChangeFileExt(FShapeFileDir + ShapeFileName + '.shp', '.txt');
      if not SaveDialog.Execute then Exit;
      Filename := SaveDialog.FileName;
    end;

{    GetShapeFileDir;
    GetShapeFileName;
    Open(FShapeFileName, 'ro');}
//    Open(ShapeFileName, 'ro');

    if (FShapeType = 11) or (FShapeType = 13) or
       (FShapeType = 15) or (FShapeType = 18) then
      zFinns := true
    else
      zFinns := false;

    if (FShapeType = 8) or (FShapeType = 21) or
       (FShapeType = 23) or (FShapeType = 25) or (FShapeType = 28) then
      mFinns := true
    else
      mFinns := false;

    if PosEx('.txt', Filename) <= 0 then
      Filename := Filename + '.txt';
    FileStream := TFileStream.Create(Filename, fmCreate);
    try
      ReadShape(0);

      if ShapeType = 0 then
        typ := 'Markerad som raderad'
      else if ShapeType = 1 then
          typ := 'Point'
      else if ShapeType = 3 then
        typ := 'PolyLine'
      else if ShapeType = 5 then
        typ := 'Polygon'
      else if ShapeType = 8 then
        typ := 'MultiPoint'
      else if ShapeType = 11 then
        typ := 'PointZ'
      else if ShapeType = 13 then
        typ := 'PolyLineZ'
      else if ShapeType = 15 then
        typ := 'PolygonZ'
      else if ShapeType = 18 then
        typ := 'MultiPointZ'
      else if ShapeType = 21 then
        typ := 'PointM'
      else if ShapeType = 23 then
        typ := 'PolyLineM'
      else if ShapeType = 25 then
        typ := 'PolygonM'
      else if ShapeType = 28 then
        typ := 'MultiPointM'
      else if ShapeType = 31 then
        typ := 'MultiPatch';

      temp := 'ShapeType:' + typ + CRLF;

      FileStream.Write(temp[1], Length(temp));

      if shapeNum >= 0 then
        ExportShape(shapeNum)
      else
      begin
        temp := 'TotalExtent: ' + lineEnding;
        FileStream.Write(temp[1], Length(temp));
        temp := ' XMaxTot: ' + FloatToStrF(FXMaxTot, ffFixed, 15, 4) +
          ' YMaxTot: ' + FloatToStrF(FYMaxTot, ffFixed, 15, 4) + lineEnding;
        FileStream.Write(temp[1], Length(temp));
        temp := ' XMinTot: ' + FloatToStrF(FXMinTot, ffFixed, 15, 4) +
          ' YMinTot: ' + FloatToStrF(FYMinTot, ffFixed, 15, 4) + lineEnding;
        FileStream.Write(temp[1], Length(temp));
        if zFinns then
        begin
          temp := ' ZMinTot: ' + FloatToStrF(FZMinTot, ffFixed, 15, 4) +
            '    ZMaxTot: ' + FloatToStrF(FZMaxTot, ffFixed, 15, 4) + lineEnding;
          FileStream.Write(temp[1], Length(temp));
        end;
        if mFinns then
        begin
          temp := ' MMaxTot: ' + FloatToStrF(FMMaxTot, ffFixed, 15, 4) +
            ' MMinTot: ' + FloatToStrF(FMMinTot, ffFixed, 15, 4) + lineEnding;
          FileStream.Write(temp[1], Length(temp));
        end;
        temp := 'NumEntities: ' + IntToStr(FNumEntities) + lineEnding;
        FileStream.Write(temp[1], Length(temp));

        if Progressbar <> nil then
        begin
          Progressbar.Max := FNumEntities;
          Progressbar.Min := 0;
          Progressbar.Position := 0;
        end;
        if StatusBar <> nil then
        begin
          StatusBar.SimpleText := 'Exporterar shapefil till ' +
            ExtractFileName(Filename);
          StatusBar.Refresh;
        end;

        i := 0;
        while i < FNumEntities do
        begin
          ExportShape(i);

          i := i + 1;
          if Progressbar <> nil then
            Progressbar.Position := i;
        end;
      end;
    finally
      FreeAndNil(FileStream);
    end;
  finally
    FreeAndNil(SaveDialog);
    if Progressbar <> nil then
      Progressbar.Position := 0;
    if StatusBar <> nil then
    begin
      StatusBar.SimpleText := '';
      StatusBar.Refresh;
    end;
  end;
end;
{$R+}

{$R-}
procedure TShapeObj.ExportAsXYZMTextFile(ShapeFileName, Filename: string;
  shapeNum: integer; exporteraAlltData : boolean;
  xnv, ynv, xoh, yoh : double; Progressbar : TProgressbar;
  StatusBar : TStatusBar);
var
  SaveDialog : TSaveDialog;
  i, hojdValue : integer;
  FileStream : TFileStream;
  zFinns, mFinns, hojdAttributeExists : boolean;

  function CheckForHojdAttribute : boolean;
  var
    i : integer;
  begin
    Result := true;

    i := 0;
    while i < FDbf.DbfFieldDefs.Count do
    begin
      if UpperCase(FDbf.Fields[i].FieldName) = 'HOJD' then
        Exit;

      Inc(i);
    end;

    Result := false;
  end;

  function GetHojdValue(n : integer) : integer;
  begin
    if n = 0 then
      FDbf.First
    else
      FDbf.MoveBy(1);
    Result := FDbf.FieldByName('hojd').AsInteger;
  end;

  procedure ExportShape(n : integer);
  var
    part : integer;
    x, y, z, m, skrivnaPunkter : double;
    xyzrad, temp, typ : string;

    procedure WritePoints;
    var
      i : integer;
      tempList : TStringList;

      function pointWithinBox : boolean;
      begin
        Result :=
         (xnv <= FXYArray[i].x) and (FXYArray[i].x <= xoh) and
         (ynv <= FXYArray[i].y) and (FXYArray[i].y <= yoh);
      end;

    begin
      tempList := TStringList.Create;
      try
        skrivnaPunkter := 0;
        i := 0;
        while i < FNumPoints do
        begin
          if (ShapeType <> 1) and (ShapeType <> 11) and (ShapeType <> 21) then
          begin
            if (exporteraAlltData) or (not exporteraAlltData) and
               (pointWithinBox) then
            begin
              temp :=
                FloatToStrF(FXYArray[i].x, ffFixed, 15, 4) + '  ' +
                FloatToStrF(FXYArray[i].y, ffFixed, 15, 4);
              if zFinns then
                temp := temp + '  ' + FloatToStrF(FZArray[i], ffFixed, 15, 4);
              if mFinns then
                temp := temp + '  ' + FloatToStrF(FMArray[i], ffFixed, 15, 4);

              if (not zFinns) and (hojdAttributeExists) then
                temp := temp + '  ' + IntToStr(hojdValue);

              temp := temp + CRLF;
              tempList.Add(temp);
              skrivnaPunkter := skrivnaPunkter + 1;
            end;
          end
          else
          begin
            temp :=
            FloatToStrF(FX, ffFixed, 15, 4) + '  ' +
            FloatToStrF(FY, ffFixed, 15, 4);
            if zFinns then
              temp := temp + '  ' + FloatToStrF(FZ, ffFixed, 15, 4);
            if mFinns then
              temp := temp + '  ' + FloatToStrF(FM, ffFixed, 15, 4);

            if (not zFinns) and (hojdAttributeExists) then
              temp := temp + '  ' + IntToStr(hojdValue);

            FileStream.Write(temp[1], Length(temp));
          end;

          i := i + 1;
        end;

        if (ShapeType <> 1) and (ShapeType <> 11) and (ShapeType <> 21) then
        begin
          if skrivnaPunkter > 0 then
            FileStream.Write(xyzrad[1], Length(xyzrad));
          i := 0;
          while i < tempList.Count do
          begin
            temp := tempList.Strings[i];
            FileStream.Write(temp[1], Length(temp));

            Inc(i);
          end;
        end;
      finally
        FreeAndNil(tempList);
      end;
    end;

  begin
    ReadShape(n);
    if hojdAttributeExists then
      hojdValue := GetHojdValue(n);

    if ShapeType = 1 then
      typ := 'Point'
    else if ShapeType = 3 then
      typ := 'PolyLine'
    else if ShapeType = 5 then
      typ := 'Polygon'
    else if ShapeType = 8 then
      typ := 'MultiPoint'
    else if ShapeType = 11 then
      typ := 'PointZ'
    else if ShapeType = 13 then
      typ := 'PolyLineZ'
    else if ShapeType = 15 then
      typ := 'PolygonZ'
    else if ShapeType = 18 then
      typ := 'MultiPointZ'
    else if ShapeType = 21 then
      typ := 'PointM'
    else if ShapeType = 23 then
      typ := 'PolyLineM'
    else if ShapeType = 25 then
      typ := 'PolygonM'
    else if ShapeType = 28 then
      typ := 'MultiPointM'
    else if ShapeType = 31 then
      typ := 'MultiPatch';

    xyzrad := ' X' + '  ' + 'Y';
    if (zFinns) or (hojdAttributeExists) then
      xyzrad := xyzrad + '  ' + 'Z';
    if mFinns then
      xyzrad := xyzrad + '  ' + 'M';
    xyzrad := xyzrad + CRLF;
    if ((ShapeType = 1) or (ShapeType = 11) or (ShapeType = 21)) and
       (n = 0) then
      FileStream.Write(xyzrad[1], Length(xyzrad));
//    else if ((ShapeType <> 1) and (ShapeType <> 11) and (ShapeType <> 21)) then
//      FileStream.Write(temp[1], Length(temp));

    if (UpperCase(typ) = 'POLYLINE') or (UpperCase(typ) = 'POLYLINEZ') or
       (UpperCase(typ) = 'POLYGON') or (UpperCase(typ) = 'POLYGONZ') then
    begin
      part := 0;
      while part < FNumParts do
      begin
        WritePoints;

        part := part + 1;
      end;
    end
    else
// Point-Shape
      WritePoints;
  end;

begin
  if (shapeNum < -1) or (shapeNum > FNumEntities - 1) then
  begin
    MessageDlg('Angivet ShapeNr(' + IntToStr(shapeNum) + ') finns inte', mtError, [mbOK], 0);
    Exit;
  end;
  
  SaveDialog := TSaveDialog.Create(nil);
  try
    if Filename = '' then
    begin
      SaveDialog.Title := 'Ange namn på exportfil';
      SaveDialog.FileName :=
        ChangeFileExt(FShapeFileDir + ShapeFileName + '.shp', '.txt');
      if not SaveDialog.Execute then Exit;
      Filename := SaveDialog.FileName;
    end;

    GetShapeFileDir;
    GetShapeFileName;
{    Open(FShapeFileDir + FShapeFileName, 'ro');}
    Open(ShapeFileName, 'ro');
    // kolla om fält "hojd" finns i till hörande dbf-fil
    hojdAttributeExists := CheckForHojdAttribute;

    if (FShapeType = 11) or (FShapeType = 13) or
       (FShapeType = 15) or (FShapeType = 18) then
      zFinns := true
    else
      zFinns := false;

    if (FShapeType = 8) or (FShapeType = 21) or
       (FShapeType = 23) or (FShapeType = 25) or (FShapeType = 28) then
      mFinns := true
    else
      mFinns := false;

    if PosEx('.txt', Filename) <= 0 then
      Filename := Filename + '.txt';
    FileStream := TFileStream.Create(Filename, fmCreate);

    if Progressbar <> nil then
    begin
      Progressbar.Max := FNumEntities;
      Progressbar.Min := 0;
      Progressbar.Position := 0;
    end;
    if StatusBar <> nil then
    begin
      StatusBar.SimpleText := 'Exporterar shapefil till ' +
        ExtractFileName(Filename);
      StatusBar.Refresh;
    end;

    try
      if shapeNum >= 0 then
        ExportShape(shapeNum)
      else
      begin
        i := 0;
        while i < FNumEntities do
        begin
          ExportShape(i);

          i := i + 1;
          if Progressbar <> nil then
            Progressbar.Position := i;
        end;
      end;
    finally
      FreeAndNil(FileStream);
    end;
  finally
    FreeAndNil(SaveDialog);
    if Progressbar <> nil then
      Progressbar.Position := 0;
    if StatusBar <> nil then
    begin
      StatusBar.SimpleText := '';
      StatusBar.Refresh;
    end;
  end;
end;
{$R+}

procedure TShapeObj.AddToLogFile(const LogMessage : string);
var
  Hour, Min, Sec, MSec : Word;
  Tidpunkt, latestDatumTid, logmsg, LogFileName : string;
  mFile : TextFile;
  tempList, logMessageList : TStringList;
  i : integer;

{  procedure TruncateLogFileIfNecessary;
  var
    newFileStream, oldFileStream : TMemoryStream;
  begin
    if (not FileExists(FLogFileName)) or (FLogFileMaxSize <= 0) then Exit;

    oldFileStream := TMemoryStream.Create;
    oldFileStream.LoadFromFile(FLogFileName);
    try
      if oldFileStream.Size > FLogFileMaxSize then
      begin
        newFileStream := TMemoryStream.Create;
        try
          oldFileStream.Position := oldFileStream.Size - 50000;
          newFileStream.CopyFrom(oldFileStream, 50000);
          newFileStream.SaveToFile(FLogFileName);
        finally
          FreeAndNil(newFileStream);
        end;
      end;
    finally
      FreeAndNil(oldFileStream);
    end;
  end;

  procedure DeleteOldLogFiles;
  var
    sRec : TSearchRec;
    i : integer;
    tid, filename : string;
  begin
    i := FindFirst(ChangeFileExt(FLogFileName, '') + '*.log', faAnyFile, sRec);
    while i = 0 do
    begin
      if abs(DaysBetween(FileDateToDateTime(sRec.Time), Now)) > FMaxLogFileAgeInDays then
        DeleteFile(ExtractFilepath(FLogFileName) + sRec.Name);

      i := FindNext(sRec);
    end;
    FindClose(sRec);
  end;}

begin
//  if not FLogging then Exit;

  try
//    FCriticalSection.Enter;
    try
//      TruncateLogFileIfNecessary;

//      if SmartPos('Startat ver', LogMessage) <> 0 then
//        DeleteOldLogFiles;

      LogFileName := ChangeFileExt(Application.ExeName, '.log');
      if FileExists(LogFileName) { *Converted from FileExists*  } then
        DeleteFile(LogFileName); { *Converted from DeleteFile*  }
//      if FileExistsUTF8(LogFileName) { *Converted from FileExists*  } then
//        DeleteFileUTF8(LogFileName); { *Converted from DeleteFile*  }

      tempList := TStringList.Create;
      try
        if FileExists(LogFileName) { *Converted from FileExists*  } then
//        if FileExistsUTF8(LogFileName) { *Converted from FileExists*  } then
        begin
          tempList.LoadFromFile(LogFileName);
          if tempList.Count > 0 then
          begin
            latestDatumTid := tempList.Strings[tempList.Count - 1];
            latestDatumTid := Copy(latestDatumTid, 1, 10);
          end
          else
            latestDatumTid := DateToStr(Now);//, FFormatSettings);
        end
        else
          latestDatumTid := DateToStr(Now);//, FFormatSettings);
      finally
        FreeAndNil(tempList);
      end;

      AssignFile(mFile, LogFileName);
      try
        if not FileExists(LogFileName) { *Converted from FileExists*  } then
//          if not FileExistsUTF8(LogFileName) { *Converted from FileExists*  } then
          Rewrite(mFile)
        else
        begin
          if latestDatumTid <> DateToStr(Now){, FFormatSettings)} then
          begin
            RenameFile(LogFileName, ChangeFileExt(LogFileName, DateToStr(Now))); { *Converted from RenameFile*  }
//            RenameFileUTF8(LogFileName, ChangeFileExt(LogFileName, DateToStr(Now))); { *Converted from RenameFile*  }
            Rewrite(mFile);

//            DeleteOldLogFiles;
          end
          else if (latestDatumTid = DateToStr(Now){, FFormatSettings}) and
             (PosEx('Startat ver.', LogMessage) <> 0) then
          begin
            RenameFile(LogFileName, ChangeFileExt(LogFileName, DateToStr(Now))); { *Converted from RenameFile*  }
//            RenameFileUTF8(LogFileName, ChangeFileExt(LogFileName, DateToStr(Now))); { *Converted from RenameFile*  }
            Rewrite(mFile);
          end
          else
            Append(mFile);
        end;

        DecodeTime(Now, Hour, Min, Sec, MSec);
        if Hour < 10 then
          Tidpunkt := '0' + IntToStr(Hour) + ':'
        else
          Tidpunkt := IntToStr(Hour) + ':';

        if Min < 10 then
          Tidpunkt := Tidpunkt + '0' + IntToStr(Min) + ':'
        else
          Tidpunkt := Tidpunkt + IntToStr(Min) + ':';

        if Sec < 10 then
          Tidpunkt := Tidpunkt + '0' + IntToStr(Sec) + '.'
        else
          Tidpunkt := Tidpunkt + IntToStr(Sec) + '.';

        if MSec < 10 then
          Tidpunkt := Tidpunkt + '00' + IntToStr(MSec)
        else if MSec < 100 then
          Tidpunkt := Tidpunkt + '0' + IntToStr(MSec)
        else
          Tidpunkt := Tidpunkt + IntToStr(MSec);

        logMessageList := TStringList.Create;
        try
          logMessageList.Text := LogMessage;
          i := 0;
          while i < logMessageList.Count do
          begin
            logmsg := logMessageList.Strings[i];
            writeln(mFile, DateToStr(Now) + ' ' + Tidpunkt + ' ' + logmsg);
            Flush(mFile);
            i := i + 1;
          end;
        finally
          FreeAndNil(logMessageList);
        end;
      finally
        CloseFile(mFile);
      end;
    finally
//      FCriticalSection.Leave;
    end;
  except
  end;
end;

function TShapeObj.Split(x1, y1, x2, y2: double; ShapeNum : integer): string;
var
  i, part, point, n1, n2 : integer;
  x3, y3, x4, y4, xout, yout, xout1, yout1, xout2, yout2 : double;
  x3segment, y3segment, x4segment, y4segment, xadjust, yadjust : double;
  res : SmallInt;
  SplitObj : TShapeObj;
  shapeFile, currentMode : string;

  procedure MoveIntersectPoint(xout1, yout1 : double; amount : double);
  var
    r, d, v : double;
  begin
    if x3segment = x4segment then
    begin
      if y4segment >= y3segment then
        v := Pi / 2
      else
        v := -Pi / 2;
    end
    else
      v := arctan2((y4segment - y3segment), (x4segment - x3segment));

    r :=
      sqrt((xout1 - x3segment) * (xout1 - x3segment) +
           (yout1 - y3segment) * (yout1 - y3segment)) +
        amount;
    xadjust := x3segment + r * cos(v);
    yadjust := y3segment + r * sin(v);
  end;

begin
  if (FShapeType <> 3) and (FShapeType <> 5) and
     (FShapeType <> 13) and (FShapeType <> 15) and
     (FShapeType <> 23) and (FShapeType <> 25) then
  begin
    Result := 'Endast polygoner och polylines kan splittras';
    Exit;
  end;

  n1 := -1;
  n2 := -1;

  shapeFile := FShapeFileName;
  currentMode := FMode;

  SplitObj := TShapeObj.Create(nil);
  try
    ReadShape(ShapeNum);
    if FSingleInstanceShapeType <> 0 then
    begin
      part := 0;
      while part < FNumParts do
      begin
        ReadShapePart(part);
        point := 0;
        while point < FPartNumPoints - 1 do
        begin
          x3 := FPartXYArray[point].x;
          y3 := FPartXYArray[point].y;

          x4 := PartXYArray[point + 1].x;
          y4 := PartXYArray[point + 1].y;

{          if y4 = 7594773 then
          point := point;}
          if (x3 = x4) and (y3 = y4) then
          begin
            Inc(point);
            Continue;
          end;

          Intersect(x1, y1, x2, y2, x3, y3, x4, y4, xout, yout, res);
          if res = 4 then
          begin;
            if n1 = -1 then
            begin
              n1 := point + 1;
              xout1 := xout;
              yout1 := yout;
              x3segment := x3; y3segment := y3;
              x4segment := x4; y4segment := y4;
            end
            else
            begin
              n2 := point + 1;
              if n2 > n1{ + 1} then
              begin
                xout2 := xout;
                yout2 := yout;
                Break;
              end;
            end;
          end;

          Inc(point);
        end;
        Inc(part);
      end;

      if ((n1 <> -1) and (n2 <> -1) and
          ((FShapeType <> 5) or (FShapeType <> 15) or
           (FShapeType <> 25))) or
         ((n1 <> -1) and
          ((FShapeType <> 3) or (FShapeType <> 13) or
           (FShapeType <> 23))) then
      begin
        // skärning funnen, skapa shape från n1 till n2
        if FileExists(FShapeFileDir + 'split.shp') then
          SplitObj.DeleteShapeFile(FShapeFileDir + 'split');
//        if FileExists(UTF8ToSys(FShapeFileDir + 'split.shp')) then
//          SplitObj.DeleteShapeFile(UTF8ToSys(FShapeFileDir + 'split'));

        if (FShapeType = 5) or (FShapeType = 15) or
           (FShapeType = 25) then
        begin
          if n2 <> -1 then
          begin
            // akt. shape är en polygon
            SplitObj.CreateShapeFile(FShapeFileDir + 'split', 'Polygon');
            SplitObj.Open(FShapeFileDir + 'split', 'rw');
            SplitObj.AddPolygonPolylineShape;
            // skärningspunkt1 = 1:sta punkt
            SplitObj.Add(xout1, yout1, 0, 0);

            point := n1;
            while point < n2 do
            begin
              x3 := PartXYArray[point].x;
              y3 := PartXYArray[point].y;
              SplitObj.Add(x3, y3, 0, 0);

              Inc(point);
            end;

            // lägg tillskärningspunkt2 = sista punkt
            SplitObj.Add(xout2, yout2, 0, 0);
            SplitObj.ClosePolygonPolylineShape;

            // skapa shape från n2 till n1
            SplitObj.AddPolygonPolylineShape;
            // skärningspunkt2 = 1:sta punkt
            SplitObj.Add(xout2, yout2, 0, 0);

            // punkter från n1 till akt. shapes slut
            point := n2;
            while point < FPartNumPoints do
            begin
              x3 := PartXYArray[point].x;
              y3 := PartXYArray[point].y;
              SplitObj.Add(x3, y3, 0, 0);

              Inc(point);
            end;

            // punkter från akt. shapes början till n1
            point := 0;
            while point < n1 do
            begin
              x3 := PartXYArray[point].x;
              y3 := PartXYArray[point].y;
              SplitObj.Add(x3, y3, 0, 0);

              Inc(point);
            end;
            // skärningspunkt1 = sista punkt
            SplitObj.Add(xout1, yout1, 0, 0);
          end;
        end
        else
        begin
          // akt. shape är en polyline
          SplitObj.CreateShapeFile(FShapeFileDir + 'split', 'Polyline');
          SplitObj.Open(FShapeFileDir + 'split', 'rw');
          SplitObj.AddPolygonPolylineShape;

          // lägg till punkter från 0 till n1 - 1
          point := 0;
          while point <= n1 - 1 do
          begin
            x3 := PartXYArray[point].x;
            y3 := PartXYArray[point].y;
            SplitObj.Add(x3, y3, 0, 0);

            Inc(point);
          end;
          // lägg till skärningspunkt minskad med 0.1 i
          // riktning x3, y3, x4, y4.
          // Detta för att säkert separera de splittade delarna
          // något lite från varandra
          MoveIntersectPoint(xout1, yout1, -FSplitAdjustDistance);
          SplitObj.Add(xadjust, yadjust, 0, 0);

          SplitObj.ClosePolygonPolylineShape;

          // skapa shape från n1 till akt. shapes slut
          SplitObj.AddPolygonPolylineShape;

          // lägg till skärningspunkt ökad med 0.1 i
          // riktning x3, y3, x4, y4
          MoveIntersectPoint(xout1, yout1, FSplitAdjustDistance);
          SplitObj.Add(xadjust, yadjust, 0, 0);
          // lägg till punkter från n1 till akt. shapes slut
          point := n1;
          while point < FPartNumPoints do
          begin
            x3 := PartXYArray[point].x;
            y3 := PartXYArray[point].y;
            SplitObj.Add(x3, y3, 0, 0);

            Inc(point);
          end;
        end;

        SplitObj.ClosePolygonPolylineShape;
        SplitObj.Close;

        SplitObj.Open(FShapeFileDir + 'split', 'ro');

        // lägg de 2 skapade shapes till FShapeObj
        Close;
        // öppna i rw-mode
        Open(shapeFile, 'rw');
        i := 0;
        while i <= 1 do
        begin
          SplitObj.ReadShape(i);
          if (SplitObj.NumPoints > 0) and
             (SplitObj.SingleInstanceShapeType <> 0) then
          begin
            AddPolygonPolylineShape;

            part := 0;
            while part < SplitObj.NumParts do
            begin
              SplitObj.ReadShapePart(part);
              point := 0;
              while point < SplitObj.PartNumPoints do
              begin
                x1 := SplitObj.PartXYArray[point].x;
                y1 := SplitObj.PartXYArray[point].y;
                Add(x1, y1, 0, 0);

                Inc(point);
              end;
              Inc(part);
            end;

            ClosePolygonPolylineShape;
          end;

          Inc(i);
        end;

        // radera den osplittade shape:n
        DeleteShape(ShapeNum);

        Close;
        Open(shapeFile, currentMode);
      end;
    end;

    Result := 'OK';
  finally
    SplitObj.Close;
    SplitObj.DeleteShapeFile(FShapeFileDir + 'split');
    FreeAndNil(SplitObj);
  end;
end;

function TShapeObj.Split(ShapeNum: integer; splitShape: TShapeObj;
  splitShapeNum: integer): string;
var
  i, n, n1, n2, riktning : integer;
  n1x, n1y, n2x, n2y : double;
  res : SmallInt;
  xStart, yStart, xEnd, yEnd, z : double;
  x1, y1, z1, m1, x2, y2, z2, m2 :double;
  x3, y3, z3, m3, x4, y4, z4, m4 : double;
  splitStartX1, splitStartY1, splitStartX2, splitStartY2 : double;
  splitEndX1, splitEndY1, splitEndX2, splitEndY2 : double;
  xsk1, ysk1, xsk2, ysk2 : double;
  linesegment1, linesegment2 : integer; // linesegment där skärning sker
  n_prevx, n_prevy, n_prevz, n_prevm : double;
  n_nextx, n_nexty, n_nextz, n_nextm : double;
  SplitObj : TShapeObj;

  procedure GetCoordinatesForSplitShapeStartAndEndLinesegments;
  begin
    splitStartX2 := splitShape.XYArray[0].x;
    splitStartY2 := splitShape.XYArray[0].y;
    // beräkna koordinater för linesegment i början av splitshape
    splitStartX1 := -100000000; splitStartY1 := -100000000;
    i := 1;
    repeat
      splitStartX1 := splitShape.XYArray[i].x;
      splitStartY1 := splitShape.XYArray[i].y;

      Inc(i); // peka på nästföljande punkt osv.
    until (splitStartX1 <> splitStartX2) or
          (splitStartY1 <> splitStartY2);

  //  z1 := splitShape.ZArray[0];
    splitEndX2 := splitShape.XYArray[splitShape.NumPoints - 1].x;
    splitEndY2 := splitShape.XYArray[splitShape.NumPoints - 1].y;
    // beräkna koordinater för linesegment i slutet av splitshape
  //  DetermineLinesegmentCoordinatesInSplitShape(
    splitEndX1 := -100000000; splitEndY1 := -100000000;
    i := splitShape.NumPoints - 2;
    repeat
      splitEndX1 := splitShape.XYArray[i].x;
      splitEndY1 := splitShape.XYArray[i].y;

      Dec(i); // peka på föregående punkt osv.
    until (splitEndX1 <> splitEndX2) or (splitEndY1 <> splitEndY2);
  end;

  procedure DeterminePossibleIntersectLinesegmentCoordinates(n : integer;
    splitx, splity : double);
  var
    i : integer;
    nx, ny, nz, nm : double;
  begin
    // Skärning kan ske med ett linesegment i akt. shape före eller
    // efter akt. närmaste punkt
    //         tre olika fall kan uppstå
    // om föregående eller nästföljande punkt är den samma som
    // akt. närmaste punkt(alltså en dubbelpunkt) sökes avvikande
    // punkter bakåt resp. framåt
    nx := FXYArray[n].x; ny := FXYArray[n].y;
    nz := ZArray[n]; nm := MArray[n];
    n_prevx := -100000000; n_prevy := -100000000;
    n_nextx := -100000000; n_nexty := -100000000;
    if n = 0 then
    begin
      //          fall 1
      // n är 1:sta punkt i akt.shape
      // föregående punkt är då sista punkt i akt. shape
      i := FNumPoints - 1;
      repeat
        n_prevx := FXYArray[i].x; n_prevy := FXYArray[i].y;
        n_prevz := ZArray[i];     n_prevm := MArray[i];

        Dec(i); // peka på föregående punkt osv.
      until (n_prevx <> nx) or (n_prevy <> ny);
      // nästföljande punkt är den som följer efter punkt n
      i := n + 1;
      repeat
        n_nextx := FXYArray[i].x; n_nexty := FXYArray[i].y;
        n_nextz := ZArray[i];     n_nextm := MArray[i];

        Inc(i); // peka på nästföljande punkt osv.
      until (n_nextx <> nx) or (n_nexty <> ny);
    end
    else if n = FNumPoints - 1 then
    begin
      //          fall 2
      // n är sista punkt i akt.shape
      // föregående punkt är då näst sista punkt i akt. shape
      i := FNumPoints - 2;
      repeat
        n_prevx := FXYArray[i].x; n_prevy := FXYArray[i].y;
        n_prevz := ZArray[i];     n_prevm := MArray[i];

        Dec(i); // peka på föregående punkt osv.
      until (n_prevx <> nx) or (n_prevy <> ny);
      // nästföljande punkt är 1:sta punkt i akt.shape
      i := 0;
      repeat
        n_nextx := FXYArray[i].x; n_nexty := FXYArray[i].y;
        n_nextz := ZArray[i];     n_nextm := MArray[i];

        Inc(i); // peka på nästföljande punkt osv.
      until (n_nextx <> nx) or (n_nexty <> ny);
    end
    else
    begin
      //          fall 3
      // n är en godtycklig punkt i akt.shape
      // föregående punkt är då precis föregående punkt i akt. shape och
      i := n - 1;
      repeat
        n_prevx := FXYArray[i].x; n_prevy := FXYArray[i].y;
        n_prevz := ZArray[i];     n_prevm := MArray[i];

        Dec(i); // peka på föregående punkt osv.
        if i < 0 then
          // om 1:sta punkt passerats, börja från sista punkt
          i := FNumPoints - 1;
      until (n_prevx <> nx) or (n_prevy <> ny);
      // nästföljande punkt är precis nästföljande punkt i akt.shape
      i := n + 1;
      repeat
        n_nextx := FXYArray[i].x; n_nexty := FXYArray[i].y;
        n_nextz := ZArray[i];     n_nextm := MArray[i];

        Inc(i); // peka på nästföljande punkt osv.
        if i = FNumPoints then
          // om sista punkt passerats, börja från 1:sta punkt
          i := 0;
      until (n_nextx <> nx) or (n_nexty <> ny);
    end;
  end;

  procedure AddPointsFromIntersection1ViaSplitShapeToIntersection2;
  begin
    // inled med skärningspunkt 1
    SplitObj.Add(xsk1, ysk1, 0, 0);

    // lägg till splitShape
    i := 0;
    while i < splitShape.NumPoints do
    begin
      SplitObj.Add(splitShape.XYArray[i].x, splitShape.XYArray[i].y, 0, 0);

      Inc(i);
    end;

    // avsluta med skärningspunkt 2
    SplitObj.Add(xsk2, ysk2, 0, 0);
  end;

  function AddShapePointsUntilFirstPointOrIntersection1IsReached(
    backward : boolean) : integer;
  var
    x, y : double;
  begin
    x := -100000000; y := -100000000;
    i := linesegment2 - 1;
    i := n2;
//    i := n2 - 1;
    while true do
    begin
      x := FXYArray[i].x; y := FXYArray[i].y;

      if (i = linesegment1) or
         ((x = xsk1) and (y = ysk1)) then
      begin
        SplitObj.Add(xsk1, ysk1, 0, 0);
        Break;
      end;

      SplitObj.Add(x, y, 0, 0);

      if backward then
      begin
        Dec(i);
        if i < 0 then
          i := FNumPoints - 1;
      end
      else
      begin
        Inc(i);
        if i = FNumPoints then
          i := 0;
      end;
    end;
    Result := i; // anger om 1:sta punkt eller skärningspunkt 1 nåtts
  end;

  procedure CopySplittedPolygonsToShapefile;
  var
    n, i : integer;
    x, y, z, m : double;
  begin
    SplitObj.Open(FShapeFileDir + 'split.shp', 'ro');
    n := 0;
    while n < SplitObj.NumEntities do
    begin
      AddPolygonPolylineShape;
      SplitObj.ReadShape(n);
      i := 0;
      while i < SplitObj.NumPoints do
      begin
        x := SplitObj.XYArray[i].x;
        y := SplitObj.XYArray[i].y;
        if (ShapeType = 13) or (ShapeType = 15) then
          z := SplitObj.ZArray[i]
        else
          z := 0;
        if (ShapeType = 23) or (ShapeType = 25) then
          m := SplitObj.MArray[i]
        else
          m := 0;

        Add(x, y, z, m);

        Inc(i);
      end;
      ClosePolygonPolylineShape;

      Inc(n);
    end;
  end;

{  procedure AddShapePointsFromFirstPointInShapeToIntersection1;
  var
    x, y : double;
  begin
    x := -100000000; y := -100000000;
    i := 0;
    while true do
    begin
      x := FXYArray[i].x; y := FXYArray[i].y;
      SplitObj.Add(x, y, 0, 0);
      if ((x = xsk1) and (y = ysk1)) or (i = FNumPoints - 1) then
        Break;

      Inc(i);
    end;
  end;

  procedure AddShapePointsFromLastPointInShapeToIntersection1;
  var
    x, y : double;
  begin
    x := -100000000; y := -100000000;
    i := FNumPoints - 1;
    while true do
    begin
      x := FXYArray[i].x; y := FXYArray[i].y;
      SplitObj.Add(x, y, 0, 0);
      if ((x = xsk1) and (y = ysk1)) or (i = 0) then
        Break;

      Dec(i);
    end;
  end;}

begin
  if (FShapeType <> 3) and (FShapeType <> 5) and
     (FShapeType <> 13) and (FShapeType <> 15) and
     (FShapeType <> 23) and (FShapeType <> 25) then
  begin
    Result := 'Endast polygoner och polylines kan splittras';
    Exit;
  end;

  SplitObj := TShapeObj.Create(nil);
  try
    try
      // läs splitShape
      splitShape.ReadShape(splitShapeNum);

      // läs koordinater för linesegment i början och slutet av splitshape
      GetCoordinatesForSplitShapeStartAndEndLinesegments;

      // läs akt. shape som ska splittras
      ReadShape(ShapeNum);

      // hitta de punkter i akt. shape som ligger närmast splitShapes ändpunkter
      n1 := GetClosestShapePoint(splitStartX2, splitStartY2, z1, m1);
      n2 := GetClosestShapePoint(splitEndX2, splitEndY2, z2, m2);

      // läs koordinater i akt. shape som ligger närmast splitShapes ändpunkter
      xStart := FXYArray[n1].x; yStart := FXYArray[n1].y;
      xEnd := FXYArray[n2].x;   yEnd := FXYArray[n2].y;

      // läs koordinater för de 2 linesegment i akt.shape
      // som ligger närmast början på splitShape för att bestämma
      // i vilket segment akt. skärningspunkt ligger
      DeterminePossibleIntersectLinesegmentCoordinates(n1,
        splitStartX2, splitStartY2);
      // bestäm skärningspunkten mellan splitshapes början och akt. shape
      // testa först linesegment före närmaste punkt
      Intersect(xStart, yStart, n_prevx, n_prevy,
        splitStartX1, splitStartY1, splitStartX2, splitStartY2, xsk1, ysk1, res);
      if res = 2 then
      begin
        // linesegment före närmaste punkt utgör skärningssegment
        linesegment1 := n1 - 1;
        n1x := n_prevx;
        n1y := n_prevy;
      end
      else
      begin
        // linesegment efter närmaste punkt utgör skärningssegment
        Intersect(xStart, yStart, n_nextx, n_nexty,
          splitStartX1, splitStartY1, splitStartX2, splitStartY2, xsk1, ysk1, res);
        linesegment1 := n1;
        n1x := n_nextx;
        n1y := n_nexty;
      end;

      // läs koordinater för de 2 linesegment i akt.shape
      // som ligger närmast slutet på splitShape för att bestämma
      // i vilket segment akt. skärningspunkt ligger
      DeterminePossibleIntersectLinesegmentCoordinates(n2,
        splitEndX2, splitEndY2);
      // bestäm skärningspunkten mellan splitshapes slut och akt. shape
      // testa först linesegment före närmaste punkt
      Intersect(xEnd, yEnd, n_prevx, n_prevy,
        splitEndX1, splitEndY1, splitEndX2, splitEndY2, xsk2, ysk2, res);
      if res = 2 then
      begin
        // linesegment före närmaste punkt utgör skärningssegment
        linesegment2 := n2 - 1;
        n2x := n_prevx;
        n2y := n_prevy;
      end
      else
      begin
        // linesegment efter närmaste punkt utgör skärningssegment
        Intersect(xEnd, yEnd, n_nextx, n_nexty,
          splitEndX1, splitEndY1, splitEndX2, splitEndY2, xsk2, ysk2, res);
        linesegment2 := n2;
        n2x := n_nextx;
        n2y := n_nexty;
      end;

      // Generera 2 shapes av den shape som ska splittras
      // radera ev. gammal temporär shapefil för de 2 shapes som
      // skapas vid split
      if FileExists(FShapeFileDir + 'split.shp') then
        SplitObj.DeleteShapeFile(FShapeFileDir + 'split');

      SplitObj.CreateShapeFile(FShapeFileDir + 'split', 'PolylineZ');
//      SplitObj.CreateShapeFile(FShapeFileDir + 'split', FShapeType);
      SplitObj.Open(FShapeFileDir + 'split.shp', 'ex');

      // Generering av shape 1 går till som följer:
      //   skärningspunkt 1 --> n1 -- n2 -->
      //   akt. shape baklänges från Skärningspunkt 2 -->
      //   skärningspunkt 1 eller 1:sta punkt i akt. shape
      // om 1:sta punkt nåtts --> sista punkt  i akt. shape baklänges -->
      //   skärningspunkt 1
      SplitObj.AddPolygonPolylineShape;

      AddPointsFromIntersection1ViaSplitShapeToIntersection2;

      // lägg till punkter från akt. shape i baklängesordning
      // till skärningspunkt 1 nås
      n :=
        AddShapePointsUntilFirstPointOrIntersection1IsReached(true);

      SplitObj.ClosePolygonPolylineShape;

      // Generering av shape 2 går till som följer:
      //   skärningspunkt 1 --> n1 -- n2 -->
      //   akt. shape framlänges från skärningspunkt 2 -->
      //   skärningspunkt 1 eller 1:sta punkt i akt. shape
      // om 1:sta punkt nåtts --> sista punkt  i akt. shape baklänges -->
      //   skärningspunkt 1
      SplitObj.AddPolygonPolylineShape;

      AddPointsFromIntersection1ViaSplitShapeToIntersection2;

      n :=
        AddShapePointsUntilFirstPointOrIntersection1IsReached(false);

      SplitObj.ClosePolygonPolylineShape;
      SplitObj.Close;

      CopySplittedPolygonsToShapefile;
      DeleteShape(ShapeNum);

      Result := 'OK';
    except
      on E: Exception do
        Result := E.Message;
    end;
  finally
    SplitObj.DeleteShapeFile(FShapeFileDir + 'split');
    FreeAndNil(SplitObj);
  end;
end;

function TShapeObj.ShapeIntersect(const x1, y1, x2, y2 : double;
  var shapeNumArray : integerArray; var xyOut : doubleXYArray;
  var distFromX1Y1 : integerArray) : word;
var
  shapeNum, n : word;
  dRect, shapeDRect : TDoubleRect;
  x3, y3, x4, y4, xout, yout, d : double;
  res : SmallInt;
  shapeList, xyOutList, distShapeList : TStringList;
  testarr : array of integer;
  tempList : TStringList;

  procedure QuickSort(var AI: integerArray; ALo, AHi: Integer);
  var
    Lo, Hi, Pivot, T: Integer;
  begin
    Lo := ALo;
    Hi := AHi;
    Pivot := AI[(Lo + Hi) div 2];
    repeat
      while AI[Lo] < Pivot do
        Inc(Lo) ;
      while AI[Hi] > Pivot do
        Dec(Hi) ;
      if Lo <= Hi then
      begin
        T := AI[Lo];
        AI[Lo] := AI[Hi];
        AI[Hi] := T;
        Inc(Lo) ;
        Dec(Hi) ;
      end;
    until Lo > Hi;
    if Hi > ALo then
      QuickSort(AI, ALo, Hi) ;
    if Lo < AHi then
      QuickSort(AI, Lo, AHi) ;
  end;

  procedure SortDistList;
  var
    n, index : integer;
    tempList : TStringList;
    d : string;
  begin
    tempList := TStringList.Create;
    try
      tempList.Text := distShapeList.Text;
      distShapeList.Clear;

      n := 0;
      while n < Length(distFromX1Y1) do
      begin
        d := IntToStr(distFromX1Y1[n]);
        index := tempList.IndexOfName(d);
        if index >= 0 then
          distShapeList.Add(tempList.Strings[index])
        else
          index := index;

        Inc(n);
      end;
    finally
      FreeAndnil(tempList);
    end;
  end;

begin
  Result := 0;

  shapeList := TStringList.Create;
  xyOutList := TStringList.Create;
  distShapeList := TStringList.Create;
  tempList := TStringList.Create;
  try
    SetLength(shapeNumArray, 0);
    SetLength(distFromX1Y1, 0);

    dRect := MakeDoubleRect(x1, y1, x2, y2);
    shapeNum := 0;
    while shapeNum < FNumEntities do
    begin
      ReadShape(shapeNum);
      if (FSingleInstanceShapeType > 0) or (not FDrawNonDeletedShapesOnly) then
      begin
        case FShapeType of
          3, 5, 13, 15, 23, 25 :
          begin
{          if shapeNum = 1067 then
            shapeNum := shapeNum;
            shapeDRect := MakeDoubleRect(FXMin, FYMin, FXMax, FYMax);
            if (not TotallyOutsideDoubleRect(FXMin, FYMin, dRect)) or
               (not TotallyOutsideDoubleRect(FXMax, FYMax, dRect)) then
           if (WithInDoubleRect(x1, y1, shapeDRect)) or
              (WithInDoubleRect(x2, y2, shapeDRect)) then}
            begin
              n := 0;
              while n < FNumPoints - 1 do
              begin
                x3 := FXYArray[n].x; y3 := FXYArray[n].y;
                x4 := FXYArray[n + 1].x; y4 := FXYArray[n + 1].y;
                Intersect(x1,y1,x2,y2,x3,y3,x4,y4, xout, yout, res);
                if res = 4 then
                begin
                  d := sqrt((xout - x1) * (xout - x1) +
                            (yout - y1) * (yout - y1));
                  SetLength(distFromX1Y1, Length(distFromX1Y1) + 1);
                  distFromX1Y1[Length(distFromX1Y1) - 1] := Round(d) * 100;
                  distShapeList.Add(IntToStr(Round(d) * 100) + '=' +
                    IntToStr(shapeNum));
                  Break;
                end;

                Inc(n);
              end;
            end;
          end;
        end;
      end;

      Inc(shapeNum);
    end;

    if distShapeList.Count > 0 then
    begin
{      distShapeList.SaveToFile('distListBefore.txt');

      n := 0;
      while n < Length(distFromX1Y1) do
      begin
        tempList.Add(IntToStr(distFromX1Y1[n]));
        Inc(n);
      end;
      tempList.SaveToFile('distFromX1Y1Before.txt');
      tempList.Clear;}
      QuickSort(distFromX1Y1, 0, Length(distFromX1Y1) - 1);

      SortDistList;
//      distShapeList.SaveToFile('distListAfter.txt');
      SetLength(shapeNumArray, distShapeList.Count);
      n := 0;
      while n < distShapeList.Count do
      begin
//        tempList.Add(IntToStr(distFromX1Y1[n]));
        shapeNumArray[n] := StrToInt(distShapeList.ValueFromIndex[n]);
        Inc(n);
      end;
    end;
//    tempList.SaveToFile('distFromX1Y1After.txt');

    Result := distShapeList.Count;
  finally
  FreeAndNil(shapeList);
  FreeAndNil(xyOutList);
  FreeAndNil(distShapeList);
  FreeAndNil(tempList);
  end;
end;

procedure TShapeObj.Intersect(const x1,y1,x2,y2,x3,y3,x4,y4 : double;
  out xout, yout : double; var res : SmallInt);
var
  k1, k2, temp : double;
  res1, res2 : SmallInt;
begin
{
// parallella linesegment:
     res := 0
// identiska linesegment:
     res := 1
// identiska linesegment i motsatta riktningar:
     res := -1
// korsande linesegment med skärningspunkt inuti segment 1:
     res := 2
// korsande linesegment med skärningspunkt inuti segment 2:
     res := 3
// korsande linesegment med skärningspunkt inuti båda segmenten:
     res := 4
// korsande linesegment med skärningspunkt utanför segmenten:
     res := 5
// division med noll, FEL:
    res := 5-9999;
}
  res := -1;
  res1 := -1;
  res2 := -1;

  // kolla om linesegmenten är identiska
  if (x1 = x3) and (y1 = y3) and (x2 = x4) and (y2 = y4) then
  begin
    // identiska linesegment
    xout := (x1 + x2) / 2;
    yout := (y1 + y2) / 2;
    res := 1;
    Exit;
  end;

  if (x1 = x4) and (y1 = y4) and (x2 = x3) and (y2 = y3) then
  begin
    // identiska linesegment men i motsatta riktningar
    xout := (x1 + x2) / 2;
    yout := (y1 + y2) / 2;
    res := -1;
    Exit;
  end;

  // kolla om linesegmenten är parallella
  if y1 = y2 then
    k1 := 0
  else if x2 = x1 then
  begin
    if y2 > y1 then
      k1 := 1.7E308
    else
      k1 := -1.7E308;
  end
  else
    k1 := (y2 - y1) / (x2 - x1);

  if y3 = y4 then
    k2 := 0
  else if x4 = x3 then
  begin
    if y4 > y3 then
      k2 := 1.7E308
    else
      k2 := -1.7E308;
  end
  else
    k2 := (y4 - y3) / (x4 - x3);

  if k1 = k2 then
  begin
    // parallella linesegment
    res := 0;
    Exit;
  end;

  if ((y4 - y3) * (x2 - x1) - (x4 - x3) * (y2 - y1)) <> 0 then
    temp := ((x4 - x3) * (y1 - y3) - (y4 - y3) * (x1 - x3)) /
            ((y4 - y3) * (x2 - x1) - (x4 - x3) * (y2 - y1))
  else
  begin
    res := -9999;
    Exit;
  end;
  xout := x1 + temp * (x2 - x1);
  yout := y1 + temp * (y2 - y1);

  if (xout >= Min(x1, x2)) and (xout <= Max(x1, x2)) and
     (yout >= Min(y1, y2)) and (yout <= Max(y1, y2)) then
    res1 := 2;

  if (xout >= Min(x3, x4)) and (xout <= Max(x3, x4)) and
     (yout >= Min(y3, y4)) and (yout <= Max(y3, y4)) then
    res2 := 3;

  if (res1 = 2) and (res2 = 3) then
    res := 4
  else if res1 = 2 then
    res := 2
  else if res2 = 3 then
    res := 3
  else
    res := 5;
end;

function TShapeObj.ShapeTypeToDesignation : string;
begin
  if FShapeType = 1 then
    Result := 'POINT'
  else if FShapeType = 3 then
    Result := 'POLYLINE'
  else if FShapeType = 5 then
    Result := 'POLYGON'
  else if FShapeType = 8 then
    Result := 'MULTIPOINT'
  else if FShapeType = 11 then
    Result := 'POINTZ'
  else if FShapeType = 13 then
    Result := 'POLYLINEZ'
  else if FShapeType = 15 then
    Result := 'POLYGONZ'
  else if FShapeType = 18 then
    Result := 'MULTIPOINTZ'
  else if FShapeType = 21 then
    Result := 'POINTM'
  else if FShapeType = 23 then
    Result := 'POLYLINEM'
  else if FShapeType = 25 then
    Result := 'POLYGONM'
  else if FShapeType = 28 then
    Result := 'MULTIPOINTM'
  else if FShapeType = 31 then
    Result := 'MULTIPATCH';
end;

function TShapeObj.AddIntermediatePoints(shapeNum: integer;
  pointDistance : double): integer;
var
  n, nPoints : integer;
  x1, y1, x2, y2 : double;
  x, y, z, m : double;
  shapeObj : TShapeObj;

  procedure CalculateIntemediaryPoints;
  var
    x, y, dist, angle, d, v : double;
  begin
    shapeObj.Add(x1, y1, 0, 0);
    nPoints := 0;
    dist := (x2 - x1) * (x2 - x1) + (y2 - y1) * (y2 - y1);

    if FProgressBar <> nil then
    begin
      x := sqrt(dist);
      nPoints := Round(sqrt(dist) / pointDistance);
      FProgressBar.Max := Round(sqrt(dist) / pointDistance);
      FProgressBar.Min := 0;
      FProgressBar.Position := 0;
    end;

    if dist * dist > pointDistance * pointDistance then
    begin
      if x1 = x2 then
        angle := Pi / 2
      else if y1 = y2 then
        angle := 0
      else
        angle := arctan((y2 - y1) / (x2 - x1));
      if angle = Pi / 2 then
        angle := angle;
      // bestäm akt. kvadrant och justera ev. angle
      if ((angle > 0) and (x2 < x1) and (y2 < y1)) or
         ((angle < 0) and (x2 < x1) and (y2 > y1)) then
         angle := angle + Pi
      else if (angle = Pi / 2) and (y2 < y1) then
        angle := -angle
      else if (angle = 0) and (x2 < x1) then
        angle := angle + Pi;
      v := radtodeg(angle);
      x := x1 + pointDistance * cos(angle);
      y := y1 + pointDistance * sin(angle);
      d := (x - x1) * (x - x1) + (y - y1) * (y - y1);
      while d < dist do
      begin
        shapeObj.Add(x, y, 0, 0);
        Inc(nPoints);
        if (nPoints mod 10 = 0) and (FProgressBar <> nil) then
        begin
          FProgressBar.Position := nPoints;
          FProgressBar.Refresh;
        end;
        x := x + pointDistance * cos(angle);
        y := y + pointDistance * sin(angle);
        d := (x - x1) * (x - x1) + (y - y1) * (y - y1);
      end;
      d := d;
    end;
    if FProgressBar <> nil then
    begin
      FProgressBar.Position := 0;
      FProgressBar.Refresh;
    end;
//    shapeObj.Add(x2, y2, 0, 0);
  end;

begin
  Result := 0;
  if not ReadShape(shapeNum) then Exit;
  if (FShapeType <> 3) and (FShapeType <> 5) and
     (FShapeType <> 13) and (FShapeType <> 15) and
     (FShapeType <> 23) and (FShapeType <> 25) then Exit;
  if FSingleInstanceShapeType = 0 then Exit;

  // skapa temporär shapefil för lagring av förtätad shape
  shapeObj := TShapeObj.Create(nil);
  try
  // radera ev. gammal temporär shape
    shapeObj.DeleteShapefile(FShapeFileDir + 'temp');

    if FStatusBar <> nil then
    begin
      FStatusBar.SimpleText := 'Genererar mellanpunkter';
      FStatusBar.Refresh;
    end;
    shapeObj.CreateShapeFile(
      FShapeFileDir + 'temp', FShapeType);
    shapeObj.Open(FShapeFileDir + 'temp', 'rw');
    shapeObj.AddPolygonPolylineShape;

    n := 0;
    while n < FNumPoints - 1 do
    begin
      if FStatusBar <> nil then
      begin
        FStatusBar.SimpleText :=
          'Genererar mellanpunkter mellan punkt' + IntToStr(n) +
            ' och punkt' + IntToStr(n + 1) +
            '(' + IntToStr(FNumPoints) + ')';
        FStatusBar.Refresh;
      end;

      x1 := FXYArray[n].x; y1 := FXYArray[n].y;
      x2 := FXYArray[n + 1].x; y2 := FXYArray[n + 1].y;
      CalculateIntemediaryPoints;

      Inc(n);
    end;
    shapeObj.ClosePolygonPolylineShape;
    if FStatusBar <> nil then
    begin
      FStatusBar.SimpleText := '';
      FStatusBar.Refresh;
    end;

    // kopiera in förtätad shape
//    shapeObj.FlushShape;
    shapeObj.ReadShape(0);
    AddPolygonPolylineShape;
    n := 0;
    while n < shapeObj.NumPoints do
    begin
      if shapeObj.ZArray <> nil then
        Add(shapeObj.XYArray[n].x, shapeObj.XYArray[n].y, shapeObj.ZArray[n], 0)
      else
        Add(shapeObj.XYArray[n].x, shapeObj.XYArray[n].y, 0, 0);
      Inc(n);
    end;
    ClosePolygonPolylineShape;
    Result := n;

    shapeObj.Close;
    // radera temporär shapefil
    shapeObj.DeleteShapefile(FShapeFileDir + 'temp');
  finally
    FreeAndNil(shapeObj);
  end;

  Self.DeleteShape(shapeNum);
  Self.Compress;
end;

function TShapeObj.SimplifyPolyShape(shapeNum: integer;
  maxReturnedPoints : integer): integer;
var
  n : integer;
  Orig: array of TPointFloat3D;
  Simple: TFloat3DPointAr;
  Tol: TFloat;
begin
  Result := 0;
  if not ReadShape(shapeNum) then Exit;
  if (FShapeType <> 3) and (FShapeType <> 5) and
     (FShapeType <> 13) and (FShapeType <> 15) and
     (FShapeType <> 23) and (FShapeType <> 25) then Exit;
  if FSingleInstanceShapeType = 0 then Exit;

  SetLength(Orig, FNumPoints);
  SetLength(Simple, FNumPoints);
  n := 0;
  while n < FNumPoints do
  begin
    Orig[n].X := FXYArray[n].x;
    Orig[n].Y := FXYArray[n].y;
    if ZArray <> nil then
      Orig[n].Z := ZArray[n];
    if MArray <> nil then
      Orig[n].Z := ZArray[n]
    else
      Orig[n].Z := 0;

    Inc(n);
  end;

  Tol := 50;
  repeat
    Result := DouglasPeucker(Tol, Orig, Simple);
    if Result = 0 then Exit;
    Tol := Tol / 2;
  until Result <= maxReturnedPoints;

  DeleteShape(shapeNum);
  AddPolygonPolylineShape;
  n := 0;
  while n < Result do
  begin
    Add(Simple[n].X, Simple[n].Y, Simple[n].Z, 0);

    Inc(n);
  end;
  ClosePolygonPolylineShape;
  Compress;
end;

function TShapeObj.DouglasPeucker(Tol: TFloat;
  const Orig: array of TPointFloat3D; var Simple: TFloat3DPointAr): integer;

// https://github.com/WouterVanNifterick/delphi-maps/blob/master/source/DelphiMaps.DouglasPeuckers.pas
  function VecMinFloat2D(const A, B: TPointFloat2D): TPointFloat2D;
  // Result = A - B
  begin
    Result.X := A.X - B.X;
    Result.Y := A.Y - B.Y;
  end;

  function VecMinFloat3D(const A, B: TPointFloat3D): TPointFloat3D;
  // Result = A - B
  begin
    Result.X := A.X - B.X;
    Result.Y := A.Y - B.Y;
    Result.Z := A.Z - B.Z;
  end;

  function DotProdFloat2D(const A, B: TPointFloat2D): TFloat;
  // Dotproduct = A * B
  begin
    Result := A.X * B.X + A.Y * B.Y;
  end;

  function DotProdFloat3D(const A, B: TPointFloat3D): TFloat;
  // Dotproduct = A * B
  begin
    Result := A.X * B.X + A.Y * B.Y + A.Z * B.Z;
  end;

  function NormSquaredFloat2D(const A: TPointFloat2D): TFloat;
  // Square of the norm |A|
  begin
    Result := A.X * A.X + A.Y * A.Y;
  end;

  function NormSquaredFloat3D(const A: TPointFloat3D): TFloat;
  // Square of the norm |A|
  begin
    Result := A.X * A.X + A.Y * A.Y + A.Z * A.Z;
  end;

  function DistSquaredFloat2D(const A, B: TPointFloat2D): TFloat;
  // Square of the distance from A to B
  begin
    Result := NormSquaredFloat2D(VecMinFloat2D(A, B));
  end;

  function DistSquaredFloat3D(const A, B: TPointFloat3D): TFloat;
  // Square of the distance from A to B
  begin
    Result := NormSquaredFloat3D(VecMinFloat3D(A, B));
  end;

  procedure SimplifyFloat2D(var Tol2: TFloat; const Orig: array of TPointFloat2D; var Marker: array of boolean; j, k: integer);
  // Simplify polyline in OrigList between j and k. Marker[] will be set to True
  // for each point that must be included
  var
    i, MaxI: integer; // Index at maximum value
    MaxD2: TFloat; // Maximum value squared
    CU, CW, B: TFloat;
    DV2: TFloat;
    P0, P1, PB, U, W: TPointFloat2D;
  begin
    // Is there anything to simplify?
    if k <= j + 1 then
      exit;

    P0 := Orig[j];
    P1 := Orig[k];
    U := VecMinFloat2D(P1, P0); // Segment vector
    CU := DotProdFloat2D(U, U); // Segment length squared
    MaxD2 := 0;
    MaxI := 0;

    // Loop through points and detect the one furthest away
    for i := j + 1 to k - 1 do
    begin
      W := VecMinFloat2D(Orig[i], P0);
      CW := DotProdFloat2D(W, U);

      // Distance of point Orig[i] from segment
      if CW <= 0 then
      begin
        // Before segment
        DV2 := DistSquaredFloat2D(Orig[i], P0)
      end
      else
      begin
        if CW > CU then
        begin
          // Past segment
          DV2 := DistSquaredFloat2D(Orig[i], P1);
        end
        else
        begin
          // Fraction of the segment
          if CU=0 then
            B := 0
          else
            B := CW / CU;
          PB.X := P0.X + B * U.X;
          PB.Y := P0.Y + B * U.Y;
          DV2 := DistSquaredFloat2D(Orig[i], PB);
        end;
      end;

      // test with current max distance squared
      if DV2 > MaxD2 then
      begin
        // Orig[i] is a new max vertex
        MaxI := i;
        MaxD2 := DV2;
      end;
    end;

    // If the furthest point is outside tolerance we must split
    if MaxD2 > Tol2 then
    begin // error is worse than the tolerance
      // split the polyline at the farthest vertex from S
      Marker[MaxI] := True; // mark Orig[maxi] for the simplified polyline

      // recursively simplify the two subpolylines at Orig[maxi]
      SimplifyFloat2D(Tol2, Orig, Marker, j, MaxI); // polyline Orig[j] to Orig[maxi]
      SimplifyFloat2D(Tol2, Orig, Marker, MaxI, k); // polyline Orig[maxi] to Orig[k]
    end;
  end;

  procedure SimplifyFloat3D(var Tol2: TFloat; const Orig: array of TPointFloat3D; var Marker: array of boolean; j, k: integer);
  // Simplify polyline in OrigList between j and k. Marker[] will be set to True
  // for each point that must be included
  var
    i, MaxI: integer; // Index at maximum value
    MaxD2: TFloat; // Maximum value squared
    CU, CW, B: TFloat;
    DV2: TFloat;
    P0, P1, PB, U, W: TPointFloat3D;
  begin
    // Is there anything to simplify?
    if k <= j + 1 then
      exit;

    P0 := Orig[j];
    P1 := Orig[k];
    U := VecMinFloat3D(P1, P0); // Segment vector
    CU := DotProdFloat3D(U, U); // Segment length squared
    MaxD2 := 0;
    MaxI := 0;

    // Loop through points and detect the one furthest away
    for i := j + 1 to k - 1 do
    begin
      W := VecMinFloat3D(Orig[i], P0);
      CW := DotProdFloat3D(W, U);

      // Distance of point Orig[i] from segment
      if CW <= 0 then
      begin
        // Before segment
        DV2 := DistSquaredFloat3D(Orig[i], P0)
      end
      else
      begin
        if CW > CU then
        begin
          // Past segment
          DV2 := DistSquaredFloat3D(Orig[i], P1);
        end
        else
        begin
          // Fraction of the segment
          if CU=0 then
            B := 0
          else
            B := CW / CU;
          PB.X := P0.X + B * U.X;
          PB.Y := P0.Y + B * U.Y;
          PB.Z := P0.Z + B * U.Z;
          DV2 := DistSquaredFloat3D(Orig[i], PB);
        end;
      end;

      // test with current max distance squared
      if DV2 > MaxD2 then
      begin
        // Orig[i] is a new max vertex
        MaxI := i;
        MaxD2 := DV2;
      end;
    end;

    // If the furthest point is outside tolerance we must split
    if MaxD2 > Tol2 then
    begin // error is worse than the tolerance

      // split the polyline at the farthest vertex from S
      Marker[MaxI] := True; // mark Orig[maxi] for the simplified polyline

      // recursively simplify the two subpolylines at Orig[maxi]
      SimplifyFloat3D(Tol2, Orig, Marker, j, MaxI); // polyline Orig[j] to Orig[maxi]
      SimplifyFloat3D(Tol2, Orig, Marker, MaxI, k); // polyline Orig[maxi] to Orig[k]
    end;
  end;

  function VecMinInt2D(const A, B: TPoint): TPoint;
  // Result = A - B
  begin
    Result.X := A.X - B.X;
    Result.Y := A.Y - B.Y;
  end;

  function DotProdInt2D(const A, B: TPoint): TFloat;
  // Dotproduct = A * B
  begin
    Result := A.X * B.X + A.Y * B.Y;
  end;

  function NormSquaredInt2D(const A: TPoint): TFloat;
  // Square of the norm |A|
  begin
    Result := A.X * A.X + A.Y * A.Y;
  end;

  function DistSquaredInt2D(const A, B: TPoint): TFloat;
  // Square of the distance from A to B
  begin
    Result := NormSquaredInt2D(VecMinInt2D(A, B));
  end;

  procedure SimplifyInt2D(var Tol2: TFloat; const Orig: array of TPoint; var Marker: array of boolean; j, k: integer);
  // Simplify polyline in OrigList between j and k. Marker[] will be set to True
  // for each point that must be included
  var
    i, MaxI: integer; // Index at maximum value
    MaxD2: TFloat; // Maximum value squared
    CU, CW, B: TFloat;
    DV2: TFloat;
    p0, p1, pB, U, W: TPoint;
  begin
    // Is there anything to simplify?
    if k <= j + 1 then
      exit;

    p0 := Orig[j];
    p1 := Orig[k];
    U := VecMinInt2D(p1, p0); // Segment vector
    CU := DotProdInt2D(U, U); // Segment length squared
    MaxD2 := 0;
    MaxI := 0;

    // Loop through points and detect the one furthest away
    for i := j + 1 to k - 1 do
    begin
      W := VecMinInt2D(Orig[i], p0);
      CW := DotProdInt2D(W, U);

      // Distance of point Orig[i] from segment
      if CW <= 0 then
      begin
        // Before segment
        DV2 := DistSquaredInt2D(Orig[i], p0)
      end
      else
      begin
        if CW > CU then
        begin
          // Past segment
          DV2 := DistSquaredInt2D(Orig[i], p1);
        end
        else
        begin
          // Fraction of the segment
          if CU=0 then
            B := 0
          else
            B := CW / CU;
          pB.X := round(p0.X + B * U.X);
          pB.Y := round(p0.Y + B * U.Y);
          DV2 := DistSquaredInt2D(Orig[i], pB);
        end;
      end;

      // test with current max distance squared
      if DV2 > MaxD2 then
      begin
        // Orig[i] is a new max vertex
        MaxI := i;
        MaxD2 := DV2;
      end;
    end;

    // If the furthest point is outside tolerance we must split
    if MaxD2 > Tol2 then
    begin // error is worse than the tolerance

      // split the polyline at the farthest vertex from S
      Marker[MaxI] := True; // mark Orig[maxi] for the simplified polyline

      // recursively simplify the two subpolylines at Orig[maxi]
      SimplifyInt2D(Tol2, Orig, Marker, j, MaxI); // polyline Orig[j] to Orig[maxi]
      SimplifyInt2D(Tol2, Orig, Marker, MaxI, k); // polyline Orig[maxi] to Orig[k]

    end;
  end;

  function PolySimplifyFloat2D(Tol: TFloat; const Orig: array of TPointFloat2D; var Simple: TFloat2DPointAr): integer;
  var
    i, N: integer;
    MarkerAr: array of boolean;
    Tol2: TFloat;
  begin
    Result := 0;
    if length(Orig) < 2 then
      exit;
    Tol2 := sqr(Tol);

    // Create a marker array
    N := length(Orig);
    SetLength(MarkerAr, N);
    // Include first and last point
    MarkerAr[0] := True;
    MarkerAr[N - 1] := True;
    // Exclude intermediate for now
    for i := 1 to N - 2 do
      MarkerAr[i] := False;

    // Simplify
    SimplifyFloat2D(Tol2, Orig, MarkerAr, 0, N - 1);

    // prepare output list
    SetLength(Simple, N);
    for i := 0 to N - 1 do
    begin
      if MarkerAr[i] then
      begin
        Simple[Result] := Orig[i];
        inc(Result);
      end;
    end;
    // crop output list
    SetLength(Simple, Result);
  end;

  function PolySimplifyFloat3D(Tol: TFloat; const Orig: array of TPointFloat3D; var Simple: TFloat3DPointAr): integer;
  var
    i, N: integer;
    Marker: array of boolean;
    Tol2: TFloat;
  begin
    Result := 0;
    if length(Orig) < 2 then
      exit;
    Tol2 := sqr(Tol);

    // Create a marker array
    N := length(Orig);
    SetLength(Marker, N);
    // Include first and last point
    Marker[0] := True;
    Marker[N - 1] := True;
    // Exclude intermediate for now
    for i := 1 to N - 2 do
      Marker[i] := False;

    // Simplify
    SimplifyFloat3D(Tol2, Orig, Marker, 0, N - 1);

    // prepare output list
    SetLength(Simple, N);
    for i := 0 to N - 1 do
    begin
      if Marker[i] then
      begin
        Simple[Result] := Orig[i];
        inc(Result);
      end;
    end;
    // crop output list
    SetLength(Simple, Result);
  end;

  function PolySimplifyInt2D(Tol: TFloat; const Orig: array of TPoint; var Simple: TInt2dPointAr): integer;
  var
    i, N: integer;
    Marker: array of boolean;
    Tol2: TFloat;
  begin
    Result := 0;
    if length(Orig) < 2 then
      exit;
    Tol2 := sqr(Tol);

    // Create a marker array
    N := length(Orig);
    SetLength(Marker, N);
    // Include first and last point
    Marker[0] := True;
    Marker[N - 1] := True;
    // Exclude intermediate for now
    for i := 1 to N - 2 do
      Marker[i] := False;

    // Simplify
    SimplifyInt2D(Tol2, Orig, Marker, 0, N - 1);

    // Copy to resulting list

    // prepare output list
    SetLength(Simple, N);
    for i := 0 to N - 1 do
    begin
      if Marker[i] then
      begin
        Simple[Result] := Orig[i];
        inc(Result);
      end;
    end;
    // crop output list
    SetLength(Simple, Result);
  end;

begin

  // reducering av antal punkter i en polygon med DouglasPeuckers-algoritm
  Result := PolySimplifyFloat3D(Tol, Orig, Simple);
end;

function TShapeObj.MakeDoubleRect(const x1,y1,x2,y2 : double) :
  TDoubleRect;
begin
  if x1 <= x2 then
  begin
    Result.xmin := x1;
    Result.xmax := x2;
  end
  else
  begin
    Result.xmax := x1;
    Result.xmin := x2;
  end;

  if y1 <= y2 then
  begin
    Result.ymin := y1;
    Result.ymax := y2;
  end
  else
  begin
    Result.ymax := y1;
    Result.ymin := y2;
  end;
end;

function TShapeObj.WithInDoubleRect(x, y : double; dRect : TDoubleRect) :
  boolean;
begin
  if (x >= dRect.xmin) and (x <= dRect.xmax) and
     (y >= dRect.ymin) and (y <= dRect.ymax) then
    Result := true
  else
    Result := false;
end;

function TShapeObj.TotallyOutsideDoubleRect(x, y: double; dRect: TDoubleRect): boolean;
begin
  if (x < dRect.xmin) or (x > dRect.xmax) or
     (y < dRect.ymin) or (y > dRect.ymax) then
    Result := true
  else
    Result := false;
end;

end.
